﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#include "World.h"
#include <NexDemoUtil/NexUtil.h>

/*!
    @brief 複製オブジェクトが初期化されたときにライブラリから呼び出されます。
 */
void World::InitDO()
{
    NEX_DEMO_LOG("*** World Init DO!!\n");
}

/*!
    @brief 境界を設定する。
 */
void World::SetBoundary(qReal minx, qReal miny, qReal maxx, qReal maxy)
{
    m_dsBoundaries.minX = minx;
    m_dsBoundaries.maxX = maxx;
    m_dsBoundaries.minY = miny;
    m_dsBoundaries.maxY = maxy;
}

/*!
    @brief 境界を取得する。
 */
void World::GetBoundary(qReal& minx, qReal& miny, qReal& maxx, qReal& maxy)
{
    minx = m_dsBoundaries.minX;
    maxx = m_dsBoundaries.maxX;
    miny = m_dsBoundaries.minY;
    maxy = m_dsBoundaries.maxY;
}

/*!
    @brief 物理処理。
 */
void World::DoPhysic()
{
    // 何もしません
}

/*!
    @brief 描画処理。
 */
void World::Render()
{
    NEX_DEMO_LOG("WORLD INFO minx:%f miny:%f maxx:%f maxy:%f\n",
                 m_dsBoundaries.minX, m_dsBoundaries.minY, m_dsBoundaries.maxX, m_dsBoundaries.maxY);
}
