﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
//
//  ワールドを表現するクラス
//
//  プレイヤーが歩きまわる地形のイメージです
//
//  これはセッションマスタにより作成されます
//

#pragma once

#include <nex.h>
#include "WorldDDL.h"

/*!
    @brief 世界を表現するクラス。
 */
class World : public NAMESPACE_NEX DOCLASS(World)
{
public:
    World() {}
    ~World() {}

    void InitDO();

    void SetBoundary(qReal minx, qReal miny, qReal maxx, qReal maxy);
    void GetBoundary(qReal& minx, qReal& miny, qReal& maxx, qReal& maxy);

    void DoPhysic();
    void Render();
};
