﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <demo.h>

// RenderSystem::SetColor(NEXDEMO_RGB(r, g, b)) のように使用する
#define NEXDEMO_RGB(r, g, b) (f32)(r) / 255.0f, (f32)(g) / 255.0f, (f32)(b) / 255.0f

namespace nexdemo
{
namespace Graphics
{
/*!
    @brief 初期化処理を行います。
 */
void Initialize(size_t heapSize = 0x800000);

/*!
    @brief 終了処理を行います。
 */
void Finalize();

/*!
    @brief レンダラを取得します。
 */
demo::RenderSystemDrawing* GetRenderSystem();
}
}
