﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include "demo/ShaderProgram/demo_ProgramObject.h"

namespace demo
{

/*!
    @internal

    @brief フォントを描画するためのシェーダプログラムのクラスです。
*/

class FontProgram : public ProgramObject
{
public:
    /*!
    @internal

    @brief    コンストラクタです。
    */
    FontProgram(void);

    /*!
    @internal

    @brief    デストラクタです。
    */
    virtual ~FontProgram(void);

public:
    /*!
    @internal

    @brief    シェーダプログラムオブジェクトの初期処理を行います。
    */
    virtual bool Initialize(const GLuint shaderId);

    /*!
    @internal

    @brief    シェーダプログラムオブジェクトを使用します。
    */
    virtual bool Finalize(void);

public:
    /*!
    @internal

    @brief    シェーダプログラムオブジェクト使用前のレンダリングステートの設定を行います。
    */
    virtual bool Begin(void);

    /*!
    @internal

    @brief    シェーダプログラムオブジェクトを使用します。
    */
    virtual bool Use(void);

    /*!
    @internal

    @brief    シェーダプログラムオブジェクト使用後のレンダリングステートの設定を行います。
    */
    virtual bool End(void);

protected:
    virtual void InitializeVertexAttributes(void);
    void InitializeFontTexture(void);

protected:
    GLuint m_FontTextureId;
};

}

