﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <nex.h>

namespace nex_demo_util
{

#define DEMO_PAD_BUTTON_LEFT         0x0001
#define DEMO_PAD_BUTTON_RIGHT        0x0002
#define DEMO_PAD_BUTTON_DOWN         0x0004
#define DEMO_PAD_BUTTON_UP           0x0008
#define DEMO_PAD_BUTTON_R            0x0020
#define DEMO_PAD_BUTTON_L            0x0040
#define DEMO_PAD_BUTTON_A            0x0100
#define DEMO_PAD_BUTTON_B            0x0200
#define DEMO_PAD_BUTTON_X            0x0400
#define DEMO_PAD_BUTTON_Y            0x0800

/*!
    @brief キーの状態を保持する構造体です。
 */
struct PadStatus
{
    qUnsignedInt16 hold;
    qUnsignedInt16 trigger;
    qUnsignedInt16 release;
};

/*!
    @brief パッド入力を扱うクラスです。
 */
class DemoPad
{
public:

    /*!
        @brief 初期化処理を行う。
     */
    static void Initialize();

    /*!
        @brief 終了処理を行う。
     */
    static void Finalize();

    /*!
        @brief ボタンの入力を更新する。
     */
    static void Update(PadStatus* pButton);
};

}   // end of namespace nex_demo_util
