﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/DOOperation.h>

BEGIN_NAMESPACE_NEX

//group=Adapters

class DuplicatedObject;

/*
Description: Deprecated. Sets and returns specific information about an Adapter object.
Remarks: This class has been deprecated. See System Operations and information on Duplicated Objects for information on how to
provide an interface between discreet class hierarchies.
This Adapter base class enables information to be transferred between a DuplicatedObject and a target object by means of the Adapter.
The class contains methods that enable extraction of information about the duplicated
object to which this Adapter is associated and if there is a user-defined context associated to the Adapter.

See Also: System Operations, Duplicated Object Overview
*/
// {noAutoLink}
class Adapter: public RootObject
{
    // group=Methods

public:
    Adapter();
    virtual ~Adapter();

    /*
    Description: Deprecated Class.
    Remarks: Returns the duplicated object associated to this Adapter.
    Returns: The duplicated object associated with this Adapter.
    */
    DuplicatedObject* GetAssociatedDO();

    /*
    Description: Deprecated Class.
    Remarks: Sets the UserContext that is to be associated with this Adapter.
    Parameters:
    oContext: A UserContext associated to the adapter.

    See Also: GetUserContext, UserContext
    */
    void SetUserContext(const UserContext &oContext)
    {
        m_oUserContext = oContext;
    }

    /*
    Description: Deprecated Class.
    Remarks: Returns the UserContext associated with this Adapter.
    Returns: The UserContext associated with this Adapter that was set via SetUserContext.
    See Also: SetUserContext, UserContext
    */
    UserContext* GetUserContext()
    {
        return &m_oUserContext;
    }

public:
    /* System API */

    //{secret}
    void AttachAssociatedDO(DuplicatedObject* pAssociatedDO);

private:
    DuplicatedObject*   m_pAssociatedDO;
    UserContext         m_oUserContext;
};

END_NAMESPACE_NEX

