﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Core/Buffer.h>

#ifdef NEX_CLIENT_PBPOOL // クライアントのみ

BEGIN_NAMESPACE_NEX

/*! @internal
 @brief パケット用途のバッファを割り当てるのに使用するクラスです。
        qNew(RootObject::POOL_PB_MANAGEMENT)で確保します。
        メモリ確保失敗をハンドルする必要があります。

 */
class PacketBuffer: public Buffer
{
public:
    PacketBuffer()
        : Buffer(Buffer::GetDefaultBufferSize(), FLAG_PBPOOL)
    {
    }
    explicit PacketBuffer(size_t size)
        : Buffer(size, FLAG_PBPOOL)
    {
    }
    virtual ~PacketBuffer()
    {
    }
};

END_NAMESPACE_NEX

#endif // NEX_CLIENT_PBPOOL

