﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Core/CoreDecl.h>

BEGIN_NAMESPACE_NEX

class OSDK_API VersionInfo: public RootObject
{
private:
    // Never constructed.
    VersionInfo();
    ~VersionInfo();

public:
    static const qChar* GetCopyrightString();
    static qUnsignedInt16 V1();
    static qUnsignedInt16 V2();
    static qUnsignedInt16 V3();
    static qUnsignedInt16 V4();

    // Combine V1 and V2 into uint32
    static qUnsignedInt32 VersionMajor();
    // Combine V3 and V4 into uint32
    static qUnsignedInt32 VersionMinor();

    // Extract FirstNumber from the 32 bit (v1 or v3)
    static qUnsignedInt16 ExtractFirstNumber(qUnsignedInt32 combined);
    // Extract SecondNumber from the 32 bit (v2 or v4)
    static qUnsignedInt16 ExtractSecondNumber(qUnsignedInt32 combined);

    static void Banner(const qChar* description);
};

END_NAMESPACE_NEX


