﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Core/PseudoGlobalVariable.h>

BEGIN_NAMESPACE_NEX

class Message;
class Declaration;
class DynamicInstance;

class OSDK_API DynamicRunTimeInterface: public RootObject
{
public:
    DynamicRunTimeInterface();
    virtual ~DynamicRunTimeInterface();

    static DynamicRunTimeInterface *GetInstance();

    static void RegisterParseTree(qByte* byParseTree, qUnsignedInt32 uiLength);
    virtual void AppendParseTree(Message* pMessage)=0;
    virtual void ExtractParseTree(Message* pMessage)=0;

    virtual DynamicInstance* Instanciate(Declaration *pDeclaration)=0;
    virtual void ReleaseInstance(DynamicInstance* pInstance)=0;

private:

    virtual void RegisterParseTreeImpl(qByte* byParseTree, qUnsignedInt32 uiLength)=0;

private:

    OSDK_DISABLE_EXPORT_WARNING(static PseudoGlobalVariable<DynamicRunTimeInterface*> s_pDynamicRunTimeInterface);
};

END_NAMESPACE_NEX

