﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>
#include <OnlineCore/src/Platform/Core/qVector.h>

BEGIN_NAMESPACE_NEX

class OSDK_API BinaryRepresentation: public RootObject
{
public:
    BinaryRepresentation();
    virtual ~BinaryRepresentation();

    void Rewind();
    qBool EndReached();
    void Clear();

    qBool ErrorFlagIsSet()
    {
        return m_bErrorFlag;
    }
    void ClearErrorFlag()
    {
        m_bErrorFlag=false;
    }
    void SetErrorFlag()
    {
        m_bErrorFlag=true;
    }

    BinaryRepresentation& operator <<(const String& strInput);
    BinaryRepresentation& operator >>(String& strOutput);

    BinaryRepresentation& operator <<(qByte byInput);
    BinaryRepresentation& operator >>(qByte& byOutput);

    BinaryRepresentation& operator <<(qUnsignedInt32 uiInput);
    BinaryRepresentation& operator >>(qUnsignedInt32& uiOutput);

    qBool operator==(const BinaryRepresentation& oOther) const;
    qBool operator!=(const BinaryRepresentation& oOther) const;

    String StreamToString();
    void StreamFromString(const String& strConstruct);
    void StreamFromString(const qChar* szConstruct);

    qVector<qByte>& AccessContent()
    {
        return m_vecContent;
    }

private:
    OSDK_DISABLE_EXPORT_WARNING(qVector<qByte> m_vecContent);
    OSDK_DISABLE_EXPORT_WARNING(qVector<qByte>::iterator m_itReadPos);
    qBool m_bErrorFlag;
};


END_NAMESPACE_NEX

