﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDeclInternal.h>

BEGIN_NAMESPACE_NEX

// Group=Rendez-Vous Core

/*
Description: A unique positive integer used to identify each individual connection made to the lobby.
Remarks: Each connection that a Principal makes with the lobby, /i.e./ each successful log-in, is
identified via a unique ID. Therefore, even if the same Principal maintains several simultaneous
lobby connections, each connection is uniquely identified by its ConnectionID.
*/
//n1589:memo:StationのGetHandleValueがセットされる

typedef qUnsignedInt32 ConnectionID;

enum
{
    /*
     * @brief   ゲームサーバーに対して一意なステーションの識別子です。
     */
    INVALID_CONNECTIONID=0
};

END_NAMESPACE_NEX



