﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef DBG_STACKWALK_SUPPORT

#define GET_CALLER_ADDR( addr ) __asm{\
                                __asm push eax \
                                __asm mov eax, dword ptr[ ebp + 4 ]\
                                __asm mov addr, eax \
                                __asm pop eax \
};

qUnsignedInt32 GetStackWalk( qUnsignedInt32 *pAddrArray, qUnsignedInt32 uiArraySize );

#else // The debug stack walking functions do nothing in shipped distributions.


#define GET_CALLER_ADDR( addr ) {addr = 0;}
inline qUnsignedInt32 GetStackWalk( qUnsignedInt32 * /*pAddrArray*/, qUnsignedInt32 /*uiArraySize*/ )
{
    return 0;
}

#endif // DBG_STACKWALK_SUPPORT

END_NAMESPACE_NEX

