﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#define WAIT_INFINITE_TIMEOUT   0xFFFFFFFF

#define _TANSI(a)               a
#define _TUNICODE(a)            L ## a

#define NEX_SIZEOFARRAY(array) (sizeof(array) / sizeof(array[0]))

#define qMax(a,b)   (((a) > (b)) ? (a) : (b))
#define qMin(a,b)   (((a) < (b)) ? (a) : (b))

#ifdef WIN_FAMILY
#define STDCALL __stdcall
#define __CDECL __cdecl
#else // !WIN_FAMILY
#define STDCALL
#define __CDECL
#ifndef NULL
#define NULL                    0
#endif // !NULL
#endif // WIN_FAMILY


// *** _T definition for non-WIN_FAMILY platforms ***

#ifndef WIN_FAMILY
#ifndef _T

#if defined(NEX_UNICODE_VERSION)
#define __T(a)                  L ## a
#define _T(a)                   __T(a)
#else
#define _T(a)                   a
#endif

#endif // ifndef _T
#endif // ifndef WIN_FAMILY


#if defined(NEX_UNICODE_VERSION)
#define NEX_T_(a)  L ## a
#define NEX_T(a) NEX_T_(a)
#else
#define NEX_T(a) a
#endif

#if defined(_MSC_VER)

#if _MSC_VER < 1900
#define NEX_U16(s) reinterpret_cast<const qChar16*>(L ## s)
#else
#define NEX_U16(s) u ## s
#endif

#elif defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#define NEX_U16(s) L ## s
#else
#if defined(NEX_QCHAR16_IS_NOT_UINT16_T)
#define NEX_U16(s) u ## s
#else
#define NEX_U16(s) reinterpret_cast<const qChar16*>(u ## s)
#endif
#endif // end of defined(_MSC_VER)

#if defined(GCC_COMPILER_FAMILY) || defined(SNC_TARGET_NON_SUPPORT_C) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET) || defined(NEX_NX_TARGET)
#define DUMMY_PARAM(X)         (void)X;
#elif defined(CTR_TARGET)
#define DUMMY_PARAM(X)         ((void)&X);
#else
#define DUMMY_PARAM(X)          (X);
#endif // GCC_COMPILER_FAMILY

#ifdef NEX_SIGLO_FAMILY
#define NEX_INVALID_HANDLE_VALUE    static_cast<nn::os::ThreadType*>(NULL)

#elif defined(WIN_FAMILY)
#define NEX_INVALID_HANDLE_VALUE INVALID_HANDLE_VALUE

#elif defined(UNIX_FAMILY)
#define NEX_INVALID_HANDLE_VALUE    static_cast<pthread_t>(NULL)
#define CALLBACK
#define WINAPI
#define ERROR_SUCCESS           0
#define GetLastOSError()        errno

#elif defined(WII_TARGET) || defined(CAFE_TARGET)
#define NEX_INVALID_HANDLE_VALUE    static_cast<OSThread*>(NULL)

#elif defined(CAFEIOP_TARGET)
#define NEX_INVALID_HANDLE_VALUE    static_cast<IOSThreadId*>(NULL)

#elif defined(CTR_TARGET)
#define NEX_INVALID_HANDLE_VALUE    static_cast<Thread*>(NULL)
#else
#error not supported platform
#endif

#ifdef NEX_SIGLO_FAMILY
#if defined(WIN32_TARGET) && _MSC_VER < 1900
#define NEX_EXIT(x) _exit(x)
#else
#define NEX_EXIT(x) std::quick_exit(x)
#endif
#elif defined(CTR_TARGET)
#define NEX_EXIT( code ) NN_PANIC("Program exit with code=%d", code)
#else
#include <cstdlib>
#define NEX_EXIT(x) ::exit(x)
#endif

#ifdef MW_COMPILER
extern "C" {
    void mwInit();
    void mwExit();
}
#endif

