﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

// This defines the lock ordering, as part of the deadlock detection
// system.

// If two locks are to be aquired together, the one with a lower mask
// must always be acquired first.  This is how deadlocks are prevented.

namespace LockMasks
{

enum LockMasks
{
    //n1589
#if 1
    //n1589:memo:Ignored should not be 0 because CriticalSection::FlagIsSet returns false if flag is 0
    //n1589:memo:if Ignored, LochChecker ignores lock checking
    Ignored = 1 << 0,
    GlobalLock = 1 << 1,
    WorkerSchedulerLock = 1 << 2,

    SystemLock = 1 << 3,

    SchedulerQueue = 1 << 10,
    SQLLock = 1 << 11,
    PythonGIL = 1 << 12,
    SandboxLoadBalancerLock = 1 << 13,

    //n1589:オリジナルバグにより抜けていたロック
    PRUDPEndPointLock = 1 << 14,
    TransportBufferThreadLock = 1 << 15,
    IOCompletionContextTableLock = 1 << 19,

    TransportBufferSetLock = 1 << 20,
    TransportBufferLock = 1 << 21,

    VirtualSocketReceivedMessage = 1 << 22,

    SecondLastLock = 1<<28,
    Default = 1<<29
#else
    Ignored = 0,
    GlobalLock = 1<<1,
    WorkerSchedulerLock = 1<<2,
    SystemLock = 1<<3,
    SchedulerQueue = 1<<4,

    SQLLock = 1<<5,
    PythonGIL = 1<<6,
    SandboxLoadBalancerLock = 1<<7,

    Default = 1<<30
#endif
};

} //namespace LockMasks

END_NAMESPACE_NEX

