﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/LogDevice.h>

BEGIN_NAMESPACE_NEX

//group=Log Devices

/*
Description: This class implements logging to the debug output of an attached debugger.
Remarks: On Windows and NON_SUPPORT_E, forwards the entry to OutputDebugString. Otherwise, use LogDeviceConsole
See Also: LogDeviceFile, LogDeviceConsole
*/
class LogDeviceDebugOutput : public LogDevice
{
public:
    //group=Methods

    /*
    Description:Outputs the LogEntry to the attached debugger's debug output.
    Remarks: On Windows and NON_SUPPORT_E, forwards the entry to OutputDebugString. Otherwise, use LogDeviceConsole
    */
    //  {secret}

    virtual void Output(const qChar *pLog);

};

END_NAMESPACE_NEX


