﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>

BEGIN_NAMESPACE_NEX

//group= Data Logging

/*
Description: This class describes the structure of a log item.
*/
class LogEntry : public RootObject
{
public:
    //group=Methods

    /*
    Parameters:
    szString: The LogEntry as a string.
    */
    LogEntry():m_strText(NEX_T("UNKNOWN")) {};
    LogEntry(const qChar *szString):m_strText(szString) {};
    LogEntry(const LogEntry& rhs):RootObject(),m_strText(rhs.m_strText) {};

    virtual ~LogEntry() {};

    /*
    Description: Returns the LogEntry as a const C-style version of the string.
    Returns: The LogEntry as a const C-style version of the string.
    */
    const qChar *CStr() const
    {
        return m_strText.CStr();
    };

    LogEntry& operator=(const LogEntry& rhs)
    {
        m_strText=rhs.m_strText;
        return *this;
    }

    // n:2370
    size_t GetLogLength() const
    {
        return m_strText.GetLength();
    }

private:

    String m_strText;
};

END_NAMESPACE_NEX

