﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

const qUnsignedInt RNGStateVectorSize = 624;

class RandomNumberGenerator
{
public:
    RandomNumberGenerator();
    ~RandomNumberGenerator();

    void SetRandomNumberSeed(qUnsignedInt32 uiSeed);
    qReal GetRealRandomNumber(qReal fMaxValue);
    qUnsignedInt32 GetRandomNumber(qUnsignedInt32 uiMaxValue);

protected:
    static const qUnsignedInt32 DEFAULT_INITIAL_SEED = 4357;
    qUnsignedInt32  m_mt[RNGStateVectorSize]; /* the array for the state vector  */
    qUnsignedInt    m_mti;
    qUnsignedInt32  m_mag01[2];
};

END_NAMESPACE_NEX

