﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

// Windows family recognition.

#if defined(WIN32) && !defined(UNDER_CE) && !defined(_NON_SUPPORT_D) && !defined(_XENON)
#define WIN_FAMILY
#define WIN32_TARGET
#define TARGET_RECOGNIZED
#define MSC_COMPILER
#endif // WIN32

// LIVE_VERSIONはBuildFlags_server.cmakeやBuildFlags_linuxserver.cmakeで定義されるサーバビルド向け定義
#ifndef LIVE_VERSION
#define NEX_CLIENT_OPTIMIZATION
#endif

#if defined(_NON_SUPPORT_D)

// (note that due to a bug in makedepend, the spaces before the ifndef
// that follows is required!)

#ifndef _M_PPC
#define WIN_FAMILY
#define NON_SUPPORT_D_TARGET
#define NON_SUPPORT_D_FAMILY
#define TARGET_RECOGNIZED
#define MSC_COMPILER
#else
#define NON_SUPPORT_E_TARGET
#endif // _M_PPC
#endif // NON_SUPPORT_D

#if defined(XENON) || defined(_XENON) || defined(_NON_SUPPORT_E) || defined(NON_SUPPORT_E)
// Maybe some people are using those
#ifndef NON_SUPPORT_E_TARGET
#define NON_SUPPORT_E_TARGET
#endif
#endif

#ifdef NON_SUPPORT_E_TARGET
#define WIN_FAMILY
#define NON_SUPPORT_D_FAMILY
#define TARGET_RECOGNIZED
#define MSC_COMPILER
#endif

#if defined(WIN32_TARGET)

#if defined(_MSC_VER) && _MSC_VER >= 1300
#define DOT_NET_COMPILER
#endif

#if defined(_MSC_VER) && _MSC_VER >= 1310 && _MSC_VER < 1400
#define DOT_NET_2003_COMPILER
#elif defined(_MSC_VER) && _MSC_VER >= 1400 && _MSC_VER < 1500
#define VS2005_COMPILER
#elif defined(_MSC_VER) && _MSC_VER >= 1500 && _MSC_VER < 1600
#define VS2008_COMPILER
#elif defined(_MSC_VER) && _MSC_VER >= 1600
#define VS2010_COMPILER
#endif

#endif // WIN32_TARGET


// Unix family recognition.

#ifndef GCC_TARGET_NON_SUPPORT_B
#if defined(__GNUC__) && __GNUC__ >= 3
#if defined(MIPSEL) && defined(R5900)
#define GCC_TARGET_NON_SUPPORT_B
#endif
#endif
#endif

#ifdef LINUX_TARGET
#define UNIX_FAMILY
#define TARGET_RECOGNIZED
#define GCC_COMPILER_FAMILY
#endif // linux

#ifdef MACOSX_TARGET
#define UNIX_FAMILY
#define TARGET_RECOGNIZED
#define GCC_COMPILER_FAMILY
#endif // linux

// NON_SUPPORT_B target recognition.

#ifdef SN_TARGET_NON_SUPPORT_B
#define NON_SUPPORT_B_TARGET
#define SN_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifdef GCC_TARGET_NON_SUPPORT_B
#define NON_SUPPORT_B_TARGET
#define GCC_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#if defined(MW_TARGET_NON_SUPPORT_B)
#define NON_SUPPORT_B_TARGET
#define MW_COMPILER
#define TARGET_RECOGNIZED
#endif

#ifdef GCC_TARGET_NON_SUPPORT_A
#define NON_SUPPORT_A_TARGET
#define GCC_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif


#ifdef SN_TARGET_NON_SUPPORT_A
#define NON_SUPPORT_A_TARGET
#define SN_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifdef MW_TARGET_NON_SUPPORT_A
#define NON_SUPPORT_A_TARGET
#define MW_COMPILER
#define TARGET_RECOGNIZED
#endif

#if defined(NON_SUPPORT_B_TARGET) || defined(NON_SUPPORT_A_TARGET)
#define MIPS_R9000
#endif

#ifndef GCC_TARGET_NON_SUPPORT_C
#if !defined(__SNC__)
#if defined(__GNUC__) && __GNUC__ >= 3
#if defined(__CELLOS_LV2__)
#define GCC_TARGET_NON_SUPPORT_C
#endif
#endif
#endif
#endif

#ifdef GCC_TARGET_NON_SUPPORT_C
#define NON_SUPPORT_C_TARGET
#define GCC_COMPILER
#define GCC_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifndef SNC_TARGET_NON_SUPPORT_C
#if defined(__SNC__)
#if defined(__CELLOS_LV2__)
#define SNC_TARGET_NON_SUPPORT_C
#endif
#endif
#endif

#ifdef SNC_TARGET_NON_SUPPORT_C
#define NON_SUPPORT_C_TARGET
#define SN_COMPILER
#define SN_COMPILER_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifndef MW_TARGET_WII
#if defined(RVL) || defined(RVL_SDK) || defined(RVL_OS)
#define MW_TARGET_WII
#endif
#endif

#ifdef MW_TARGET_WII

#if !defined(WII_STACK) && !defined(WII_DWC)
#error You must define WII_STACK or WII_DWC to use Quazal API on Wii. Check the documentation or contact customer support for more details.
#endif

#if defined(WII_STACK) && defined(WII_DWC)
#error You must define only one of WII_STACK or WII_DWC to use Quazal API on Wii. Check the documentation or contact customer support for more details.
#endif

#define WII_TARGET
#define NINTENDO_FAMILY

// TODO_WII_PORT : we use MW_COMPILER, but we don't want to use this define
// in samples because the function mwInit(); is not defined!
// We have ~35 calls to MW_COMPILER. We should rename them to something like
// MW_COMPILER_INIT since it is mainly used (except a few exceptition) to
// define mwInit.
//#define MW_COMPILER
#define NINTENDO_FAMILY
#define TARGET_RECOGNIZED
#endif

#ifndef MULTI_TARGET_CAFE
#ifdef __ghs__  // for Green Hills compiler -----------------------------------
#define MULTI_TARGET_CAFE
#endif //#ifdef __ghs__
#endif //#ifndef MULTI_TARGET_CAFE


#ifdef MULTI_TARGET_CAFE
#define CAFE_TARGET
#define TARGET_RECOGNIZED
#define NINTENDO_FAMILY
#define NEX_CLIENT_OPTIMIZATION
#endif

#if defined(CAFE) && defined(IOP_BUILD)
#define CAFEIOP_TARGET
#define TARGET_RECOGNIZED
#define NINTENDO_FAMILY
#define NEX_CLIENT_OPTIMIZATION
#endif

#if defined(NN_NINTENDO_SDK)
#define NEX_SIGLO_FAMILY
#define NEX_NNSDK_FAMILY    // サンプルデモ向けの定義
#if defined(__arm) || defined(__aarch64__)
#define NEX_NX_TARGET
#define TARGET_RECOGNIZED
#endif
#endif

#if defined(NEX_SIGLO_FAMILY)
#ifndef NINTENDO_FAMILY
#define NINTENDO_FAMILY
#endif
#endif

/* Nintendo DS */

#if defined(__MWERKS__) && defined(__arm)
#define DS_TARGET
#define NINTENDO_FAMILY
#define TARGET_RECOGNIZED
#endif


#ifndef ARM_TARGET_CTR
#if defined(_ARMABI)
#define ARM_TARGET_CTR
#endif
#endif


#if defined(ARM_TARGET_CTR) || defined(NN_PLATFORM_CTR)
#define NEX_CLIENT_OPTIMIZATION
#define NINTENDO_FAMILY
#define CTR_TARGET
#define TARGET_RECOGNIZED
#endif


// Check errors.

#ifndef TARGET_RECOGNIZED
#error NO TARGET SPECIFIED !
#endif

/* Build Target */
#ifdef CTR_TARGET

// n2605 ライブラリビルドのときも NEX_DEBUG_VERSION を有効に
#if defined(NN_BUILD_DEBUG) || defined(NN_BUILD_NOOPT)
#define NEX_DEBUG_VERSION
// n2208 ライブラリビルドのときも NEX_DEVELOPMENT_VERSION を有効に
#elif defined(NN_BUILD_DEVELOPMENT) || defined(NN_BUILD_VERBOSE)
#define NEX_DEVELOPMENT_VERSION
#undef NEX_DEBUG_VERSION
#else
#define NEX_RELEASE_VERSION
#endif

#elif defined(NEX_SIGLO_FAMILY)

#if defined(NN_SDK_BUILD_DEBUG)
#if !defined(NEX_BUILDING_INTERNAL_TREE) && defined(NEX_NX_TARGET)
// NitendoSDKはNXのDebugビルド時にNN_SDK_BUILD_DEBUGが定義されつつDevelop版のライブラリが使われる。
// そこでパッケージされたNEXを使う場合かつNXビルドのときは、NN_SDK_BUILD_DEBUGが定義されていてもDEVELOPビルドにする
#define NEX_DEVELOPMENT_VERSION
#define NEX_ENABLE_TRACES
#else
#define NEX_DEBUG_VERSION
#endif
#elif defined(NN_SDK_BUILD_DEVELOP)
#define NEX_DEVELOPMENT_VERSION
#define NEX_ENABLE_TRACES
#else
#define NEX_RELEASE_VERSION
#endif // end of #if defined(NN_SDK_BUILD_DEBUG)

#else /* LINUX, WIN */
#if defined(_DEBUG) || defined(DEBUG)
#define NEX_DEBUG_VERSION
#else
#define NEX_RELEASE_VERSION
#endif
#endif

/* stop if defined many targets */
#if defined(NEX_DEBUG_VERSION) && defined(NEX_DEVELOPMENT_VERSION)
#error
#elif defined(NEX_DEBUG_VERSION) && defined(NEX_RELEASE_VERSION)
#error
#elif defined(NEX_DEVELOPMENT_VERSION) && defined(NEX_RELEASE_VERSION)
#error
#endif

// 一つもビルドタイプが指定されていなければエラー
#if !defined(NEX_DEBUG_VERSION) && !defined(NEX_DEVELOPMENT_VERSION) && !defined(NEX_RELEASE_VERSION)
#error NEX_DEBUG_VERSION or NEX_DEVELOPMENT_VERSION or NEX_RELEASE_VERSION are not defined.
#endif

/* Unicode or ANSI */

// 両方定義されていたらエラー
#if defined(NEX_UNICODE_VERSION) && defined(NEX_ANSI_VERSION)
#error define both NEX_UNICODE_VERSION and NEX_ANSI_VERSION
#endif

// NEX_UNICODE_VERSIONとNEX_ANSI_VERSIONの両方がコンパイルオプションで定義されていなかった場合

#if !defined(NEX_UNICODE_VERSION) && !defined(NEX_ANSI_VERSION)

#if defined(_ANSI) || defined(ANSI)
#define NEX_ANSI_VERSION

// CTR/CAFEは、Unicode
#elif defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#define NEX_UNICODE_VERSION

// Sigloは、UTF-8前提のANSI
#elif defined(NEX_SIGLO_FAMILY)
#define NEX_ANSI_VERSION

// WindowsかつMBCSは、ANSI
#elif defined(WIN32_TARGET) && defined(_MBCS)
#define NEX_ANSI_VERSION

// ここまでに決定されていなかった場合は、UNICODE優先でデフォルト
#else
#define NEX_UNICODE_VERSION
#endif

#endif // end of #if !defined(NEX_UNICODE_VERSION) && !defined(NEX_ANSI_VERSION)

/* The purpose of those definitions is to shorten macro expressions. */

#if defined(CTR_TARGET) && defined(NEX_ANSI_VERSION)
#define CTR_ANSI
#endif

#if defined(CTR_TARGET) && defined(NEX_UNICODE_VERSION)
#define CTR_UNICODE
#endif

#if defined(CAFE_TARGET) && defined(NEX_ANSI_VERSION)
#define CAFE_ANSI
#endif

#if defined(CAFE_TARGET) && defined(NEX_UNICODE_VERSION)
#define CAFE_UNICODE
#endif

// 共通化することを考えてCAFEと同じdefineにする
#if defined(CAFEIOP_TARGET) && defined(NEX_ANSI_VERSION)
#define CAFE_ANSI
#endif

#if defined(CAFEIOP_TARGET) && defined(NEX_UNICODE_VERSION)
#define CAFE_UNICODE
#endif

/* CTR config as it should run on a retail console */

#if defined(CTR_TARGET) && (defined(NEX_DEVELOPMENT_VERSION) || defined(NEX_RELEASE_VERSION))
#define CTR_SHIPPING_VERSION
#endif


// 64bit判定
#if defined(_WIN64) || defined(__x86_64__) || defined(__aarch64__)
#define NEX_64BIT_ARCH
#else
#define NEX_32BIT_ARCH
#endif

// longが64bitかどうか
#if defined(__LP64__)
#define NEX_LONG_IS_64BIT
#define NEX_LONG_IS_UINT64_T
#endif

// ネットワークスタック操作時にロックしない
#define STACK_IS_THREADSAFE

// 以下は各種切り替えオプション。TODO: OptimizationDefs.h等に移動する。

//n1589:MTUデフォルト値をオリジナルの1000から大きくする
//n2361 NFSでは互換性を保つため、MTU1000を維持
#if defined(NFS_COMPATIBLE) || defined(FPD_BUILD)
#define NEX_ENABLE_MTU_MAX 0
#else
#define NEX_ENABLE_MTU_MAX 1
#endif

//n2361 NFSでは互換性を保つため、RVとの通信のキー長を16byteに維持
#if defined(NFS_COMPATIBLE) || defined(FPD_BUILD)
#define NEX_ENABLE_KERBEROS_KEY_LENGTH_MAX 0
#else
#define NEX_ENABLE_KERBEROS_KEY_LENGTH_MAX 1
#endif

//n1589
#define NEX_ENABLE_LOCK_ENDPOINT_MAP_MISSING_FIX 1

//n1589:m_oRoutingTableのロックを行う、オリジナルコードでは抜けていた
#define NEX_ENABLE_LOCK_ROUTING_TABLE_MISSING_FIX 1

//n1589:ロックの最適化、主に各CriticalSectionを動的に個別に有効、無効を切り替えれるようにする
#define NEX_ENABLE_LOCK_OPTIMIZATION 1

//n1589
#if NEX_ENABLE_LOCK_OPTIMIZATION
#if defined(NEX_CLIENT_OPTIMIZATION)

#endif
#endif //NEX_ENABLE_LOCK_OPTIMIZATION

#ifdef NEX_CLIENT_OPTIMIZATION
#ifndef CAFEIOP_TARGET
#define NEX_CLIENT_PBPOOL // パケットバッファプールの使用 クライアントのみ
#endif
#endif

//n1589:直接送受信機能\ n2361:sjisの0x5c対策
#define NEX_ENABLE_PRUDP_USER_TRANSPORT 1

#if NEX_ENABLE_PRUDP_USER_TRANSPORT
//n2788:直接送受信機能専用クラスの有効化
#define NEX_ENABLE_USING_CLASS_DIRECTTRANSPORT 1
#endif

//n1589:送信時のロックを減らす
#define NEX_ENABLE_STATION_SEND_OPTIMIZATION 1

//n1589:unreliable送信量の最適化
#define NEX_ENABLE_UNRELIABLE_BC 1

//n1589:UnreliableSendMulti使用時にもルータ機能を使用できるようにする
#define NEX_ENABLE_SEND_MULTI_ROUTING 1

//n1589
#ifdef NEX_CLIENT_OPTIMIZATION
#define NEX_ENABLE_SOCKET_TRANSPORT_PROFILING 1
#endif

//n1589
#ifdef NEX_CLIENT_OPTIMIZATION
#define NEX_ENABLE_BERKLEY_SOCKET_PROFILING 1
#endif

//n1589:バグ報告時に必要となるフォルト処理情報をログ出力、フォルト時のレアバグが多いので必要
#if defined(NEX_CLIENT_OPTIMIZATION)
#define NEX_ENABLE_LOG_FAULT 1
#endif

//n1589:暗黙的にキュー指定されるコードを抑制
#define NEX_ENABLE_EXPLICIT_ARGUMENT_TRANSPORT_SEND_QUEUE 1

//n1589:dispatchスレッドからソケット送信が行える機能を抑制
#define NEX_ENABLE_TRANSPORT_SEND_QUEUE_FORCIBLY 1

//n2370
#if defined( NEX_CLIENT_OPTIMIZATION )
#   define NEX_ENABLE_RELIABLE_MAP_SIZE_LIMITATION 1
#else
#   define NEX_ENABLE_RELIABLE_MAP_SIZE_LIMITATION 0
#endif

#if defined( NEX_CLIENT_OPTIMIZATION )
// n2361 unittestでメモリリーク判定となるので無効に
//n1769:CTR環境でプロファイリングの有無を切り換えたいときは、こちらのマクロの値を編集してください。
#define NEX_DISABLE_USING_CTR_PROFILING_UNIT 1
#else
//n1769:非CTR環境であれば、問答無用でプロファイリング機能を封印します。こちらはこのままにしておいてください。
#define NEX_DISABLE_USING_CTR_PROFILING_UNIT 1
#endif

//n2370:セッションへの参加中は、マスター以外のPRUDP接続を拒否する
#ifdef NEX_CLIENT_OPTIMIZATION
#   define NEX_ENABLE_REJECT_PRUDP_CONNECTING_WHILE_JOINING 1
#else
#   define NEX_ENABLE_REJECT_PRUDP_CONNECTING_WHILE_JOINING 0
#endif

//n2370: セッション参加に失敗したときに一部の通信を無視する
#define NEX_IGNORE_DOPROTOCOL_IF_FAILED_TO_JOIN 1

//n2370: ステーション接続完了時のチェック
#define NEX_CHECK_FAULTY_ON_ORPHAN_RESULT 1

//n2370: 受付失敗時に切断
#define NEX_DISCONNECT_ON_REQUESTFAILED 1

//n2370: セッション受付失敗時にStationの主参照削除方法を変更
#define NEX_JOINREQUESTFAILED_CHECK_DUPLICATION_MASTER 0

//n2370: ステーション接続時にEndPointの確認を行う
#define NEX_ENABLE_ENDPOINTCHECK_UNDELETE 1

//n1589:for bug_p2p1720:ChangeMasterStationに失敗したときに無現待ちになるバグの回避
#define NEX_ENABLE_FAULT_RECOVERY_FOREVER_FIX 1

//n1589:for bug_p2p1720:そもそもChangeMasterStationに失敗する可能性をなくす（減らす）修正
#define NEX_ENABLE_FAULT_RECOVERY_ELECT_MASTER_IMPROVE 1

//n1589:for bug_p2p1174:DOターミネートが終了しなかった場合に致命的エラー処理ができるようにする
#define NEX_ENABLE_IMPROVE_DO_CORRUPT 1
#if NEX_ENABLE_IMPROVE_DO_CORRUPT

//n1589:LeaveSessionを適切に行えるようにする
#define NEX_ENABLE_IMPROVE_LEAVE_SESSION 1

#else //NEX_ENABLE_IMPROVE_DO_CORRUPT

#define NEX_ENABLE_IMPROVE_LEAVE_SESSION 0

#endif //NEX_ENABLE_IMPROVE_DO_CORRUPT

//n2370: Quazal社からの提供　終了処理が長引く問題について、EndPointへの接続をキャンセルするパッチ
#define NEX_ENABLE_QUAZAL_TERMINATE_CANCELJOB 1

//n2370: Quazal社からの提供　終了処理が長引く問題について、SynchronizeTerminationを改善するパッチ
#define NEX_ENABLE_QUAZAL_TERMINATE_SYNCTERMINATION 1

//n2370: JobTerminateDOCore::SyncTerminationでコールコンテキストのチェックを行う
#define NEX_ENABLE_CALLCONTEXT_CHECK_IN_SYNCTERMINATION 1

//n2781: PRUDPSの脆弱性を修正
#define NEX_ENABLE_FIX_PRUDPS 1

//n2781: 修正の詳細(個別にOn/Offの切り替えはできません)
#if NEX_ENABLE_FIX_PRUDPS
//n2781: 圧縮/暗号化の処理をEndPointレベルで行う
#define NEX_ENABLE_ENCDEC_AT_ENDPOINT 1

//n2781: 認証ノードから受け取った鍵をサービスノードとの通信に使用する
#define NEX_ENABLE_USE_SECURE_KEY 1

//n2781: チケットに有効期限を付ける
#define NEX_ENABLE_USE_TICKET_PERIOD 1

#else // NEX_ENABLE_FIX_PRUDPS
#define NEX_ENABLE_ENCDEC_AT_ENDPOINT 0
#define NEX_ENABLE_USE_SECURE_KEY 0
#define NEX_ENABLE_USE_TICKET_PERIOD 0
#endif // end of NEX_ENABLE_FIX_PRUDPS

//n2690: FPDの互換性維持のためのマクロ定義
#if defined(NFS_COMPATIBLE)
// RegisterURLs では、RegiserExを使用して必ずトークン認証を行う
#define NEX_ENABLE_FORCE_REGISTEREX 1
// RVSecure のストリームの受付を許可する
#define NEX_ENABLE_OLD_RVSECURE 1
#else
#define NEX_ENABLE_FORCE_REGISTEREX 0
#define NEX_ENABLE_OLD_RVSECURE 0
#endif

//n2781:まとめてACKを返す
#define NEX_ENABLE_COLLATED_ACK 0

//n2781:テスト用に指定したアドレスとの通信を遮断する
#define NEX_ENABLE_VIRTUAL_FILTER_DEVICE 1

//n2781:トランスポートスレッドの優先順位がメインスレッドより高い場合にFatalが出るバグの修正
#define NEX_ENABLE_TRANSPORT_THREAD_PRIORITY_FIX 1

//n2781: DATAパケットのHMACに安全な一時鍵を使用する
#if defined(FPD_BUILD) || defined(NFS_COMPATIBLE)
#define NEX_ENABLE_HMAC_USE_SECURE_KEY 0
#else
#define NEX_ENABLE_HMAC_USE_SECURE_KEY 1
#endif

//n2781: Hybrid接続を有効化
#define NEX_ENABLE_HYBRID 1

//n2781: Hybrid接続の制限
#define NEX_ENABLE_HYBRID_DETECT_LIMITATION 1

//n2781: JobConnectStationのキャンセルを有効化
#define NEX_ENABLE_CANCEL_CONNECT_STATION 0

//n2788: UdsNode EventThreadでnn::os::Threadを直接使用する
#define NEX_ENABLE_CHANGE_UDS_EVENT_THREAD 1

// プロダクトキーのチェックをするか
#define NEX_ENABLE_USE_PRODUCT_KEY 0

