﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>


BEGIN_NAMESPACE_NEX

enum CodePage
{
    CodePage_Current = 0,
    CodePage_Utf8 = 1
};
class CodePageConverter
{
public:

    static size_t MultiByteToWideChar( CodePage eCodePage, const qChar8* szASrc, qWideChar* szTDest, size_t uiDestLength );
    static size_t GetMultiByteToWideCharSize( CodePage eCodePage, const qChar8* szASrc );
    static size_t WideCharToMultiByte( CodePage eCodePage, const qWideChar* szTSrc, qChar8* szADest, size_t uiDestLength );
    static size_t GetWideCharToMultiByteSize( CodePage eCodePage, const qWideChar* szWSrc );
    static size_t MultiByteToChar16( CodePage eCodePage, const qChar8* szASrc, qChar16* szTDest, size_t uiDestLength );
    static size_t GetMultiByteToChar16Size( CodePage eCodePage, const qChar8* szASrc );
    static size_t Char16ToMultiByte( CodePage eCodePage, const qChar16* szTSrc, qChar8* szADest, size_t uiDestLength );
    static size_t GetChar16ToMultiByteSize( CodePage eCodePage, const qChar16* szTSrc );
};


extern size_t GetNeededUtf8BufferSize( const qWideChar* szSrc );
extern size_t UnicodeToUtf8( const qWideChar* szSrc, qChar8* szDest, size_t uiDestLength );
extern size_t Utf8ToUnicode( const qChar8* szSrc, qWideChar* szDest, size_t uiDestLength );

#if defined(NEX_QCHAR16_IS_NOT_WCHAR_T)
extern size_t GetNeededUtf8BufferSize( const qChar16* szSrc );
extern size_t UnicodeToUtf8( const qChar16* szSrc, qChar8* szDest, size_t uiDestLength );
extern size_t Utf8ToUnicode( const qChar8* szSrc, qChar16* szDest, size_t uiDestLength );
#endif

extern size_t GetNeededWideCharBufferSize( const qChar8* szSrc );


END_NAMESPACE_NEX

