﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

//$ifdef SPARK$
//$else$
//Group=Data Types
//$endif$


namespace StringEncoding
{
/*  Description: Enumerates all possible character encodings that your
    game/application may use for strings in calls to $PRODUCTNAME$.
    Remarks: When the default character encoding is set one of these values, the
    strings in calls made to $PRODUCTNAME$ by your game/application are encoded
    in the specified format.
    See Also: SetDefaultStringEncoding and GetDefaultStringEncoding
*/
enum
{
    Latin1 = 0,         // The encoding is in Windows ANSI Latin-1.
    UTF8 = 1,           // The encoding is in UTF-8.
#ifdef NEX_UNICODE_VERSION
    Unicode = 2,        // The encoding is in Windows Unicode.
#endif
    Invalid
};

}

END_NAMESPACE_NEX

