﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDeclInternal.h>

BEGIN_NAMESPACE_NEX

//Summary: Expresses a time interval in milliseconds.
/*!
    @brief 時間間隔を表す型です。単位はミリ秒です。
*/
typedef qInt32 TimeInterval;

/*!
    @brief TimeIntervalの最大値です。
*/
static const TimeInterval INFINITE_TIME_INTERVAL = 0x7fffffff;

/*!
    @brief 時間間隔を表す型です。単位はミリ秒です。
*/
typedef qInt64 LargeTimeInterval;

/*!
    @brief LargeTimeIntervalの最大値です。
*/
static const LargeTimeInterval INFINITE_LARGE_TIME_INTERVAL = 0x7fffffffffffffffLL;

// {secret}
// Expresses a time value, in microseconds.
/*!
    @brief 高分解能な時間を表す型です。単位はマイクロ秒です。
*/
typedef qUnsignedInt64 HighResolutionTime;

END_NAMESPACE_NEX

