﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once
#include <OnlineCore/src/Platform/Core/PlatformDecl.h>


BEGIN_NAMESPACE_NEX

class VirtualRootObject
{
public:
    VirtualRootObject() {}
    virtual ~VirtualRootObject() {}

    void *operator new(size_t size, void* pPtr) throw()
    {
        DUMMY_PARAM(size);
        return pPtr;
    }
    //n2775 CTRビルドの時には使用できずワーニングになるので除外
#ifndef CTR_TARGET
    void operator delete(void* pPtr1, void* pPtr2)
    {
        DUMMY_PARAM(pPtr1);
        DUMMY_PARAM(pPtr2);
    }
#endif

    void *operator new(size_t size, const qChar* file, qUnsignedInt32 line) throw();
    void *operator new(size_t size) throw();


    void *operator new[](size_t size, const qChar* file, qUnsignedInt32 line) throw();
    void *operator new[](size_t size) throw();

    void operator delete(void *uptr);
    void operator delete[](void *uptr);

    //n2775 CTRビルドの時には使用できずワーニングになるので除外
#ifndef CTR_TARGET
    void operator delete(void *uptr, const qChar *file, qUnsignedInt32 line);
    void operator delete[](void *uptr, const qChar *file, qUnsignedInt32 line);
#endif

};

END_NAMESPACE_NEX

