﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once


#include <OnlineCore/src/Platform/Stack/Core/InetDecl.h>
#include <OnlineCore/src/Platform/Stack/Core/SocketDriver.h>

BEGIN_NAMESPACE_NEX

class ClientWebSocketDriver: public WebSocketDriver
{
public:
    class ClientWebSocket;
    ClientWebSocketDriver()
#if defined(NEX_FORCE_USE_NATIVE_WINSOCK)
        : m_sslAllowSelfSignedCerts(true)
#else
        : m_sslAllowSelfSignedCerts(false)
#endif
    {}
    virtual ~ClientWebSocketDriver() {}

    virtual Socket *Create();
    virtual void Delete(SocketDriver::Socket *pSocket);

    virtual qBool Poll(PollInfo aPollInfo[], qUnsignedInt uiPollInfoSize, qUnsignedInt32 uiTimeoutInMs);

    // 自己署名された証明書を許容するかどうかをセットする。Connect側のみ影響する。
    virtual void SetSslAllowSelfSignedCerts(qBool allow)
    {
        m_sslAllowSelfSignedCerts = allow;
    }

    // 自己署名された証明書を許容するかどうかをセットする。Connect側のみ影響する。
    virtual qBool GetSslAllowSelfSignedCerts()
    {
        return m_sslAllowSelfSignedCerts;
    }

private:
    qBool m_sslAllowSelfSignedCerts;
};

END_NAMESPACE_NEX
