﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

#if defined(NEX_SIGLO_FAMILY) && !defined(NEX_FORCE_USE_NATIVE_WINSOCK)
#define NEX_SIGLO_STACK
#define BERKELEY_STACK_SUPPORT

#elif defined(WIN_FAMILY)
#define WINSOCK_FAMILY_STACK        // winsock2を使うか。winsock2特有の処理を行う場合に利用する。
#define BERKELEY_STACK_SUPPORT

#elif defined(UNIX_FAMILY)
#define BERKELEY_STACK_SUPPORT

#elif defined(NON_SUPPORT_F_STACK)
#define BERKELEY_STACK_SUPPORT

#elif defined(EENET_STACK)

#elif defined(NON_SUPPORT_A_INFRASTRUCTURE)
#define BERKELEY_STACK_SUPPORT

#elif defined(NON_SUPPORT_C_TARGET)
#define BERKELEY_STACK_SUPPORT

#elif defined(WII_TARGET)
#define BERKELEY_STACK_SUPPORT

#elif defined(CTR_TARGET)
#define BERKELEY_STACK_SUPPORT

#elif defined(CAFE_TARGET)
#define BERKELEY_STACK_SUPPORT

#elif defined(CAFEIOP_TARGET)
#define BERKELEY_STACK_SUPPORT

#else
#error not supported platform
#endif

// Windows以外ではMSG_DONTWAITをサポートする
#if !defined(WIN32_TARGET)
#define NEX_MSG_DONTWAIT_SUPPORT
#endif

//  Return value for Socket::GetIOResult()

#ifdef NON_SUPPORT_A_TARGET
#define NON_SUPPORT_A_INFRASTRUCTURE
#endif

#ifdef CTR_TARGET
#include <nn/socket/socket_Types.h> //n2343:for sizeof(nn::socket::SockAddrIn)
BEGIN_NAMESPACE_NEX
typedef nn::socket::SockAddrStorage SockAddrStorage;
typedef nn::socket::SockAddrIn SockAddrIn;
END_NAMESPACE_NEX
#endif

#ifdef UNIX_FAMILY
#include <netinet/in.h>

BEGIN_NAMESPACE_NEX
typedef struct ::sockaddr_storage SockAddrStorage;
typedef struct ::sockaddr_in SockAddrIn;
END_NAMESPACE_NEX

#endif

#if defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)

#if defined(CAFE_TARGET)
#include <sdk_ver.h>
#if CAFE_OS_SDK_VERSION <= 20908
#include <cafe/net/so.h>
#else
#include <cafe/net/so_init.h>
#endif
#endif //defined(CAFE_TARGET)

#if defined(CAFEIOP_TARGET)
#include <cafe/net/so.h>
#include <cafe/net/netdb.h> // for gethostbyname
#endif //defined(CAFEIOP_TARGET)

BEGIN_NAMESPACE_NEX
typedef struct sockaddr SockAddrStorage;
typedef struct sockaddr_in SockAddrIn;
END_NAMESPACE_NEX

#endif


BEGIN_NAMESPACE_NEX

// ソケットハンドルの型を定義
#ifdef WINSOCK_FAMILY_STACK
// SOCKET型を使いたいが、windows.hはここではインクルードできないのでuintptr_tで代用
typedef uintptr_t       SocketHandle;
#else
typedef qInt32          SocketHandle;
#endif

// 無効なソケットハンドルの値を定義
#ifdef WINSOCK_FAMILY_STACK
static const SocketHandle NEX_INVALID_SOCKET = static_cast<SocketHandle>(~0);   // WinSock2.hの定義と同じ
#else
static const SocketHandle NEX_INVALID_SOCKET = -1;
#endif

namespace SocketConstants
{
#if NEX_ENABLE_MTU_MAX
    static const qUnsignedInt32 DEFAULT_MTU = 1364;
#else
    // NFS向けの設定
    static const qUnsignedInt32 DEFAULT_MTU = 1000;
#endif
    static const qUnsignedInt32 TCP_DATAGRAM_SIZE_PREFIX_SIZE = 2;
};
END_NAMESPACE_NEX
