﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/
#pragma once

#include <cstring>

// テストのためにServerWebSocketDriver.cppより分離

// X-Forwarded-Forのアドレス列をパースして、カンマがあれば最後の,で区切られた文字列をクライアントのIPアドレスと見なす。
// (前段のリバースプロキシーがつけたもの)
static char* GetLastSeparatedAddressInXForwardedFor(const char* xForwardedFor, char* clientAddr, size_t maxAddrSize)
{
    const char* pLastSeparatedAddress = xForwardedFor;
    while(true)
    {
        const char* pComma = strchr(pLastSeparatedAddress, ',');
        if (pComma == NULL) // ,が発見されなかったので、ループを抜ける
        {
            break;
        }
        // カンマの次の文字を指定して再検索
        pLastSeparatedAddress = pComma + 1;
    }
    strncpy(clientAddr, pLastSeparatedAddress, maxAddrSize - 1);
    clientAddr[maxAddrSize - 1] = '\0';
    
    return clientAddr;
}

