﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once
#include <OnlineCore/src/Platform/Core/HighResolutionClock.h>

BEGIN_NAMESPACE_NEX

class LFSR
{
private:
    qInt32 m_iCycle;
    qUnsignedInt32 m_uiPattern;
    qUnsignedInt32 m_uiCurrent;
public:
    LFSR(qInt32 iCycle, qUnsignedInt32 uiPattern) :
        m_iCycle(iCycle),
        m_uiPattern(uiPattern),
        m_uiCurrent(0)
    {
    }

    void SetSeed(qUnsignedInt32 uiNewCurren)
    {
        m_uiCurrent = uiNewCurren % m_iCycle;
    }
    qInt32 GetNext();
    qInt32 GetPrev();

    static qUnsignedInt32 GetNext(qUnsignedInt32 value, qUnsignedInt32 cycle, qInt32 pattern);
    static qUnsignedInt32 GetPrev(qUnsignedInt32 value, qUnsignedInt32 cycle, qInt32 pattern);

private:
    static qInt32 GetOrder(qUnsignedInt32 cycle);
};

END_NAMESPACE_NEX


