﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/RootObject.h>
#include <OnlineCore/src/Core/Key.h>
#include <OnlineCore/src/Transport/Interface/Stream.h>

BEGIN_NAMESPACE_NEX

class Packet;

class PacketEncDecInf : public RootObject
{
public:
    PacketEncDecInf() {}
    virtual ~PacketEncDecInf() {}

    virtual qBool Encode(Packet* pPacket, Stream::Type streamType, qBool needCopy = true) = 0;
    virtual void Decode(Packet* pPacket) = 0;
    virtual void SetEncryptionKey(const Key &oKey) = 0;
    virtual void SetReliableEncryptionKey(const Key &oKey, qByte sessionID, qByte peerSessionID) = 0;
    virtual void SetUnreliableEncryptionKey(const Key &oKey) = 0;
    virtual Key *GetEncryptionKey() = 0;
    virtual void DecideMaxUserReliableSubStreams(qUnsignedInt16 maxUserReliableSubStreams) = 0;
    virtual void ReinitUserReliableSubStreams() = 0;
};

class DummyPacketEncDec : public PacketEncDecInf
{
public:
    DummyPacketEncDec() {}
    virtual ~DummyPacketEncDec() {}

    virtual qBool Encode(Packet*, Stream::Type, qBool needCopy = true)
    {
        DUMMY_PARAM(needCopy);
        return true;
    }
    
    virtual void Decode(Packet*) {}
    virtual void SetEncryptionKey(const Key &) {}
    virtual void SetReliableEncryptionKey(const Key &, qByte , qByte ) {}
    virtual void SetUnreliableEncryptionKey(const Key &) {};
    virtual Key *GetEncryptionKey() {return NULL;}
    virtual void DecideMaxUserReliableSubStreams(qUnsignedInt16) {}
    virtual void ReinitUserReliableSubStreams() {}
};

END_NAMESPACE_NEX

