﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/ConnectionOrientedStream.h>

// TODO - Should be named StreamEventHandler

BEGIN_NAMESPACE_NEX
class TransportEventHandler: public RootObject
{

public:

    TransportEventHandler();
    virtual ~TransportEventHandler();

    // Handles receives 'out of bound' such as broadcasts, etc.  Those
    // receives that are not done in the context of a connection
    // (receives in the context of a connection are done on the
    // EndPoint class).
    virtual void Receive(ConnectionOrientedStream *pTransport, Buffer *pBuffer, const StationURL *pStationURL);
    virtual void ReceiveBroadcast(ConnectionOrientedStream *pTransport, Buffer *pBuffer, const StationURL *pStationURL);

#if NEX_ENABLE_HYBRID
    virtual qBool SwitchToRoutingConnection(EndPoint *);
#endif

    // TODO - remove this method?
    virtual void DeviceDiscovery(ConnectionOrientedStream *pTransport, qChar *szDevice);
    virtual qBool ConnectionRequest(ConnectionOrientedStream *pTransport, const StationURL *pStationURL,
                                    Buffer *pInOutBuffer, EndPoint *pEndPoint);
};


END_NAMESPACE_NEX

