﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Core/Holder.h>

BEGIN_NAMESPACE_NEX

class KeyedChecksumAlgorithm;

/* A class that manages a set of transport, sharing connections to a
 * set of other stations.  A connection to a station, through which
 * ever transport, is considered equivalent to one via any other
 * transport.  All incoming and outcoming connections will share the
 * same end point event dispatcher */

class TransportSignatureGenerator: public RootObject
{
public:
    TransportSignatureGenerator();
    ~TransportSignatureGenerator();

    qUnsignedInt32 ComputeSourceSignature(qUnsignedInt32 uiAddress, qUnsignedInt16 uiPort);

private:
    // Illegal operations.
    TransportSignatureGenerator(const TransportSignatureGenerator&);
    TransportSignatureGenerator& operator=(const TransportSignatureGenerator&);

private:
    Holder<KeyedChecksumAlgorithm> m_pChecksum;
};


END_NAMESPACE_NEX

