﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/StationURL.h>

BEGIN_NAMESPACE_NEX

class VirtualNATDevice: public RootObject
{
public:
    VirtualNATDevice() {}
    virtual ~VirtualNATDevice() {}

    //  Returned value for both methods: 'true' actually means that the packet is blocked.
    virtual qBool PreventSendingTo(StationURL& urlTarget, qUnsignedInt16 ui16LocalPort = 0) = 0;
    virtual qBool PreventReceivingFrom(StationURL& urlSource, qUnsignedInt16 ui16LocalPort = 0) = 0;
};


END_NAMESPACE_NEX

