﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#pragma once

#include <OnlineCore/src/Transport/PRUDP/PRUDPDecl.h>
#include <OnlineCore/src/Transport/PRUDP/PRUDPMessageInterface.h>
#include <OnlineCore/src/Transport/Interface/Stream.h>


BEGIN_NAMESPACE_NEX
class Packet;
class TransportSignatureGenerator;
class SignatureBytes;
class InetAddress;
class EndPointUniqueIDSignatureHolder;
class PRUDPMessageSelector;
class TransportPerfCounters;

class PRUDPStreamTemplateInterface
{
public:
    virtual ~PRUDPStreamTemplateInterface() {};

    virtual qByte GetVersion() = 0;
    virtual qBool VersionNegotiation(Packet *pPacket, Packet *pAckPacket) = 0;
    virtual qBool CalcSendConnectionSignature(Packet* pPacket, TransportSignatureGenerator* pSignatureGenerator,
        Stream::ID idSource, SignatureBytes* pSendConnectionSignature) = 0;
    virtual PRUDPMessageInterface::SignatureMatchPattern
        CheckSignature(InetAddress* pInetAddress, qUnsignedInt16 uiPort,
                Stream::ID idSource, Packet *pPacket, Key *pKey, TransportSignatureGenerator* pSignatureGenerator, SignatureBytes *pSB,
                PRUDPMessageInterface::SignatureMethod oMethod) = 0;
    virtual qBool GetSendConnectionSignature(Packet* pPacket, TransportSignatureGenerator* pSignatureGenerator,
            Stream::ID idSource, SignatureBytes* pSendConnectionSignature) = 0;
    virtual void ServiceTimeouts(const Time& currentTime) = 0;

    virtual Stream::Type GetStreamType() = 0;
#ifdef NEX_PERFCOUNTER_ENABLED
    virtual void SetPerfCounters(TransportPerfCounters *pPerfCounters) = 0;
#endif
};

END_NAMESPACE_NEX

