﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/UDP/PacketIn.h>

#ifdef NEX_CLIENT_PBPOOL // クライアントのみ

BEGIN_NAMESPACE_NEX

/*! @internal
 @brief PacketBufferオブジェクトをペイロード用に確保するPacketInクラスです。
        qNew(RootObject::POOL_PB_MANAGEMENT)で確保します。
        パケットバッファプールで確保するパケットについてはPacketInでなく、こちらのクラスを使用します。
        new後のインスタンスがNULLまたはPacketIn::IsValid()==falseの場合はメモリ確保失敗として、枯渇エラーとする処理が必要です。
 */

class PacketBufferPacketIn: public PacketIn
{
public:
    PacketBufferPacketIn(size_t size);
    virtual ~PacketBufferPacketIn()
    {
    }
};

END_NAMESPACE_NEX

#endif // NEX_CLIENT_PBPOOL // クライアントのみ

