﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// n2370
//#ifndef _PacketIn_H
#pragma once

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/UDP/Packet.h>
#include <OnlineCore/src/Core/ByteStream.h>
#include <OnlineCore/src/Core/FixedSizeMemoryPool.h>

BEGIN_NAMESPACE_NEX

class PacketIn: public Packet
{
public:

    PacketIn();
    PacketIn(qInt dummy);
    virtual ~PacketIn() {}


#ifdef NEX_TRACE_ENABLED    // n2370
    virtual void Trace(qUnsignedInt64 uiTraceFlags = D_TRACE_TRANSPORT_PACKET)
    {
        TraceImpl(uiTraceFlags, true);
    }
#endif  // NEX_TRACE_ENABLED

#ifdef NEX_CLIENT_PBPOOL // クライアントのみ
    /* @internal
     @brief Validでない場合は、このオブジェクトを使用してはいけない。
            現状メモリ確保できていない場合false。
     */
    qBool IsValid()
    {
        if (!GetPayload() || !GetPayload()->IsValid())
        {
            // コンストラクタでqNew PacketBuffer()しているのに、PacketBuffer自体もしくはそのペイロードのバッファ自体が無い。(バッファ枯渇)
            QTRACE(D_TRACE_MEMORY, NEX_T("PacketIn::IsValid() false"));
            return false;
        }

        return true;
    }
#endif // NEX_CLIENT_PBPOOL
};

END_NAMESPACE_NEX

