#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "AccountDataDDL.h"
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Core/src/Common/Data.h"
#include "OnlineCore/src/DDLTypes/STLExtTypes.h"
#include "RendezVous/Core/src/Common/ResultRange.h"
#include "BasicAccountInfoDDL.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(AccountManagementProtocol, CreateAccount, 1 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, DeleteAccount, 2 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, DisableAccount, 3 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, ChangePassword, 4 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, TestCapability, 5 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetName, 6 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetAccountData, 7 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetPrivateData, 8 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetPublicData, 9 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetMultiplePublicData, 10 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateAccountName, 11 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateAccountEmail, 12 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateCustomData, 13 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, FindByNameRegex, 14 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateAccountExpiryDate, 15 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateAccountEffectiveDate, 16 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateStatus, 17 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetStatus, 18 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, GetLastConnectionStats, 19 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, ResetPassword, 20 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, CreateAccountWithCustomData, 21 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, RetrieveAccount, 22 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, UpdateAccount, 23 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, ChangePasswordByGuest, 24 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, FindByNameLike, 25 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, CustomCreateAccount, 26 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, NintendoCreateAccount, 27 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, LookupOrCreateAccount, 28 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, DisconnectPrincipal, 29 );
PROTO_DEFINE_RMCID(AccountManagementProtocol, DisconnectAllPrincipals, 30 );
PROTO_DEFINE_NUM_RMC(AccountManagementProtocol, 30);

class AccountManagementProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(qresult) TCreateAccount_result;
        typedef DDLTYPE(string) TCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TCreateAccount_strKey;
        typedef DDLTYPE(uint32) TCreateAccount_uiGroups;
        typedef DDLTYPE(string) TCreateAccount_strEmail;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, CreateAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCreateAccount_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TDeleteAccount_idPrincipal;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, DeleteAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TDisableAccount_result;
        typedef DDLTYPE(uint32) TDisableAccount_idPrincipal;
        typedef DDLTYPE(datetime) TDisableAccount_dtUntil;
        typedef DDLTYPE(string) TDisableAccount_strMessage;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, DisableAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDisableAccount_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TChangePassword_result;
        typedef DDLTYPE(string) TChangePassword_strNewKey;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, ChangePassword)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TChangePassword_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TTestCapability_result;
        typedef DDLTYPE(uint32) TTestCapability_uiCapability;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, TestCapability)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TTestCapability_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetName_idPrincipal;
        typedef DDLTYPE(string) TGetName_strName;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetName)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetName_strName,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TGetAccountData_result;
        typedef CLASSMETATYPE(AccountData) TGetAccountData_oAccountData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetAccountData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetAccountData_result,1);
            _DO_RMC_ExtractReturnValue(TGetAccountData_oAccountData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetPrivateData_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TGetPrivateData_oData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetPrivateData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPrivateData_result,1);
            _DO_RMC_ExtractReturnValue(TGetPrivateData_oData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetPublicData_result;
        typedef DDLTYPE(uint32) TGetPublicData_idPrincipal;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TGetPublicData_oData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetPublicData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPublicData_result,1);
            _DO_RMC_ExtractReturnValue(TGetPublicData_oData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetMultiplePublicData_result;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetMultiplePublicData_lstPrincipals;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > > TGetMultiplePublicData_oData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetMultiplePublicData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetMultiplePublicData_result,1);
            _DO_RMC_ExtractReturnValue(TGetMultiplePublicData_oData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TUpdateAccountName_result;
        typedef DDLTYPE(string) TUpdateAccountName_strName;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateAccountName)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUpdateAccountName_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TUpdateAccountEmail_result;
        typedef DDLTYPE(string) TUpdateAccountEmail_strName;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateAccountEmail)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUpdateAccountEmail_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TUpdateCustomData_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateCustomData_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateCustomData_oPrivateData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateCustomData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUpdateCustomData_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindByNameRegex_uiGroups;
        typedef DDLTYPE(string) TFindByNameRegex_strRegex;
        typedef CLASSMETATYPE(ResultRange) TFindByNameRegex_resultRange;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) > TFindByNameRegex_plstAccounts;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, FindByNameRegex)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByNameRegex_plstAccounts,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateAccountExpiryDate_idPrincipal;
        typedef DDLTYPE(datetime) TUpdateAccountExpiryDate_dtExpiry;
        typedef DDLTYPE(string) TUpdateAccountExpiryDate_strExpiredMessage;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateAccountExpiryDate)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateAccountEffectiveDate_idPrincipal;
        typedef DDLTYPE(datetime) TUpdateAccountEffectiveDate_dtEffectiveFrom;
        typedef DDLTYPE(string) TUpdateAccountEffectiveDate_strNotEffectiveMessage;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateAccountEffectiveDate)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TUpdateStatus_strStatus;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateStatus)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetStatus_idPrincipal;
        typedef DDLTYPE(string) TGetStatus_strStatus;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetStatus)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStatus_strStatus,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetLastConnectionStats_idPrincipal;
        typedef DDLTYPE(datetime) TGetLastConnectionStats_dtLastSessionLogin;
        typedef DDLTYPE(datetime) TGetLastConnectionStats_dtLastSessionLogout;
        typedef DDLTYPE(datetime) TGetLastConnectionStats_dtCurrentSessionLogin;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, GetLastConnectionStats)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetLastConnectionStats_dtLastSessionLogin,1);
            _DO_RMC_ExtractReturnValue(TGetLastConnectionStats_dtLastSessionLogout,1);
            _DO_RMC_ExtractReturnValue(TGetLastConnectionStats_dtCurrentSessionLogin,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TResetPassword_result;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, ResetPassword)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TResetPassword_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TCreateAccountWithCustomData_strPrincipalName;
        typedef DDLTYPE(string) TCreateAccountWithCustomData_strKey;
        typedef DDLTYPE(uint32) TCreateAccountWithCustomData_uiGroups;
        typedef DDLTYPE(string) TCreateAccountWithCustomData_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TCreateAccountWithCustomData_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TCreateAccountWithCustomData_oPrivateData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, CreateAccountWithCustomData)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(AccountData) TRetrieveAccount_oAccountData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TRetrieveAccount_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TRetrieveAccount_oPrivateData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, RetrieveAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRetrieveAccount_oAccountData,1);
            _DO_RMC_ExtractReturnValue(TRetrieveAccount_oPublicData,1);
            _DO_RMC_ExtractReturnValue(TRetrieveAccount_oPrivateData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TUpdateAccount_strKey;
        typedef DDLTYPE(string) TUpdateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateAccount_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateAccount_oPrivateData;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, UpdateAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TChangePasswordByGuest_strPrincipalName;
        typedef DDLTYPE(string) TChangePasswordByGuest_strEmail;
        typedef DDLTYPE(string) TChangePasswordByGuest_strKey;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, ChangePasswordByGuest)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindByNameLike_uiGroups;
        typedef DDLTYPE(string) TFindByNameLike_strLike;
        typedef CLASSMETATYPE(ResultRange) TFindByNameLike_resultRange;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) > TFindByNameLike_plstAccounts;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, FindByNameLike)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByNameLike_plstAccounts,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TCustomCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TCustomCreateAccount_strKey;
        typedef DDLTYPE(uint32) TCustomCreateAccount_uiGroups;
        typedef DDLTYPE(string) TCustomCreateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TCustomCreateAccount_oAuthData;
        typedef DDLTYPE(uint32) TCustomCreateAccount_pid;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, CustomCreateAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCustomCreateAccount_pid,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TNintendoCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TNintendoCreateAccount_strKey;
        typedef DDLTYPE(uint32) TNintendoCreateAccount_uiGroups;
        typedef DDLTYPE(string) TNintendoCreateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TNintendoCreateAccount_oAuthData;
        typedef DDLTYPE(uint32) TNintendoCreateAccount_pid;
        typedef DDLTYPE(string) TNintendoCreateAccount_pidHMAC;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, NintendoCreateAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TNintendoCreateAccount_pid,1);
            _DO_RMC_ExtractReturnValue(TNintendoCreateAccount_pidHMAC,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TLookupOrCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TLookupOrCreateAccount_strKey;
        typedef DDLTYPE(uint32) TLookupOrCreateAccount_uiGroups;
        typedef DDLTYPE(string) TLookupOrCreateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TLookupOrCreateAccount_oAuthData;
        typedef DDLTYPE(uint32) TLookupOrCreateAccount_pid;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, LookupOrCreateAccount)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TLookupOrCreateAccount_pid,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TDisconnectPrincipal_result;
        typedef DDLTYPE(uint32) TDisconnectPrincipal_idPrincipal;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, DisconnectPrincipal)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDisconnectPrincipal_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TDisconnectAllPrincipals_result;
        PROTO_RMCIMPL_RETURN(AccountManagementProtocol, DisconnectAllPrincipals)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDisconnectAllPrincipals_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        AccountManagementProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew AccountManagementProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallCreateAccount(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail);
        static qBool CreateAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail);
        qBool CallDeleteAccount(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idPrincipal);
        static qBool DeleteAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idPrincipal);
        qBool CallDisableAccount(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtUntil, const DDLTYPE(string)::CPPType& strMessage);
        static qBool DisableAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtUntil, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallChangePassword(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strNewKey);
        static qBool ChangePassword_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strNewKey);
        qBool CallTestCapability(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& uiCapability);
        static qBool TestCapability_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& uiCapability);
        qBool CallGetName(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(string)::CPPType* strName);
        static qBool GetName_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(string)::CPPType* strName);
        qBool CallGetAccountData(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, AccountData* oAccountData);
        static qBool GetAccountData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, AccountData* oAccountData);
        qBool CallGetPrivateData(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oData);
        static qBool GetPrivateData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oData);
        qBool CallGetPublicData(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oData);
        static qBool GetPublicData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oData);
        qBool CallGetMultiplePublicData(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* oData);
        static qBool GetMultiplePublicData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* oData);
        qBool CallUpdateAccountName(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strName);
        static qBool UpdateAccountName_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strName);
        qBool CallUpdateAccountEmail(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strName);
        static qBool UpdateAccountEmail_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strName);
        qBool CallUpdateCustomData(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData);
        static qBool UpdateCustomData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData);
        qBool CallFindByNameRegex(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strRegex, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType* plstAccounts);
        static qBool FindByNameRegex_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strRegex, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType* plstAccounts);
        qBool CallUpdateAccountExpiryDate(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtExpiry, const DDLTYPE(string)::CPPType& strExpiredMessage);
        static qBool UpdateAccountExpiryDate_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtExpiry, const DDLTYPE(string)::CPPType& strExpiredMessage);
        qBool CallUpdateAccountEffectiveDate(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtEffectiveFrom, const DDLTYPE(string)::CPPType& strNotEffectiveMessage);
        static qBool UpdateAccountEffectiveDate_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtEffectiveFrom, const DDLTYPE(string)::CPPType& strNotEffectiveMessage);
        qBool CallUpdateStatus(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strStatus);
        static qBool UpdateStatus_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strStatus);
        qBool CallGetStatus(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(string)::CPPType* strStatus);
        static qBool GetStatus_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(string)::CPPType* strStatus);
        qBool CallGetLastConnectionStats(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(datetime)::CPPType* dtLastSessionLogin, DDLTYPE(datetime)::CPPType* dtLastSessionLogout, DDLTYPE(datetime)::CPPType* dtCurrentSessionLogin);
        static qBool GetLastConnectionStats_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(datetime)::CPPType* dtLastSessionLogin, DDLTYPE(datetime)::CPPType* dtLastSessionLogout, DDLTYPE(datetime)::CPPType* dtCurrentSessionLogin);
        qBool CallResetPassword(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool ResetPassword_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        qBool CallCreateAccountWithCustomData(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData);
        static qBool CreateAccountWithCustomData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData);
        qBool CallRetrieveAccount(ProtocolCallContext *pContext, AccountData* oAccountData, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oPublicData, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oPrivateData);
        static qBool RetrieveAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, AccountData* oAccountData, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oPublicData, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oPrivateData);
        qBool CallUpdateAccount(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData);
        static qBool UpdateAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData);
        qBool CallChangePasswordByGuest(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(string)::CPPType& strKey);
        static qBool ChangePasswordByGuest_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(string)::CPPType& strKey);
        qBool CallFindByNameLike(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strLike, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType* plstAccounts);
        static qBool FindByNameLike_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strLike, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType* plstAccounts);
        qBool CallCustomCreateAccount(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid);
        static qBool CustomCreateAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid);
        qBool CallNintendoCreateAccount(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid, DDLTYPE(string)::CPPType* pidHMAC);
        static qBool NintendoCreateAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid, DDLTYPE(string)::CPPType* pidHMAC);
        qBool CallLookupOrCreateAccount(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid);
        static qBool LookupOrCreateAccount_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid);
        qBool CallDisconnectPrincipal(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idPrincipal);
        static qBool DisconnectPrincipal_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idPrincipal);
        qBool CallDisconnectAllPrincipals(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool DisconnectAllPrincipals_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(AccountManagementProtocol) + 1];
};

class DDLPROTOCOL(AccountManagementProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(AccountManagementProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_CreateAccountProfilingUnit(NEX_T("AccountManagementProtocol::CreateAccount"))
            , m_DeleteAccountProfilingUnit(NEX_T("AccountManagementProtocol::DeleteAccount"))
            , m_DisableAccountProfilingUnit(NEX_T("AccountManagementProtocol::DisableAccount"))
            , m_ChangePasswordProfilingUnit(NEX_T("AccountManagementProtocol::ChangePassword"))
            , m_TestCapabilityProfilingUnit(NEX_T("AccountManagementProtocol::TestCapability"))
            , m_GetNameProfilingUnit(NEX_T("AccountManagementProtocol::GetName"))
            , m_GetAccountDataProfilingUnit(NEX_T("AccountManagementProtocol::GetAccountData"))
            , m_GetPrivateDataProfilingUnit(NEX_T("AccountManagementProtocol::GetPrivateData"))
            , m_GetPublicDataProfilingUnit(NEX_T("AccountManagementProtocol::GetPublicData"))
            , m_GetMultiplePublicDataProfilingUnit(NEX_T("AccountManagementProtocol::GetMultiplePublicData"))
            , m_UpdateAccountNameProfilingUnit(NEX_T("AccountManagementProtocol::UpdateAccountName"))
            , m_UpdateAccountEmailProfilingUnit(NEX_T("AccountManagementProtocol::UpdateAccountEmail"))
            , m_UpdateCustomDataProfilingUnit(NEX_T("AccountManagementProtocol::UpdateCustomData"))
            , m_FindByNameRegexProfilingUnit(NEX_T("AccountManagementProtocol::FindByNameRegex"))
            , m_UpdateAccountExpiryDateProfilingUnit(NEX_T("AccountManagementProtocol::UpdateAccountExpiryDate"))
            , m_UpdateAccountEffectiveDateProfilingUnit(NEX_T("AccountManagementProtocol::UpdateAccountEffectiveDate"))
            , m_UpdateStatusProfilingUnit(NEX_T("AccountManagementProtocol::UpdateStatus"))
            , m_GetStatusProfilingUnit(NEX_T("AccountManagementProtocol::GetStatus"))
            , m_GetLastConnectionStatsProfilingUnit(NEX_T("AccountManagementProtocol::GetLastConnectionStats"))
            , m_ResetPasswordProfilingUnit(NEX_T("AccountManagementProtocol::ResetPassword"))
            , m_CreateAccountWithCustomDataProfilingUnit(NEX_T("AccountManagementProtocol::CreateAccountWithCustomData"))
            , m_RetrieveAccountProfilingUnit(NEX_T("AccountManagementProtocol::RetrieveAccount"))
            , m_UpdateAccountProfilingUnit(NEX_T("AccountManagementProtocol::UpdateAccount"))
            , m_ChangePasswordByGuestProfilingUnit(NEX_T("AccountManagementProtocol::ChangePasswordByGuest"))
            , m_FindByNameLikeProfilingUnit(NEX_T("AccountManagementProtocol::FindByNameLike"))
            , m_CustomCreateAccountProfilingUnit(NEX_T("AccountManagementProtocol::CustomCreateAccount"))
            , m_NintendoCreateAccountProfilingUnit(NEX_T("AccountManagementProtocol::NintendoCreateAccount"))
            , m_LookupOrCreateAccountProfilingUnit(NEX_T("AccountManagementProtocol::LookupOrCreateAccount"))
            , m_DisconnectPrincipalProfilingUnit(NEX_T("AccountManagementProtocol::DisconnectPrincipal"))
            , m_DisconnectAllPrincipalsProfilingUnit(NEX_T("AccountManagementProtocol::DisconnectAllPrincipals"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(qresult) TCreateAccount_result;
        typedef DDLTYPE(string) TCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TCreateAccount_strKey;
        typedef DDLTYPE(uint32) TCreateAccount_uiGroups;
        typedef DDLTYPE(string) TCreateAccount_strEmail;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, CreateAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strPrincipalName;
            _MSG_EXTRACT_VARIABLE(TCreateAccount_strPrincipalName, strPrincipalName);
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TCreateAccount_strKey, strKey);
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TCreateAccount_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TCreateAccount_strEmail, strEmail);
            DDLTYPE(qresult)::CPPType __result=pProtocol->CreateAccount( strPrincipalName, strKey, uiGroups, strEmail );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,CreateAccount);
            _MSG_ADD_VARIABLE(TCreateAccount_result,__result);
        }
        
        typedef DDLTYPE(uint32) TDeleteAccount_idPrincipal;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, DeleteAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TDeleteAccount_idPrincipal, idPrincipal);
            pProtocol->DeleteAccount( idPrincipal );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,DeleteAccount);
        }
        
        typedef DDLTYPE(qresult) TDisableAccount_result;
        typedef DDLTYPE(uint32) TDisableAccount_idPrincipal;
        typedef DDLTYPE(datetime) TDisableAccount_dtUntil;
        typedef DDLTYPE(string) TDisableAccount_strMessage;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, DisableAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TDisableAccount_idPrincipal, idPrincipal);
            DDLTYPE(datetime)::CPPType dtUntil;
            _MSG_EXTRACT_VARIABLE(TDisableAccount_dtUntil, dtUntil);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TDisableAccount_strMessage, strMessage);
            DDLTYPE(qresult)::CPPType __result=pProtocol->DisableAccount( idPrincipal, dtUntil, strMessage );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,DisableAccount);
            _MSG_ADD_VARIABLE(TDisableAccount_result,__result);
        }
        
        typedef DDLTYPE(bool) TChangePassword_result;
        typedef DDLTYPE(string) TChangePassword_strNewKey;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, ChangePassword)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strNewKey;
            _MSG_EXTRACT_VARIABLE(TChangePassword_strNewKey, strNewKey);
            DDLTYPE(bool)::CPPType __result=pProtocol->ChangePassword( strNewKey );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,ChangePassword);
            _MSG_ADD_VARIABLE(TChangePassword_result,__result);
        }
        
        typedef DDLTYPE(bool) TTestCapability_result;
        typedef DDLTYPE(uint32) TTestCapability_uiCapability;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, TestCapability)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType uiCapability;
            _MSG_EXTRACT_VARIABLE(TTestCapability_uiCapability, uiCapability);
            DDLTYPE(bool)::CPPType __result=pProtocol->TestCapability( uiCapability );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,TestCapability);
            _MSG_ADD_VARIABLE(TTestCapability_result,__result);
        }
        
        typedef DDLTYPE(uint32) TGetName_idPrincipal;
        typedef DDLTYPE(string) TGetName_strName;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetName)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TGetName_idPrincipal, idPrincipal);
            DDLTYPE(string)::CPPType strName;
            pProtocol->GetName( idPrincipal, &strName );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetName);
            _MSG_ADD_VARIABLE(TGetName_strName, strName);
        }
        
        typedef DDLTYPE(qresult) TGetAccountData_result;
        typedef CLASSMETATYPE(AccountData) TGetAccountData_oAccountData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetAccountData)
        {
            PROTO_PREPARE_EXTRACTION();
            AccountData oAccountData;
            DDLTYPE(qresult)::CPPType __result=pProtocol->GetAccountData( &oAccountData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetAccountData);
            _MSG_ADD_VARIABLE(TGetAccountData_result,__result);
            _MSG_ADD_VARIABLE(TGetAccountData_oAccountData, oAccountData);
        }
        
        typedef DDLTYPE(bool) TGetPrivateData_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TGetPrivateData_oData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetPrivateData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oData;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetPrivateData( &oData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetPrivateData);
            _MSG_ADD_VARIABLE(TGetPrivateData_result,__result);
            _MSG_ADD_VARIABLE(TGetPrivateData_oData, oData);
        }
        
        typedef DDLTYPE(bool) TGetPublicData_result;
        typedef DDLTYPE(uint32) TGetPublicData_idPrincipal;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TGetPublicData_oData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetPublicData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TGetPublicData_idPrincipal, idPrincipal);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oData;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetPublicData( idPrincipal, &oData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetPublicData);
            _MSG_ADD_VARIABLE(TGetPublicData_result,__result);
            _MSG_ADD_VARIABLE(TGetPublicData_oData, oData);
        }
        
        typedef DDLTYPE(bool) TGetMultiplePublicData_result;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetMultiplePublicData_lstPrincipals;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > > TGetMultiplePublicData_oData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetMultiplePublicData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstPrincipals;
            _MSG_EXTRACT_VARIABLE(TGetMultiplePublicData_lstPrincipals, lstPrincipals);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType oData;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetMultiplePublicData( lstPrincipals, &oData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetMultiplePublicData);
            _MSG_ADD_VARIABLE(TGetMultiplePublicData_result,__result);
            _MSG_ADD_VARIABLE(TGetMultiplePublicData_oData, oData);
        }
        
        typedef DDLTYPE(qresult) TUpdateAccountName_result;
        typedef DDLTYPE(string) TUpdateAccountName_strName;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateAccountName)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strName;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountName_strName, strName);
            DDLTYPE(qresult)::CPPType __result=pProtocol->UpdateAccountName( strName );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateAccountName);
            _MSG_ADD_VARIABLE(TUpdateAccountName_result,__result);
        }
        
        typedef DDLTYPE(qresult) TUpdateAccountEmail_result;
        typedef DDLTYPE(string) TUpdateAccountEmail_strName;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateAccountEmail)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strName;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountEmail_strName, strName);
            DDLTYPE(qresult)::CPPType __result=pProtocol->UpdateAccountEmail( strName );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateAccountEmail);
            _MSG_ADD_VARIABLE(TUpdateAccountEmail_result,__result);
        }
        
        typedef DDLTYPE(qresult) TUpdateCustomData_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateCustomData_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateCustomData_oPrivateData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateCustomData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPublicData;
            _MSG_EXTRACT_VARIABLE(TUpdateCustomData_oPublicData, oPublicData);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPrivateData;
            _MSG_EXTRACT_VARIABLE(TUpdateCustomData_oPrivateData, oPrivateData);
            DDLTYPE(qresult)::CPPType __result=pProtocol->UpdateCustomData( oPublicData, oPrivateData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateCustomData);
            _MSG_ADD_VARIABLE(TUpdateCustomData_result,__result);
        }
        
        typedef DDLTYPE(uint32) TFindByNameRegex_uiGroups;
        typedef DDLTYPE(string) TFindByNameRegex_strRegex;
        typedef CLASSMETATYPE(ResultRange) TFindByNameRegex_resultRange;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) > TFindByNameRegex_plstAccounts;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, FindByNameRegex)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TFindByNameRegex_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strRegex;
            _MSG_EXTRACT_VARIABLE(TFindByNameRegex_strRegex, strRegex);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByNameRegex_resultRange, resultRange);
            DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType plstAccounts;
            pProtocol->FindByNameRegex( uiGroups, strRegex, resultRange, &plstAccounts );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,FindByNameRegex);
            _MSG_ADD_VARIABLE(TFindByNameRegex_plstAccounts, plstAccounts);
        }
        
        typedef DDLTYPE(uint32) TUpdateAccountExpiryDate_idPrincipal;
        typedef DDLTYPE(datetime) TUpdateAccountExpiryDate_dtExpiry;
        typedef DDLTYPE(string) TUpdateAccountExpiryDate_strExpiredMessage;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateAccountExpiryDate)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountExpiryDate_idPrincipal, idPrincipal);
            DDLTYPE(datetime)::CPPType dtExpiry;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountExpiryDate_dtExpiry, dtExpiry);
            DDLTYPE(string)::CPPType strExpiredMessage;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountExpiryDate_strExpiredMessage, strExpiredMessage);
            pProtocol->UpdateAccountExpiryDate( idPrincipal, dtExpiry, strExpiredMessage );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateAccountExpiryDate);
        }
        
        typedef DDLTYPE(uint32) TUpdateAccountEffectiveDate_idPrincipal;
        typedef DDLTYPE(datetime) TUpdateAccountEffectiveDate_dtEffectiveFrom;
        typedef DDLTYPE(string) TUpdateAccountEffectiveDate_strNotEffectiveMessage;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateAccountEffectiveDate)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountEffectiveDate_idPrincipal, idPrincipal);
            DDLTYPE(datetime)::CPPType dtEffectiveFrom;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountEffectiveDate_dtEffectiveFrom, dtEffectiveFrom);
            DDLTYPE(string)::CPPType strNotEffectiveMessage;
            _MSG_EXTRACT_VARIABLE(TUpdateAccountEffectiveDate_strNotEffectiveMessage, strNotEffectiveMessage);
            pProtocol->UpdateAccountEffectiveDate( idPrincipal, dtEffectiveFrom, strNotEffectiveMessage );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateAccountEffectiveDate);
        }
        
        typedef DDLTYPE(string) TUpdateStatus_strStatus;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateStatus)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strStatus;
            _MSG_EXTRACT_VARIABLE(TUpdateStatus_strStatus, strStatus);
            pProtocol->UpdateStatus( strStatus );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateStatus);
        }
        
        typedef DDLTYPE(uint32) TGetStatus_idPrincipal;
        typedef DDLTYPE(string) TGetStatus_strStatus;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetStatus)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TGetStatus_idPrincipal, idPrincipal);
            DDLTYPE(string)::CPPType strStatus;
            pProtocol->GetStatus( idPrincipal, &strStatus );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetStatus);
            _MSG_ADD_VARIABLE(TGetStatus_strStatus, strStatus);
        }
        
        typedef DDLTYPE(uint32) TGetLastConnectionStats_idPrincipal;
        typedef DDLTYPE(datetime) TGetLastConnectionStats_dtLastSessionLogin;
        typedef DDLTYPE(datetime) TGetLastConnectionStats_dtLastSessionLogout;
        typedef DDLTYPE(datetime) TGetLastConnectionStats_dtCurrentSessionLogin;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, GetLastConnectionStats)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TGetLastConnectionStats_idPrincipal, idPrincipal);
            DDLTYPE(datetime)::CPPType dtLastSessionLogin;
            DDLTYPE(datetime)::CPPType dtLastSessionLogout;
            DDLTYPE(datetime)::CPPType dtCurrentSessionLogin;
            pProtocol->GetLastConnectionStats( idPrincipal, &dtLastSessionLogin, &dtLastSessionLogout, &dtCurrentSessionLogin );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,GetLastConnectionStats);
            _MSG_ADD_VARIABLE(TGetLastConnectionStats_dtLastSessionLogin, dtLastSessionLogin);
            _MSG_ADD_VARIABLE(TGetLastConnectionStats_dtLastSessionLogout, dtLastSessionLogout);
            _MSG_ADD_VARIABLE(TGetLastConnectionStats_dtCurrentSessionLogin, dtCurrentSessionLogin);
        }
        
        typedef DDLTYPE(bool) TResetPassword_result;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, ResetPassword)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->ResetPassword(  );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,ResetPassword);
            _MSG_ADD_VARIABLE(TResetPassword_result,__result);
        }
        
        typedef DDLTYPE(string) TCreateAccountWithCustomData_strPrincipalName;
        typedef DDLTYPE(string) TCreateAccountWithCustomData_strKey;
        typedef DDLTYPE(uint32) TCreateAccountWithCustomData_uiGroups;
        typedef DDLTYPE(string) TCreateAccountWithCustomData_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TCreateAccountWithCustomData_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TCreateAccountWithCustomData_oPrivateData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, CreateAccountWithCustomData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strPrincipalName;
            _MSG_EXTRACT_VARIABLE(TCreateAccountWithCustomData_strPrincipalName, strPrincipalName);
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TCreateAccountWithCustomData_strKey, strKey);
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TCreateAccountWithCustomData_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TCreateAccountWithCustomData_strEmail, strEmail);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPublicData;
            _MSG_EXTRACT_VARIABLE(TCreateAccountWithCustomData_oPublicData, oPublicData);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPrivateData;
            _MSG_EXTRACT_VARIABLE(TCreateAccountWithCustomData_oPrivateData, oPrivateData);
            pProtocol->CreateAccountWithCustomData( strPrincipalName, strKey, uiGroups, strEmail, oPublicData, oPrivateData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,CreateAccountWithCustomData);
        }
        
        typedef CLASSMETATYPE(AccountData) TRetrieveAccount_oAccountData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TRetrieveAccount_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TRetrieveAccount_oPrivateData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, RetrieveAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            AccountData oAccountData;
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPublicData;
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPrivateData;
            pProtocol->RetrieveAccount( &oAccountData, &oPublicData, &oPrivateData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,RetrieveAccount);
            _MSG_ADD_VARIABLE(TRetrieveAccount_oAccountData, oAccountData);
            _MSG_ADD_VARIABLE(TRetrieveAccount_oPublicData, oPublicData);
            _MSG_ADD_VARIABLE(TRetrieveAccount_oPrivateData, oPrivateData);
        }
        
        typedef DDLTYPE(string) TUpdateAccount_strKey;
        typedef DDLTYPE(string) TUpdateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateAccount_oPublicData;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TUpdateAccount_oPrivateData;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, UpdateAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TUpdateAccount_strKey, strKey);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TUpdateAccount_strEmail, strEmail);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPublicData;
            _MSG_EXTRACT_VARIABLE(TUpdateAccount_oPublicData, oPublicData);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oPrivateData;
            _MSG_EXTRACT_VARIABLE(TUpdateAccount_oPrivateData, oPrivateData);
            pProtocol->UpdateAccount( strKey, strEmail, oPublicData, oPrivateData );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,UpdateAccount);
        }
        
        typedef DDLTYPE(string) TChangePasswordByGuest_strPrincipalName;
        typedef DDLTYPE(string) TChangePasswordByGuest_strEmail;
        typedef DDLTYPE(string) TChangePasswordByGuest_strKey;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, ChangePasswordByGuest)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strPrincipalName;
            _MSG_EXTRACT_VARIABLE(TChangePasswordByGuest_strPrincipalName, strPrincipalName);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TChangePasswordByGuest_strEmail, strEmail);
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TChangePasswordByGuest_strKey, strKey);
            pProtocol->ChangePasswordByGuest( strPrincipalName, strEmail, strKey );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,ChangePasswordByGuest);
        }
        
        typedef DDLTYPE(uint32) TFindByNameLike_uiGroups;
        typedef DDLTYPE(string) TFindByNameLike_strLike;
        typedef CLASSMETATYPE(ResultRange) TFindByNameLike_resultRange;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) > TFindByNameLike_plstAccounts;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, FindByNameLike)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TFindByNameLike_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strLike;
            _MSG_EXTRACT_VARIABLE(TFindByNameLike_strLike, strLike);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByNameLike_resultRange, resultRange);
            DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType plstAccounts;
            pProtocol->FindByNameLike( uiGroups, strLike, resultRange, &plstAccounts );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,FindByNameLike);
            _MSG_ADD_VARIABLE(TFindByNameLike_plstAccounts, plstAccounts);
        }
        
        typedef DDLTYPE(string) TCustomCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TCustomCreateAccount_strKey;
        typedef DDLTYPE(uint32) TCustomCreateAccount_uiGroups;
        typedef DDLTYPE(string) TCustomCreateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TCustomCreateAccount_oAuthData;
        typedef DDLTYPE(uint32) TCustomCreateAccount_pid;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, CustomCreateAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strPrincipalName;
            _MSG_EXTRACT_VARIABLE(TCustomCreateAccount_strPrincipalName, strPrincipalName);
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TCustomCreateAccount_strKey, strKey);
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TCustomCreateAccount_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TCustomCreateAccount_strEmail, strEmail);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oAuthData;
            _MSG_EXTRACT_VARIABLE(TCustomCreateAccount_oAuthData, oAuthData);
            DDLTYPE(uint32)::CPPType pid;
            pProtocol->CustomCreateAccount( strPrincipalName, strKey, uiGroups, strEmail, oAuthData, &pid );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,CustomCreateAccount);
            _MSG_ADD_VARIABLE(TCustomCreateAccount_pid, pid);
        }
        
        typedef DDLTYPE(string) TNintendoCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TNintendoCreateAccount_strKey;
        typedef DDLTYPE(uint32) TNintendoCreateAccount_uiGroups;
        typedef DDLTYPE(string) TNintendoCreateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TNintendoCreateAccount_oAuthData;
        typedef DDLTYPE(uint32) TNintendoCreateAccount_pid;
        typedef DDLTYPE(string) TNintendoCreateAccount_pidHMAC;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, NintendoCreateAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strPrincipalName;
            _MSG_EXTRACT_VARIABLE(TNintendoCreateAccount_strPrincipalName, strPrincipalName);
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TNintendoCreateAccount_strKey, strKey);
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TNintendoCreateAccount_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TNintendoCreateAccount_strEmail, strEmail);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oAuthData;
            _MSG_EXTRACT_VARIABLE(TNintendoCreateAccount_oAuthData, oAuthData);
            DDLTYPE(uint32)::CPPType pid;
            DDLTYPE(string)::CPPType pidHMAC;
            pProtocol->NintendoCreateAccount( strPrincipalName, strKey, uiGroups, strEmail, oAuthData, &pid, &pidHMAC );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,NintendoCreateAccount);
            _MSG_ADD_VARIABLE(TNintendoCreateAccount_pid, pid);
            _MSG_ADD_VARIABLE(TNintendoCreateAccount_pidHMAC, pidHMAC);
        }
        
        typedef DDLTYPE(string) TLookupOrCreateAccount_strPrincipalName;
        typedef DDLTYPE(string) TLookupOrCreateAccount_strKey;
        typedef DDLTYPE(uint32) TLookupOrCreateAccount_uiGroups;
        typedef DDLTYPE(string) TLookupOrCreateAccount_strEmail;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TLookupOrCreateAccount_oAuthData;
        typedef DDLTYPE(uint32) TLookupOrCreateAccount_pid;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, LookupOrCreateAccount)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strPrincipalName;
            _MSG_EXTRACT_VARIABLE(TLookupOrCreateAccount_strPrincipalName, strPrincipalName);
            DDLTYPE(string)::CPPType strKey;
            _MSG_EXTRACT_VARIABLE(TLookupOrCreateAccount_strKey, strKey);
            DDLTYPE(uint32)::CPPType uiGroups;
            _MSG_EXTRACT_VARIABLE(TLookupOrCreateAccount_uiGroups, uiGroups);
            DDLTYPE(string)::CPPType strEmail;
            _MSG_EXTRACT_VARIABLE(TLookupOrCreateAccount_strEmail, strEmail);
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oAuthData;
            _MSG_EXTRACT_VARIABLE(TLookupOrCreateAccount_oAuthData, oAuthData);
            DDLTYPE(uint32)::CPPType pid;
            pProtocol->LookupOrCreateAccount( strPrincipalName, strKey, uiGroups, strEmail, oAuthData, &pid );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,LookupOrCreateAccount);
            _MSG_ADD_VARIABLE(TLookupOrCreateAccount_pid, pid);
        }
        
        typedef DDLTYPE(bool) TDisconnectPrincipal_result;
        typedef DDLTYPE(uint32) TDisconnectPrincipal_idPrincipal;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, DisconnectPrincipal)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idPrincipal;
            _MSG_EXTRACT_VARIABLE(TDisconnectPrincipal_idPrincipal, idPrincipal);
            DDLTYPE(bool)::CPPType __result=pProtocol->DisconnectPrincipal( idPrincipal );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,DisconnectPrincipal);
            _MSG_ADD_VARIABLE(TDisconnectPrincipal_result,__result);
        }
        
        typedef DDLTYPE(bool) TDisconnectAllPrincipals_result;
        PROTO_RMCIMPL_STUB(AccountManagementProtocol, DisconnectAllPrincipals)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->DisconnectAllPrincipals(  );
            PROTO_PREPARE_RETURN(AccountManagementProtocol,DisconnectAllPrincipals);
            _MSG_ADD_VARIABLE(TDisconnectAllPrincipals_result,__result);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(qresult)::CPPType CreateAccount(const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail) = 0;
        virtual void DeleteAccount(const DDLTYPE(uint32)::CPPType& idPrincipal) = 0;
        virtual DDLTYPE(qresult)::CPPType DisableAccount(const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtUntil, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual DDLTYPE(bool)::CPPType ChangePassword(const DDLTYPE(string)::CPPType& strNewKey) = 0;
        virtual DDLTYPE(bool)::CPPType TestCapability(const DDLTYPE(uint32)::CPPType& uiCapability) = 0;
        virtual void GetName(const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(string)::CPPType* strName) = 0;
        virtual DDLTYPE(qresult)::CPPType GetAccountData(AccountData* oAccountData) = 0;
        virtual DDLTYPE(bool)::CPPType GetPrivateData(DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oData) = 0;
        virtual DDLTYPE(bool)::CPPType GetPublicData(const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oData) = 0;
        virtual DDLTYPE(bool)::CPPType GetMultiplePublicData(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > >::CPPType* oData) = 0;
        virtual DDLTYPE(qresult)::CPPType UpdateAccountName(const DDLTYPE(string)::CPPType& strName) = 0;
        virtual DDLTYPE(qresult)::CPPType UpdateAccountEmail(const DDLTYPE(string)::CPPType& strName) = 0;
        virtual DDLTYPE(qresult)::CPPType UpdateCustomData(const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData) = 0;
        virtual void FindByNameRegex(const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strRegex, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType* plstAccounts) = 0;
        virtual void UpdateAccountExpiryDate(const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtExpiry, const DDLTYPE(string)::CPPType& strExpiredMessage) = 0;
        virtual void UpdateAccountEffectiveDate(const DDLTYPE(uint32)::CPPType& idPrincipal, const DDLTYPE(datetime)::CPPType& dtEffectiveFrom, const DDLTYPE(string)::CPPType& strNotEffectiveMessage) = 0;
        virtual void UpdateStatus(const DDLTYPE(string)::CPPType& strStatus) = 0;
        virtual void GetStatus(const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(string)::CPPType* strStatus) = 0;
        virtual void GetLastConnectionStats(const DDLTYPE(uint32)::CPPType& idPrincipal, DDLTYPE(datetime)::CPPType* dtLastSessionLogin, DDLTYPE(datetime)::CPPType* dtLastSessionLogout, DDLTYPE(datetime)::CPPType* dtCurrentSessionLogin) = 0;
        virtual DDLTYPE(bool)::CPPType ResetPassword() = 0;
        virtual void CreateAccountWithCustomData(const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData) = 0;
        virtual void RetrieveAccount(AccountData* oAccountData, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oPublicData, DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType* oPrivateData) = 0;
        virtual void UpdateAccount(const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPublicData, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oPrivateData) = 0;
        virtual void ChangePasswordByGuest(const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(string)::CPPType& strKey) = 0;
        virtual void FindByNameLike(const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strLike, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(BasicAccountInfo) >::CPPType* plstAccounts) = 0;
        virtual void CustomCreateAccount(const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid) = 0;
        virtual void NintendoCreateAccount(const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid, DDLTYPE(string)::CPPType* pidHMAC) = 0;
        virtual void LookupOrCreateAccount(const DDLTYPE(string)::CPPType& strPrincipalName, const DDLTYPE(string)::CPPType& strKey, const DDLTYPE(uint32)::CPPType& uiGroups, const DDLTYPE(string)::CPPType& strEmail, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oAuthData, DDLTYPE(uint32)::CPPType* pid) = 0;
        virtual DDLTYPE(bool)::CPPType DisconnectPrincipal(const DDLTYPE(uint32)::CPPType& idPrincipal) = 0;
        virtual DDLTYPE(bool)::CPPType DisconnectAllPrincipals() = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_CreateAccountProfilingUnit;
        ProfilingUnit m_DeleteAccountProfilingUnit;
        ProfilingUnit m_DisableAccountProfilingUnit;
        ProfilingUnit m_ChangePasswordProfilingUnit;
        ProfilingUnit m_TestCapabilityProfilingUnit;
        ProfilingUnit m_GetNameProfilingUnit;
        ProfilingUnit m_GetAccountDataProfilingUnit;
        ProfilingUnit m_GetPrivateDataProfilingUnit;
        ProfilingUnit m_GetPublicDataProfilingUnit;
        ProfilingUnit m_GetMultiplePublicDataProfilingUnit;
        ProfilingUnit m_UpdateAccountNameProfilingUnit;
        ProfilingUnit m_UpdateAccountEmailProfilingUnit;
        ProfilingUnit m_UpdateCustomDataProfilingUnit;
        ProfilingUnit m_FindByNameRegexProfilingUnit;
        ProfilingUnit m_UpdateAccountExpiryDateProfilingUnit;
        ProfilingUnit m_UpdateAccountEffectiveDateProfilingUnit;
        ProfilingUnit m_UpdateStatusProfilingUnit;
        ProfilingUnit m_GetStatusProfilingUnit;
        ProfilingUnit m_GetLastConnectionStatsProfilingUnit;
        ProfilingUnit m_ResetPasswordProfilingUnit;
        ProfilingUnit m_CreateAccountWithCustomDataProfilingUnit;
        ProfilingUnit m_RetrieveAccountProfilingUnit;
        ProfilingUnit m_UpdateAccountProfilingUnit;
        ProfilingUnit m_ChangePasswordByGuestProfilingUnit;
        ProfilingUnit m_FindByNameLikeProfilingUnit;
        ProfilingUnit m_CustomCreateAccountProfilingUnit;
        ProfilingUnit m_NintendoCreateAccountProfilingUnit;
        ProfilingUnit m_LookupOrCreateAccountProfilingUnit;
        ProfilingUnit m_DisconnectPrincipalProfilingUnit;
        ProfilingUnit m_DisconnectAllPrincipalsProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
