﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Common/RemoteLogDeviceProtocolDDL.h>
#include <RendezVous/Core/src/Client/RemoteLogDeviceLogsCallback.h>
#include <OnlineCore/src/Platform/Core/String.h>
#include <OnlineCore/src/Platform/Core/qVector.h>
#include <OnlineCore/src/Platform/Core/qMultiMap.h>

BEGIN_NAMESPACE_NEX

class ClientProtocolRequestBroker;

class OSDK_API DDLPROTOCOL(RemoteLogDeviceProtocolServer);
class OSDK_API RemoteLogDeviceServer : public DDLPROTOCOL(RemoteLogDeviceProtocolServer)
{
public:
    RemoteLogDeviceServer();
    virtual ~RemoteLogDeviceServer();

    void SetLogsCallback(RemoteLogDeviceLogsCallback *pLogsCallback)
    {
        m_pLogsCallback = pLogsCallback;
    }

    virtual void Log(const String& strLine);
private:
    RemoteLogDeviceLogsCallback *m_pLogsCallback;
};

END_NAMESPACE_NEX
