﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Core/src/Client/RendezVousOperation.h>

BEGIN_NAMESPACE_NEX

/**
\ingroup group_rdv_core_client
\brief The RendezVousLoginOperation represent the login
process of RendezVous.  The operation begin before the argument
were validated and end at completion, either successful or failed.
The Credentials is valid only on successful login at the end of the
operation.  You can access them using the OperationManager from the
BackEndServices.

\sa OperationManager, OperationCallback
*/
class OSDK_API RendezVousLoginOperation : public RendezVousOperation
{
public:

    /** \internal */
    explicit RendezVousLoginOperation(BackEndServices& be);
    /** \internal */
    virtual ~RendezVousLoginOperation();

    NEX_IMPL_OPERATION_COMMON_METHODS(RendezVousLogin);
};

END_NAMESPACE_NEX

