﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Core/src/Client/RendezVousOperation.h>

BEGIN_NAMESPACE_NEX

/**
\ingroup group_rdv_core_client
\brief The RendezVousLogoutOperation represent the logout
process of RendezVous.  The operation begin at the start of the
process and end at completion, either successful or failed.  The
Credentials is valid only at the start of the operation (for
callback with a priority lesser than 0) and it's clear for the end
of the operation (priority greater than 0).

\sa OperationManager, OperationCallback
*/
class OSDK_API RendezVousLogoutOperation : public RendezVousOperation
{
public:

    /** \internal */
    explicit RendezVousLogoutOperation(BackEndServices& be);
    /** \internal */
    virtual ~RendezVousLogoutOperation();

    NEX_IMPL_OPERATION_COMMON_METHODS(RendezVousLogout);
};

END_NAMESPACE_NEX

