﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class  ServicePortOffsets
{
public:
#else
namespace ServicePortOffsets
{
#endif
    enum
    {
        Base                        = 0,    // BasePort
        Authentication              = 0,    // UDP UDP利用時のAuth用。
        PRUDPS                      = 1,    // UDP UDP利用時のSecure用。CombineAuthAndServiceNodeがTrueの場合は使用されない。
        TcpAuthentication           = 0,    // TCP TCP利用時のAuth用。
        WebSocketAuthentication     = 0,    // TCP WebSocket利用時のAuth用。
        HttpHealthCheck             = 0,    // TCP(HTTP) UDPやWebSocket利用時のHealthCheck用
        ZeroMQ                      = 1,    // TCP
        RendezVousManagementConsole = 3,    // TCP
        WebRpc                      = 4,    // TCP WebRpc(NEXのJsonRpc)用ポート
        WebApi                      = 5,    // TCP WebApi用ポートオフセット。
        TcpPRUDPS                   = 6,    // TCP TCP利用時のSecure用。CombineAuthAndServiceNodeがTrueの場合は使用されない。
        WebSocketPRUDPS             = 6,    // TCP WebSocket利用時のSecure用。CombineAuthAndServiceNodeがTrueの場合は使用されない。
        WebSocketSorryForTests      = 8,    // TCP WebSocketのテスト用ソーリーサーバが使うポート。製品では使用されないが、被らないように定義しておく。
        WebApiForUnitTests          = 9     // TCP UnitTestsでのWebAPIのテストをする場合に使用される。製品では使用されないが、被らないように定義しておく。

    };
#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

