﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include "ProtocolFoundationDDF.h"

#include <RendezVous/Core/src/Common/AnyObjectHolder.h>

BEGIN_NAMESPACE_NEX

template<class ROOT,class TYPE>
class DDLTYPE(any): public DDLType
{
public:
    typedef typename ROOT::CPPType Any;
    typedef typename TYPE::CPPType Type;
    typedef AnyObjectHolder<Any,Type> CPPType;
    static void Add(Message* pMessageToSend, const AnyObjectHolder<Any,Type>& oValue)
    {
        oValue.StreamIn(pMessageToSend);
    }
    static void Extract(Message* pReceivedMessage, AnyObjectHolder<Any,Type> *pValue)
    {
        pValue->StreamOut(pReceivedMessage);
    }
};

END_NAMESPACE_NEX

