﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/*!
 @file
 */
/*
    \ingroup group_rdv_core_common
    \brief Defines the default ResultRange size, which by default is equal to 20.
*/

/*!
 @brief    デフォルトの検索結果のリストサイズです。
 */
#define RESULTRANGE_DEFAULT_SIZE        20

/*
    \brief Defines a pseudo random ResultRange offset.
    \remarks When this offset is set, \productname uses a pseudo random offset when returning
    the ResultRange.
*/

/*!
 @brief    検索結果を無作為に並び替えるためのダミーのオフセット値です。

 この値を ResultRange オブジェクトのオフセットに指定することで、サーバー上で
 検索結果全体を無作為に並び替えた上で、リストサイズ分の結果をクライアントに返します。
 */
#define RESULTRANGE_ANY_OFFSET          0xFFFFFFFFUL

END_NAMESPACE_NEX


