#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/STLExtTypes.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "ConnectionDataDDL.h"
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Core/src/Common/Data.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(SecureConnectionProtocol, Register, 1 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, RequestConnectionData, 2 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, RequestURLs, 3 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, RegisterEx, 4 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, TestConnectivity, 5 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, UpdateURLs, 6 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, ReplaceURL, 7 );
PROTO_DEFINE_RMCID(SecureConnectionProtocol, SendReport, 8 );
PROTO_DEFINE_NUM_RMC(SecureConnectionProtocol, 8);

class SecureConnectionProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(qresult) TRegister_result;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRegister_vecMyURLs;
        typedef DDLTYPE(uint32) TRegister_pidConnectionID;
        typedef DDLTYPE(stationurl) TRegister_urlPublic;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, Register)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRegister_result,1);
            _DO_RMC_ExtractReturnValue(TRegister_pidConnectionID,1);
            _DO_RMC_ExtractReturnValue(TRegister_urlPublic,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TRequestConnectionData_result;
        typedef DDLTYPE(uint32) TRequestConnectionData_cidTarget;
        typedef DDLTYPE(uint32) TRequestConnectionData_pidTarget;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(ConnectionData) > TRequestConnectionData_pvecConnectionsData;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, RequestConnectionData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRequestConnectionData_result,1);
            _DO_RMC_ExtractReturnValue(TRequestConnectionData_pvecConnectionsData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TRequestURLs_result;
        typedef DDLTYPE(uint32) TRequestURLs_cidTarget;
        typedef DDLTYPE(uint32) TRequestURLs_pidTarget;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRequestURLs_plstURLs;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, RequestURLs)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRequestURLs_result,1);
            _DO_RMC_ExtractReturnValue(TRequestURLs_plstURLs,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TRegisterEx_result;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRegisterEx_vecMyURLs;
        typedef DDLTYPE(uint32) TRegisterEx_pidConnectionID;
        typedef DDLTYPE(stationurl) TRegisterEx_urlPublic;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TRegisterEx_hCustomData;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, RegisterEx)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRegisterEx_result,1);
            _DO_RMC_ExtractReturnValue(TRegisterEx_pidConnectionID,1);
            _DO_RMC_ExtractReturnValue(TRegisterEx_urlPublic,1);
            PROTO_RETURNSTUB_END();
        };
        
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, TestConnectivity)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TUpdateURLs_vecMyURLs;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, UpdateURLs)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(stationurl) TReplaceURL_target;
        typedef DDLTYPE(stationurl) TReplaceURL_url;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, ReplaceURL)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TSendReport_reportId;
        typedef DDLTYPE(qBuffer) TSendReport_reportData;
        PROTO_RMCIMPL_RETURN(SecureConnectionProtocol, SendReport)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        SecureConnectionProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew SecureConnectionProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallRegister(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs, DDLTYPE(uint32)::CPPType* pidConnectionID, DDLTYPE(stationurl)::CPPType* urlPublic);
        static qBool Register_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs, DDLTYPE(uint32)::CPPType* pidConnectionID, DDLTYPE(stationurl)::CPPType* urlPublic);
        qBool CallRequestConnectionData(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& cidTarget, const DDLTYPE(uint32)::CPPType& pidTarget, DDLTYPE(std_list)< CLASSMETATYPE(ConnectionData) >::CPPType* pvecConnectionsData);
        static qBool RequestConnectionData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& cidTarget, const DDLTYPE(uint32)::CPPType& pidTarget, DDLTYPE(std_list)< CLASSMETATYPE(ConnectionData) >::CPPType* pvecConnectionsData);
        qBool CallRequestURLs(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& cidTarget, const DDLTYPE(uint32)::CPPType& pidTarget, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* plstURLs);
        static qBool RequestURLs_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& cidTarget, const DDLTYPE(uint32)::CPPType& pidTarget, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* plstURLs);
        qBool CallRegisterEx(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs, DDLTYPE(uint32)::CPPType* pidConnectionID, DDLTYPE(stationurl)::CPPType* urlPublic, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& hCustomData);
        static qBool RegisterEx_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs, DDLTYPE(uint32)::CPPType* pidConnectionID, DDLTYPE(stationurl)::CPPType* urlPublic, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& hCustomData);
        qBool CallTestConnectivity(ProtocolCallContext *pContext);
        static qBool TestConnectivity_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg);
        qBool CallUpdateURLs(ProtocolCallContext *pContext, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs);
        static qBool UpdateURLs_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs);
        qBool CallReplaceURL(ProtocolCallContext *pContext, const DDLTYPE(stationurl)::CPPType& target, const DDLTYPE(stationurl)::CPPType& url);
        static qBool ReplaceURL_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(stationurl)::CPPType& target, const DDLTYPE(stationurl)::CPPType& url);
        qBool CallSendReport(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& reportId, const DDLTYPE(qBuffer)::CPPType& reportData);
        static qBool SendReport_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& reportId, const DDLTYPE(qBuffer)::CPPType& reportData);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(SecureConnectionProtocol) + 1];
};

class DDLPROTOCOL(SecureConnectionProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(SecureConnectionProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_RegisterProfilingUnit(NEX_T("SecureConnectionProtocol::Register"))
            , m_RequestConnectionDataProfilingUnit(NEX_T("SecureConnectionProtocol::RequestConnectionData"))
            , m_RequestURLsProfilingUnit(NEX_T("SecureConnectionProtocol::RequestURLs"))
            , m_RegisterExProfilingUnit(NEX_T("SecureConnectionProtocol::RegisterEx"))
            , m_TestConnectivityProfilingUnit(NEX_T("SecureConnectionProtocol::TestConnectivity"))
            , m_UpdateURLsProfilingUnit(NEX_T("SecureConnectionProtocol::UpdateURLs"))
            , m_ReplaceURLProfilingUnit(NEX_T("SecureConnectionProtocol::ReplaceURL"))
            , m_SendReportProfilingUnit(NEX_T("SecureConnectionProtocol::SendReport"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(qresult) TRegister_result;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRegister_vecMyURLs;
        typedef DDLTYPE(uint32) TRegister_pidConnectionID;
        typedef DDLTYPE(stationurl) TRegister_urlPublic;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, Register)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType vecMyURLs;
            _MSG_EXTRACT_VARIABLE(TRegister_vecMyURLs, vecMyURLs);
            DDLTYPE(uint32)::CPPType pidConnectionID;
            DDLTYPE(stationurl)::CPPType urlPublic;
            DDLTYPE(qresult)::CPPType __result=pProtocol->Register( vecMyURLs, &pidConnectionID, &urlPublic );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,Register);
            _MSG_ADD_VARIABLE(TRegister_result,__result);
            _MSG_ADD_VARIABLE(TRegister_pidConnectionID, pidConnectionID);
            _MSG_ADD_VARIABLE(TRegister_urlPublic, urlPublic);
        }
        
        typedef DDLTYPE(bool) TRequestConnectionData_result;
        typedef DDLTYPE(uint32) TRequestConnectionData_cidTarget;
        typedef DDLTYPE(uint32) TRequestConnectionData_pidTarget;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(ConnectionData) > TRequestConnectionData_pvecConnectionsData;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, RequestConnectionData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType cidTarget;
            _MSG_EXTRACT_VARIABLE(TRequestConnectionData_cidTarget, cidTarget);
            DDLTYPE(uint32)::CPPType pidTarget;
            _MSG_EXTRACT_VARIABLE(TRequestConnectionData_pidTarget, pidTarget);
            DDLTYPE(std_list)< CLASSMETATYPE(ConnectionData) >::CPPType pvecConnectionsData;
            DDLTYPE(bool)::CPPType __result=pProtocol->RequestConnectionData( cidTarget, pidTarget, &pvecConnectionsData );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,RequestConnectionData);
            _MSG_ADD_VARIABLE(TRequestConnectionData_result,__result);
            _MSG_ADD_VARIABLE(TRequestConnectionData_pvecConnectionsData, pvecConnectionsData);
        }
        
        typedef DDLTYPE(bool) TRequestURLs_result;
        typedef DDLTYPE(uint32) TRequestURLs_cidTarget;
        typedef DDLTYPE(uint32) TRequestURLs_pidTarget;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRequestURLs_plstURLs;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, RequestURLs)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType cidTarget;
            _MSG_EXTRACT_VARIABLE(TRequestURLs_cidTarget, cidTarget);
            DDLTYPE(uint32)::CPPType pidTarget;
            _MSG_EXTRACT_VARIABLE(TRequestURLs_pidTarget, pidTarget);
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType plstURLs;
            DDLTYPE(bool)::CPPType __result=pProtocol->RequestURLs( cidTarget, pidTarget, &plstURLs );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,RequestURLs);
            _MSG_ADD_VARIABLE(TRequestURLs_result,__result);
            _MSG_ADD_VARIABLE(TRequestURLs_plstURLs, plstURLs);
        }
        
        typedef DDLTYPE(qresult) TRegisterEx_result;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRegisterEx_vecMyURLs;
        typedef DDLTYPE(uint32) TRegisterEx_pidConnectionID;
        typedef DDLTYPE(stationurl) TRegisterEx_urlPublic;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TRegisterEx_hCustomData;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, RegisterEx)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType vecMyURLs;
            _MSG_EXTRACT_VARIABLE(TRegisterEx_vecMyURLs, vecMyURLs);
            DDLTYPE(uint32)::CPPType pidConnectionID;
            DDLTYPE(stationurl)::CPPType urlPublic;
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType hCustomData;
            _MSG_EXTRACT_VARIABLE(TRegisterEx_hCustomData, hCustomData);
            DDLTYPE(qresult)::CPPType __result=pProtocol->RegisterEx( vecMyURLs, &pidConnectionID, &urlPublic, hCustomData );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,RegisterEx);
            _MSG_ADD_VARIABLE(TRegisterEx_result,__result);
            _MSG_ADD_VARIABLE(TRegisterEx_pidConnectionID, pidConnectionID);
            _MSG_ADD_VARIABLE(TRegisterEx_urlPublic, urlPublic);
        }
        
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, TestConnectivity)
        {
            PROTO_PREPARE_EXTRACTION();
            pProtocol->TestConnectivity(  );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,TestConnectivity);
        }
        
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TUpdateURLs_vecMyURLs;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, UpdateURLs)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType vecMyURLs;
            _MSG_EXTRACT_VARIABLE(TUpdateURLs_vecMyURLs, vecMyURLs);
            pProtocol->UpdateURLs( vecMyURLs );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,UpdateURLs);
        }
        
        typedef DDLTYPE(stationurl) TReplaceURL_target;
        typedef DDLTYPE(stationurl) TReplaceURL_url;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, ReplaceURL)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(stationurl)::CPPType target;
            _MSG_EXTRACT_VARIABLE(TReplaceURL_target, target);
            DDLTYPE(stationurl)::CPPType url;
            _MSG_EXTRACT_VARIABLE(TReplaceURL_url, url);
            pProtocol->ReplaceURL( target, url );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,ReplaceURL);
        }
        
        typedef DDLTYPE(uint32) TSendReport_reportId;
        typedef DDLTYPE(qBuffer) TSendReport_reportData;
        PROTO_RMCIMPL_STUB(SecureConnectionProtocol, SendReport)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType reportId;
            _MSG_EXTRACT_VARIABLE(TSendReport_reportId, reportId);
            DDLTYPE(qBuffer)::CPPType reportData;
            _MSG_EXTRACT_VARIABLE(TSendReport_reportData, reportData);
            pProtocol->SendReport( reportId, reportData );
            PROTO_PREPARE_RETURN(SecureConnectionProtocol,SendReport);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(qresult)::CPPType Register(const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs, DDLTYPE(uint32)::CPPType* pidConnectionID, DDLTYPE(stationurl)::CPPType* urlPublic) = 0;
        virtual DDLTYPE(bool)::CPPType RequestConnectionData(const DDLTYPE(uint32)::CPPType& cidTarget, const DDLTYPE(uint32)::CPPType& pidTarget, DDLTYPE(std_list)< CLASSMETATYPE(ConnectionData) >::CPPType* pvecConnectionsData) = 0;
        virtual DDLTYPE(bool)::CPPType RequestURLs(const DDLTYPE(uint32)::CPPType& cidTarget, const DDLTYPE(uint32)::CPPType& pidTarget, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* plstURLs) = 0;
        virtual DDLTYPE(qresult)::CPPType RegisterEx(const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs, DDLTYPE(uint32)::CPPType* pidConnectionID, DDLTYPE(stationurl)::CPPType* urlPublic, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& hCustomData) = 0;
        virtual void TestConnectivity() = 0;
        virtual void UpdateURLs(const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& vecMyURLs) = 0;
        virtual void ReplaceURL(const DDLTYPE(stationurl)::CPPType& target, const DDLTYPE(stationurl)::CPPType& url) = 0;
        virtual void SendReport(const DDLTYPE(uint32)::CPPType& reportId, const DDLTYPE(qBuffer)::CPPType& reportData) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_RegisterProfilingUnit;
        ProfilingUnit m_RequestConnectionDataProfilingUnit;
        ProfilingUnit m_RequestURLsProfilingUnit;
        ProfilingUnit m_RegisterExProfilingUnit;
        ProfilingUnit m_TestConnectivityProfilingUnit;
        ProfilingUnit m_UpdateURLsProfilingUnit;
        ProfilingUnit m_ReplaceURLProfilingUnit;
        ProfilingUnit m_SendReportProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
