﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Common/Constants/ServicePortOffsets.h>
#include <OnlineCore/src/Platform/Stack/Core/TransportProtocol.h>
    
BEGIN_NAMESPACE_NEX

// 待ち受けポートが提供するサービスの種類
enum ServicePortType
{
    SERVICE_PORT_TYPE_AUTHENTICATION,   // Auth用
    SERVICE_PORT_TYPE_PRUDPS,           // PRUDPS用
    SERVICE_PORT_TYPE_WEBAPI,           // WebAPI用
    SERVICE_PORT_TYPE_COUNT             // ServicePortTypeの定義数
};

// 待ち受けポートが提供するサービスの種類からポートオフセットに変換するユーティリティクラス
class ServicePortOffsetConverter: public RootObject
{
    // サービスの種類とプロトコルからポートオフセットを引くテーブル
    static qUnsignedInt16 s_portOffsetMap[SERVICE_PORT_TYPE_COUNT][TransportProtocol::TYPE_COUNT];

public:
    static qUnsignedInt16 ServicePortTypeToOffset(ServicePortType servicePortType, TransportProtocol::Type transportProtocolType);
};

END_NAMESPACE_NEX
