#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "RVConnectionDataDDL.h"
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Core/src/Common/Data.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(TicketGrantingProtocol, ValidateAndRequestTicket, 1 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, ValidateAndRequestTicketWithCustomData, 2 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, RequestTicket, 3 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, GetPID, 4 );
PROTO_DEFINE_RMCID(TicketGrantingProtocol, GetName, 5 );
PROTO_DEFINE_NUM_RMC(TicketGrantingProtocol, 5);

class TicketGrantingProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(qresult) TValidateAndRequestTicket_result;
        typedef DDLTYPE(string) TValidateAndRequestTicket_strUserName;
        typedef DDLTYPE(uint32) TValidateAndRequestTicket_pidPrincipal;
        typedef DDLTYPE(buffer) TValidateAndRequestTicket_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TValidateAndRequestTicket_pConnectionData;
        typedef DDLTYPE(string) TValidateAndRequestTicket_strReturnMsg;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, ValidateAndRequestTicket)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicket_result,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicket_pidPrincipal,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicket_pbufResponse,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicket_pConnectionData,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicket_strReturnMsg,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TValidateAndRequestTicketWithCustomData_result;
        typedef DDLTYPE(string) TValidateAndRequestTicketWithCustomData_strUserName;
        typedef DDLTYPE(uint32) TValidateAndRequestTicketWithCustomData_pidPrincipal;
        typedef DDLTYPE(buffer) TValidateAndRequestTicketWithCustomData_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TValidateAndRequestTicketWithCustomData_pConnectionData;
        typedef DDLTYPE(string) TValidateAndRequestTicketWithCustomData_strReturnMsg;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TValidateAndRequestTicketWithCustomData_oExtraData;
        typedef DDLTYPE(string) TValidateAndRequestTicketWithCustomData_pSourceKey;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, ValidateAndRequestTicketWithCustomData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicketWithCustomData_result,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicketWithCustomData_pidPrincipal,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicketWithCustomData_pbufResponse,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicketWithCustomData_pConnectionData,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicketWithCustomData_strReturnMsg,1);
            _DO_RMC_ExtractReturnValue(TValidateAndRequestTicketWithCustomData_pSourceKey,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qresult) TRequestTicket_result;
        typedef DDLTYPE(uint32) TRequestTicket_idSource;
        typedef DDLTYPE(uint32) TRequestTicket_idTarget;
        typedef DDLTYPE(buffer) TRequestTicket_bufResponse;
        typedef DDLTYPE(string) TRequestTicket_pSourceKey;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, RequestTicket)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRequestTicket_result,1);
            _DO_RMC_ExtractReturnValue(TRequestTicket_bufResponse,1);
            _DO_RMC_ExtractReturnValue(TRequestTicket_pSourceKey,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPID_result;
        typedef DDLTYPE(string) TGetPID_strUserName;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, GetPID)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPID_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TGetName_result;
        typedef DDLTYPE(uint32) TGetName_id;
        PROTO_RMCIMPL_RETURN(TicketGrantingProtocol, GetName)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetName_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        TicketGrantingProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew TicketGrantingProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallValidateAndRequestTicket(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg);
        static qBool ValidateAndRequestTicket_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg);
        qBool CallValidateAndRequestTicketWithCustomData(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oExtraData, DDLTYPE(string)::CPPType* pSourceKey);
        static qBool ValidateAndRequestTicketWithCustomData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oExtraData, DDLTYPE(string)::CPPType* pSourceKey);
        qBool CallRequestTicket(ProtocolCallContext *pContext, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idSource, const DDLTYPE(uint32)::CPPType& idTarget, DDLTYPE(buffer)::CPPType* bufResponse, DDLTYPE(string)::CPPType* pSourceKey);
        static qBool RequestTicket_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(qresult)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idSource, const DDLTYPE(uint32)::CPPType& idTarget, DDLTYPE(buffer)::CPPType* bufResponse, DDLTYPE(string)::CPPType* pSourceKey);
        qBool CallGetPID(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName);
        static qBool GetPID_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType *pReturn, const DDLTYPE(string)::CPPType& strUserName);
        qBool CallGetName(ProtocolCallContext *pContext, DDLTYPE(string)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& id);
        static qBool GetName_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(string)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& id);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(TicketGrantingProtocol) + 1];
};

class DDLPROTOCOL(TicketGrantingProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(TicketGrantingProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_ValidateAndRequestTicketProfilingUnit(NEX_T("TicketGrantingProtocol::ValidateAndRequestTicket"))
            , m_ValidateAndRequestTicketWithCustomDataProfilingUnit(NEX_T("TicketGrantingProtocol::ValidateAndRequestTicketWithCustomData"))
            , m_RequestTicketProfilingUnit(NEX_T("TicketGrantingProtocol::RequestTicket"))
            , m_GetPIDProfilingUnit(NEX_T("TicketGrantingProtocol::GetPID"))
            , m_GetNameProfilingUnit(NEX_T("TicketGrantingProtocol::GetName"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(qresult) TValidateAndRequestTicket_result;
        typedef DDLTYPE(string) TValidateAndRequestTicket_strUserName;
        typedef DDLTYPE(uint32) TValidateAndRequestTicket_pidPrincipal;
        typedef DDLTYPE(buffer) TValidateAndRequestTicket_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TValidateAndRequestTicket_pConnectionData;
        typedef DDLTYPE(string) TValidateAndRequestTicket_strReturnMsg;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, ValidateAndRequestTicket)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strUserName;
            _MSG_EXTRACT_VARIABLE(TValidateAndRequestTicket_strUserName, strUserName);
            DDLTYPE(uint32)::CPPType pidPrincipal;
            DDLTYPE(buffer)::CPPType pbufResponse;
            RVConnectionData pConnectionData;
            DDLTYPE(string)::CPPType strReturnMsg;
            DDLTYPE(qresult)::CPPType __result=pProtocol->ValidateAndRequestTicket( strUserName, &pidPrincipal, &pbufResponse, &pConnectionData, &strReturnMsg );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,ValidateAndRequestTicket);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicket_result,__result);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicket_pidPrincipal, pidPrincipal);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicket_pbufResponse, pbufResponse);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicket_pConnectionData, pConnectionData);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicket_strReturnMsg, strReturnMsg);
        }
        
        typedef DDLTYPE(qresult) TValidateAndRequestTicketWithCustomData_result;
        typedef DDLTYPE(string) TValidateAndRequestTicketWithCustomData_strUserName;
        typedef DDLTYPE(uint32) TValidateAndRequestTicketWithCustomData_pidPrincipal;
        typedef DDLTYPE(buffer) TValidateAndRequestTicketWithCustomData_pbufResponse;
        typedef CLASSMETATYPE(RVConnectionData) TValidateAndRequestTicketWithCustomData_pConnectionData;
        typedef DDLTYPE(string) TValidateAndRequestTicketWithCustomData_strReturnMsg;
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TValidateAndRequestTicketWithCustomData_oExtraData;
        typedef DDLTYPE(string) TValidateAndRequestTicketWithCustomData_pSourceKey;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, ValidateAndRequestTicketWithCustomData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strUserName;
            _MSG_EXTRACT_VARIABLE(TValidateAndRequestTicketWithCustomData_strUserName, strUserName);
            DDLTYPE(uint32)::CPPType pidPrincipal;
            DDLTYPE(buffer)::CPPType pbufResponse;
            RVConnectionData pConnectionData;
            DDLTYPE(string)::CPPType strReturnMsg;
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oExtraData;
            _MSG_EXTRACT_VARIABLE(TValidateAndRequestTicketWithCustomData_oExtraData, oExtraData);
            DDLTYPE(string)::CPPType pSourceKey;
            DDLTYPE(qresult)::CPPType __result=pProtocol->ValidateAndRequestTicketWithCustomData( strUserName, &pidPrincipal, &pbufResponse, &pConnectionData, &strReturnMsg, oExtraData, &pSourceKey );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,ValidateAndRequestTicketWithCustomData);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicketWithCustomData_result,__result);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicketWithCustomData_pidPrincipal, pidPrincipal);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicketWithCustomData_pbufResponse, pbufResponse);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicketWithCustomData_pConnectionData, pConnectionData);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicketWithCustomData_strReturnMsg, strReturnMsg);
            _MSG_ADD_VARIABLE(TValidateAndRequestTicketWithCustomData_pSourceKey, pSourceKey);
        }
        
        typedef DDLTYPE(qresult) TRequestTicket_result;
        typedef DDLTYPE(uint32) TRequestTicket_idSource;
        typedef DDLTYPE(uint32) TRequestTicket_idTarget;
        typedef DDLTYPE(buffer) TRequestTicket_bufResponse;
        typedef DDLTYPE(string) TRequestTicket_pSourceKey;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, RequestTicket)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idSource;
            _MSG_EXTRACT_VARIABLE(TRequestTicket_idSource, idSource);
            DDLTYPE(uint32)::CPPType idTarget;
            _MSG_EXTRACT_VARIABLE(TRequestTicket_idTarget, idTarget);
            DDLTYPE(buffer)::CPPType bufResponse;
            DDLTYPE(string)::CPPType pSourceKey;
            DDLTYPE(qresult)::CPPType __result=pProtocol->RequestTicket( idSource, idTarget, &bufResponse, &pSourceKey );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,RequestTicket);
            _MSG_ADD_VARIABLE(TRequestTicket_result,__result);
            _MSG_ADD_VARIABLE(TRequestTicket_bufResponse, bufResponse);
            _MSG_ADD_VARIABLE(TRequestTicket_pSourceKey, pSourceKey);
        }
        
        typedef DDLTYPE(uint32) TGetPID_result;
        typedef DDLTYPE(string) TGetPID_strUserName;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, GetPID)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strUserName;
            _MSG_EXTRACT_VARIABLE(TGetPID_strUserName, strUserName);
            DDLTYPE(uint32)::CPPType __result=pProtocol->GetPID( strUserName );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,GetPID);
            _MSG_ADD_VARIABLE(TGetPID_result,__result);
        }
        
        typedef DDLTYPE(string) TGetName_result;
        typedef DDLTYPE(uint32) TGetName_id;
        PROTO_RMCIMPL_STUB(TicketGrantingProtocol, GetName)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TGetName_id, id);
            DDLTYPE(string)::CPPType __result=pProtocol->GetName( id );
            PROTO_PREPARE_RETURN(TicketGrantingProtocol,GetName);
            _MSG_ADD_VARIABLE(TGetName_result,__result);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(qresult)::CPPType ValidateAndRequestTicket(const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg) = 0;
        virtual DDLTYPE(qresult)::CPPType ValidateAndRequestTicketWithCustomData(const DDLTYPE(string)::CPPType& strUserName, DDLTYPE(uint32)::CPPType* pidPrincipal, DDLTYPE(buffer)::CPPType* pbufResponse, RVConnectionData* pConnectionData, DDLTYPE(string)::CPPType* strReturnMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oExtraData, DDLTYPE(string)::CPPType* pSourceKey) = 0;
        virtual DDLTYPE(qresult)::CPPType RequestTicket(const DDLTYPE(uint32)::CPPType& idSource, const DDLTYPE(uint32)::CPPType& idTarget, DDLTYPE(buffer)::CPPType* bufResponse, DDLTYPE(string)::CPPType* pSourceKey) = 0;
        virtual DDLTYPE(uint32)::CPPType GetPID(const DDLTYPE(string)::CPPType& strUserName) = 0;
        virtual DDLTYPE(string)::CPPType GetName(const DDLTYPE(uint32)::CPPType& id) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_ValidateAndRequestTicketProfilingUnit;
        ProfilingUnit m_ValidateAndRequestTicketWithCustomDataProfilingUnit;
        ProfilingUnit m_RequestTicketProfilingUnit;
        ProfilingUnit m_GetPIDProfilingUnit;
        ProfilingUnit m_GetNameProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
