﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Services/Jugem/Authentication/src/Common/AuthenticationInfoDDL.h>
#include <OnlineCore/src/version/nex_version.h>

BEGIN_NAMESPACE_NEX

class AuthenticationInfo: public DDLCLASS(AuthenticationInfo)
{
public:
    enum AuthTokenType
    {
        AUTH_TOKEN_TYPE_NAS = 0,    //!< NAS(CTR向け)
        AUTH_TOKEN_TYPE_NNAS = 1,   //!< NNAS(Cafe向け)
        AUTH_TOKEN_TYPE_AA = 2      //!< AA(NX向け)
    };
    AuthenticationInfo()
    {
        Clear();
    }
    virtual ~AuthenticationInfo() {}

    void Clear()
    {
        m_authToken = NEX_T("");
        m_ngsVersion = NEX_VERSION_DDL;
        m_serverVersion = NEX_VERSION_SERVER;
#ifdef CAFE_TARGET
        m_authTokenType = AUTH_TOKEN_TYPE_NNAS;
#elif defined(NEX_SIGLO_FAMILY)
        m_authTokenType = AUTH_TOKEN_TYPE_AA;
#else
        m_authTokenType = AUTH_TOKEN_TYPE_NAS;
#endif
    }

    const String& GetAuthToken()
    {
        return m_authToken;
    }
    void SetAuthToken(const String& authToken)
    {
        m_authToken = authToken;
    }
    qByte GetAuthTokenType() const
    {
        return m_authTokenType;
    }
    void SetAuthTokenType(qByte authTokenType)
    {
        m_authTokenType = authTokenType;
    }
};

END_NAMESPACE_NEX

