#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "DataStorePrepareGetParamV1.h"
#include "DataStoreReqGetInfoV1.h"
#include "DataStorePreparePostParamV1.h"
#include "DataStoreReqPostInfoV1DDL.h"
#include "DataStoreCompletePostParamV1.h"
#include "DataStoreDeleteParam.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "DataStoreChangeMetaParamV1.h"
#include "DataStoreGetMetaParam.h"
#include "DataStoreMetaInfo.h"
#include "DataStorePrepareUpdateParam.h"
#include "DataStoreReqUpdateInfoDDL.h"
#include "DataStoreCompleteUpdateParamDDL.h"
#include "DataStoreSearchParam.h"
#include "DataStoreSearchResult.h"
#include "DataStoreGetNotificationUrlParamDDL.h"
#include "DataStoreReqGetNotificationUrlInfoDDL.h"
#include "DataStoreGetNewArrivedNotificationsParamDDL.h"
#include "DataStoreNotificationV1DDL.h"
#include "DataStoreRatingTarget.h"
#include "DataStoreRateObjectParam.h"
#include "DataStoreRatingInfo.h"
#include "DataStoreRatingInfoWithSlotDDL.h"
#include "DataStoreGetSpecificMetaParamV1DDL.h"
#include "DataStoreSpecificMetaInfoV1DDL.h"
#include "DataStorePreparePostParam.h"
#include "DataStoreTouchObjectParam.h"
#include "DataStoreRatingLog.h"
#include "DataStoreReqPostInfoDDL.h"
#include "DataStorePrepareGetParam.h"
#include "DataStoreReqGetInfo.h"
#include "DataStoreCompletePostParam.h"
#include "DataStoreNotificationDDL.h"
#include "DataStoreGetSpecificMetaParamDDL.h"
#include "DataStoreSpecificMetaInfoDDL.h"
#include "DataStorePersistenceInfo.h"
#include "DataStoreReqGetAdditionalMetaDDL.h"
#include "DataStorePasswordInfo.h"
#include "DataStoreChangeMetaParam.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(DataStoreProtocol, PrepareGetObjectV1, 1 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PreparePostObjectV1, 2 );
PROTO_DEFINE_RMCID(DataStoreProtocol, CompletePostObjectV1, 3 );
PROTO_DEFINE_RMCID(DataStoreProtocol, DeleteObject, 4 );
PROTO_DEFINE_RMCID(DataStoreProtocol, DeleteObjects, 5 );
PROTO_DEFINE_RMCID(DataStoreProtocol, ChangeMetaV1, 6 );
PROTO_DEFINE_RMCID(DataStoreProtocol, ChangeMetasV1, 7 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetMeta, 8 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetMetas, 9 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PrepareUpdateObject, 10 );
PROTO_DEFINE_RMCID(DataStoreProtocol, CompleteUpdateObject, 11 );
PROTO_DEFINE_RMCID(DataStoreProtocol, SearchObject, 12 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetNotificationUrl, 13 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetNewArrivedNotificationsV1, 14 );
PROTO_DEFINE_RMCID(DataStoreProtocol, RateObject, 15 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetRating, 16 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetRatings, 17 );
PROTO_DEFINE_RMCID(DataStoreProtocol, ResetRating, 18 );
PROTO_DEFINE_RMCID(DataStoreProtocol, ResetRatings, 19 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetSpecificMetaV1, 20 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PostMetaBinary, 21 );
PROTO_DEFINE_RMCID(DataStoreProtocol, TouchObject, 22 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetRatingWithLog, 23 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PreparePostObject, 24 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PrepareGetObject, 25 );
PROTO_DEFINE_RMCID(DataStoreProtocol, CompletePostObject, 26 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetNewArrivedNotifications, 27 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetSpecificMeta, 28 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetPersistenceInfo, 29 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetPersistenceInfos, 30 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PerpetuateObject, 31 );
PROTO_DEFINE_RMCID(DataStoreProtocol, UnperpetuateObject, 32 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PrepareGetObjectOrMetaBinary, 33 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetPasswordInfo, 34 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetPasswordInfos, 35 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetMetasMultipleParam, 36 );
PROTO_DEFINE_RMCID(DataStoreProtocol, CompletePostObjects, 37 );
PROTO_DEFINE_RMCID(DataStoreProtocol, ChangeMeta, 38 );
PROTO_DEFINE_RMCID(DataStoreProtocol, ChangeMetas, 39 );
PROTO_DEFINE_RMCID(DataStoreProtocol, RateObjects, 40 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PostMetaBinaryWithDataId, 41 );
PROTO_DEFINE_RMCID(DataStoreProtocol, PostMetaBinariesWithDataId, 42 );
PROTO_DEFINE_RMCID(DataStoreProtocol, RateObjectWithPosting, 43 );
PROTO_DEFINE_RMCID(DataStoreProtocol, RateObjectsWithPosting, 44 );
PROTO_DEFINE_RMCID(DataStoreProtocol, GetObjectInfos, 45 );
PROTO_DEFINE_RMCID(DataStoreProtocol, SearchObjectLight, 46 );
PROTO_DEFINE_NUM_RMC(DataStoreProtocol, 46);

class DataStoreProtocolClient : public ClientProtocol {
    public:
        typedef CLASSMETATYPE(DataStorePrepareGetParamV1) TPrepareGetObjectV1_param;
        typedef CLASSMETATYPE(DataStoreReqGetInfoV1) TPrepareGetObjectV1_pReqGetInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PrepareGetObjectV1)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPrepareGetObjectV1_pReqGetInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStorePreparePostParamV1) TPreparePostObjectV1_param;
        typedef CLASSMETATYPE(DataStoreReqPostInfoV1) TPreparePostObjectV1_pReqPostInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PreparePostObjectV1)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPreparePostObjectV1_pReqPostInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreCompletePostParamV1) TCompletePostObjectV1_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, CompletePostObjectV1)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreDeleteParam) TDeleteObject_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, DeleteObject)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreDeleteParam) > TDeleteObjects_params;
        typedef DDLTYPE(bool) TDeleteObjects_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TDeleteObjects_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, DeleteObjects)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDeleteObjects_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreChangeMetaParamV1) TChangeMetaV1_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, ChangeMetaV1)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TChangeMetasV1_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParamV1) > TChangeMetasV1_params;
        typedef DDLTYPE(bool) TChangeMetasV1_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TChangeMetasV1_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, ChangeMetasV1)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TChangeMetasV1_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreGetMetaParam) TGetMeta_param;
        typedef CLASSMETATYPE(DataStoreMetaInfo) TGetMeta_pMetaInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetMeta)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetMeta_pMetaInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetMetas_dataIds;
        typedef CLASSMETATYPE(DataStoreGetMetaParam) TGetMetas_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) > TGetMetas_pMetaInfo;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetMetas_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetMetas)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetMetas_pMetaInfo,1);
            _DO_RMC_ExtractReturnValue(TGetMetas_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStorePrepareUpdateParam) TPrepareUpdateObject_param;
        typedef CLASSMETATYPE(DataStoreReqUpdateInfo) TPrepareUpdateObject_pReqUpdateInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PrepareUpdateObject)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPrepareUpdateObject_pReqUpdateInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreCompleteUpdateParam) TCompleteUpdateObject_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, CompleteUpdateObject)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreSearchParam) TSearchObject_param;
        typedef CLASSMETATYPE(DataStoreSearchResult) TSearchObject_pSearchResult;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, SearchObject)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TSearchObject_pSearchResult,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreGetNotificationUrlParam) TGetNotificationUrl_param;
        typedef CLASSMETATYPE(DataStoreReqGetNotificationUrlInfo) TGetNotificationUrl_info;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetNotificationUrl)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetNotificationUrl_info,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreGetNewArrivedNotificationsParam) TGetNewArrivedNotificationsV1_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotificationV1) > TGetNewArrivedNotificationsV1_pResult;
        typedef DDLTYPE(bool) TGetNewArrivedNotificationsV1_pHasNext;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetNewArrivedNotificationsV1)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetNewArrivedNotificationsV1_pResult,1);
            _DO_RMC_ExtractReturnValue(TGetNewArrivedNotificationsV1_pHasNext,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TRateObject_target;
        typedef CLASSMETATYPE(DataStoreRateObjectParam) TRateObject_param;
        typedef DDLTYPE(bool) TRateObject_fetchRatings;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TRateObject_pRating;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, RateObject)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRateObject_pRating,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TGetRating_target;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TGetRating_pRating;
        typedef DDLTYPE(uint64) TGetRating_accessPassword;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetRating)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRating_pRating,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetRatings_dataIds;
        typedef DDLTYPE(qvector)< DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) > > TGetRatings_pRatings;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetRatings_pResults;
        typedef DDLTYPE(uint64) TGetRatings_accessPassword;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetRatings)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRatings_pRatings,1);
            _DO_RMC_ExtractReturnValue(TGetRatings_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TResetRating_target;
        typedef DDLTYPE(uint64) TResetRating_updatePassword;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, ResetRating)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TResetRatings_dataIds;
        typedef DDLTYPE(bool) TResetRatings_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TResetRatings_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, ResetRatings)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TResetRatings_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreGetSpecificMetaParamV1) TGetSpecificMetaV1_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfoV1) > TGetSpecificMetaV1_pMetaInfos;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetSpecificMetaV1)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSpecificMetaV1_pMetaInfos,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStorePreparePostParam) TPostMetaBinary_param;
        typedef DDLTYPE(uint64) TPostMetaBinary_dataId;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PostMetaBinary)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPostMetaBinary_dataId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreTouchObjectParam) TTouchObject_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, TouchObject)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TGetRatingWithLog_target;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TGetRatingWithLog_pRating;
        typedef CLASSMETATYPE(DataStoreRatingLog) TGetRatingWithLog_pRatingLog;
        typedef DDLTYPE(uint64) TGetRatingWithLog_accessPassword;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetRatingWithLog)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRatingWithLog_pRating,1);
            _DO_RMC_ExtractReturnValue(TGetRatingWithLog_pRatingLog,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStorePreparePostParam) TPreparePostObject_param;
        typedef CLASSMETATYPE(DataStoreReqPostInfo) TPreparePostObject_pReqPostInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PreparePostObject)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPreparePostObject_pReqPostInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStorePrepareGetParam) TPrepareGetObject_param;
        typedef CLASSMETATYPE(DataStoreReqGetInfo) TPrepareGetObject_pReqGetInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PrepareGetObject)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPrepareGetObject_pReqGetInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreCompletePostParam) TCompletePostObject_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, CompletePostObject)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreGetNewArrivedNotificationsParam) TGetNewArrivedNotifications_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotification) > TGetNewArrivedNotifications_pResult;
        typedef DDLTYPE(bool) TGetNewArrivedNotifications_pHasNext;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetNewArrivedNotifications)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetNewArrivedNotifications_pResult,1);
            _DO_RMC_ExtractReturnValue(TGetNewArrivedNotifications_pHasNext,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreGetSpecificMetaParam) TGetSpecificMeta_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfo) > TGetSpecificMeta_pMetaInfos;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetSpecificMeta)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSpecificMeta_pMetaInfos,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPersistenceInfo_ownerId;
        typedef DDLTYPE(uint16) TGetPersistenceInfo_persistenceSlotId;
        typedef CLASSMETATYPE(DataStorePersistenceInfo) TGetPersistenceInfo_pPersistenceInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetPersistenceInfo)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPersistenceInfo_pPersistenceInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetPersistenceInfos_ownerId;
        typedef DDLTYPE(qvector)< DDLTYPE(uint16) > TGetPersistenceInfos_persistenceSlotIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePersistenceInfo) > TGetPersistenceInfos_pPersistenceInfo;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetPersistenceInfos_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetPersistenceInfos)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPersistenceInfos_pPersistenceInfo,1);
            _DO_RMC_ExtractReturnValue(TGetPersistenceInfos_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint16) TPerpetuateObject_persistenceSlotId;
        typedef DDLTYPE(uint64) TPerpetuateObject_dataId;
        typedef DDLTYPE(bool) TPerpetuateObject_deleteLastObject;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PerpetuateObject)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint16) TUnperpetuateObject_persistenceSlotId;
        typedef DDLTYPE(bool) TUnperpetuateObject_deleteLastObject;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, UnperpetuateObject)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStorePrepareGetParam) TPrepareGetObjectOrMetaBinary_param;
        typedef CLASSMETATYPE(DataStoreReqGetInfo) TPrepareGetObjectOrMetaBinary_pReqGetInfo;
        typedef CLASSMETATYPE(DataStoreReqGetAdditionalMeta) TPrepareGetObjectOrMetaBinary_pReqGetAdditionalMeta;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PrepareGetObjectOrMetaBinary)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPrepareGetObjectOrMetaBinary_pReqGetInfo,1);
            _DO_RMC_ExtractReturnValue(TPrepareGetObjectOrMetaBinary_pReqGetAdditionalMeta,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TGetPasswordInfo_dataId;
        typedef CLASSMETATYPE(DataStorePasswordInfo) TGetPasswordInfo_pPasswordInfo;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetPasswordInfo)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPasswordInfo_pPasswordInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetPasswordInfos_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePasswordInfo) > TGetPasswordInfos_pPasswordInfos;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetPasswordInfos_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetPasswordInfos)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPasswordInfos_pPasswordInfos,1);
            _DO_RMC_ExtractReturnValue(TGetPasswordInfos_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreGetMetaParam) > TGetMetasMultipleParam_params;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) > TGetMetasMultipleParam_pMetaInfo;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetMetasMultipleParam_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetMetasMultipleParam)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetMetasMultipleParam_pMetaInfo,1);
            _DO_RMC_ExtractReturnValue(TGetMetasMultipleParam_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TCompletePostObjects_dataIds;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, CompletePostObjects)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreChangeMetaParam) TChangeMeta_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, ChangeMeta)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TChangeMetas_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParam) > TChangeMetas_params;
        typedef DDLTYPE(bool) TChangeMetas_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TChangeMetas_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, ChangeMetas)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TChangeMetas_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) > TRateObjects_targets;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) > TRateObjects_params;
        typedef DDLTYPE(bool) TRateObjects_transactional;
        typedef DDLTYPE(bool) TRateObjects_fetchRatings;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) > TRateObjects_pRatings;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TRateObjects_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, RateObjects)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRateObjects_pRatings,1);
            _DO_RMC_ExtractReturnValue(TRateObjects_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TPostMetaBinaryWithDataId_dataId;
        typedef CLASSMETATYPE(DataStorePreparePostParam) TPostMetaBinaryWithDataId_param;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PostMetaBinaryWithDataId)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TPostMetaBinariesWithDataId_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) > TPostMetaBinariesWithDataId_params;
        typedef DDLTYPE(bool) TPostMetaBinariesWithDataId_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TPostMetaBinariesWithDataId_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, PostMetaBinariesWithDataId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPostMetaBinariesWithDataId_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TRateObjectWithPosting_target;
        typedef CLASSMETATYPE(DataStoreRateObjectParam) TRateObjectWithPosting_rateParam;
        typedef CLASSMETATYPE(DataStorePreparePostParam) TRateObjectWithPosting_postParam;
        typedef DDLTYPE(bool) TRateObjectWithPosting_fetchRatings;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TRateObjectWithPosting_pRating;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, RateObjectWithPosting)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRateObjectWithPosting_pRating,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) > TRateObjectsWithPosting_targets;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) > TRateObjectsWithPosting_rateParams;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) > TRateObjectsWithPosting_postParams;
        typedef DDLTYPE(bool) TRateObjectsWithPosting_transactional;
        typedef DDLTYPE(bool) TRateObjectsWithPosting_fetchRatings;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) > TRateObjectsWithPosting_pRatings;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TRateObjectsWithPosting_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, RateObjectsWithPosting)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRateObjectsWithPosting_pRatings,1);
            _DO_RMC_ExtractReturnValue(TRateObjectsWithPosting_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetObjectInfos_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreReqGetInfo) > TGetObjectInfos_pInfos;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetObjectInfos_pResults;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, GetObjectInfos)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetObjectInfos_pInfos,1);
            _DO_RMC_ExtractReturnValue(TGetObjectInfos_pResults,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(DataStoreSearchParam) TSearchObjectLight_param;
        typedef CLASSMETATYPE(DataStoreSearchResult) TSearchObjectLight_pSearchResult;
        PROTO_RMCIMPL_RETURN(DataStoreProtocol, SearchObjectLight)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TSearchObjectLight_pSearchResult,1);
            PROTO_RETURNSTUB_END();
        };
        
        DataStoreProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew DataStoreProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallPrepareGetObjectV1(ProtocolCallContext *pContext, const DataStorePrepareGetParamV1& param, DataStoreReqGetInfoV1* pReqGetInfo);
        static qBool PrepareGetObjectV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePrepareGetParamV1& param, DataStoreReqGetInfoV1* pReqGetInfo);
        qBool CallPreparePostObjectV1(ProtocolCallContext *pContext, const DataStorePreparePostParamV1& param, DataStoreReqPostInfoV1* pReqPostInfo);
        static qBool PreparePostObjectV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePreparePostParamV1& param, DataStoreReqPostInfoV1* pReqPostInfo);
        qBool CallCompletePostObjectV1(ProtocolCallContext *pContext, const DataStoreCompletePostParamV1& param);
        static qBool CompletePostObjectV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreCompletePostParamV1& param);
        qBool CallDeleteObject(ProtocolCallContext *pContext, const DataStoreDeleteParam& param);
        static qBool DeleteObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreDeleteParam& param);
        qBool CallDeleteObjects(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreDeleteParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool DeleteObjects_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreDeleteParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallChangeMetaV1(ProtocolCallContext *pContext, const DataStoreChangeMetaParamV1& param);
        static qBool ChangeMetaV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreChangeMetaParamV1& param);
        qBool CallChangeMetasV1(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParamV1) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool ChangeMetasV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParamV1) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallGetMeta(ProtocolCallContext *pContext, const DataStoreGetMetaParam& param, DataStoreMetaInfo* pMetaInfo);
        static qBool GetMeta_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreGetMetaParam& param, DataStoreMetaInfo* pMetaInfo);
        qBool CallGetMetas(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DataStoreGetMetaParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType* pMetaInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool GetMetas_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DataStoreGetMetaParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType* pMetaInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallPrepareUpdateObject(ProtocolCallContext *pContext, const DataStorePrepareUpdateParam& param, DataStoreReqUpdateInfo* pReqUpdateInfo);
        static qBool PrepareUpdateObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePrepareUpdateParam& param, DataStoreReqUpdateInfo* pReqUpdateInfo);
        qBool CallCompleteUpdateObject(ProtocolCallContext *pContext, const DataStoreCompleteUpdateParam& param);
        static qBool CompleteUpdateObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreCompleteUpdateParam& param);
        qBool CallSearchObject(ProtocolCallContext *pContext, const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult);
        static qBool SearchObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult);
        qBool CallGetNotificationUrl(ProtocolCallContext *pContext, const DataStoreGetNotificationUrlParam& param, DataStoreReqGetNotificationUrlInfo* info);
        static qBool GetNotificationUrl_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreGetNotificationUrlParam& param, DataStoreReqGetNotificationUrlInfo* info);
        qBool CallGetNewArrivedNotificationsV1(ProtocolCallContext *pContext, const DataStoreGetNewArrivedNotificationsParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotificationV1) >::CPPType* pResult, DDLTYPE(bool)::CPPType* pHasNext);
        static qBool GetNewArrivedNotificationsV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreGetNewArrivedNotificationsParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotificationV1) >::CPPType* pResult, DDLTYPE(bool)::CPPType* pHasNext);
        qBool CallRateObject(ProtocolCallContext *pContext, const DataStoreRatingTarget& target, const DataStoreRateObjectParam& param, const DDLTYPE(bool)::CPPType& fetchRatings, DataStoreRatingInfo* pRating);
        static qBool RateObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreRatingTarget& target, const DataStoreRateObjectParam& param, const DDLTYPE(bool)::CPPType& fetchRatings, DataStoreRatingInfo* pRating);
        qBool CallGetRating(ProtocolCallContext *pContext, const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, const DDLTYPE(uint64)::CPPType& accessPassword);
        static qBool GetRating_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, const DDLTYPE(uint64)::CPPType& accessPassword);
        qBool CallGetRatings(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) > >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults, const DDLTYPE(uint64)::CPPType& accessPassword);
        static qBool GetRatings_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) > >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults, const DDLTYPE(uint64)::CPPType& accessPassword);
        qBool CallResetRating(ProtocolCallContext *pContext, const DataStoreRatingTarget& target, const DDLTYPE(uint64)::CPPType& updatePassword);
        static qBool ResetRating_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreRatingTarget& target, const DDLTYPE(uint64)::CPPType& updatePassword);
        qBool CallResetRatings(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool ResetRatings_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallGetSpecificMetaV1(ProtocolCallContext *pContext, const DataStoreGetSpecificMetaParamV1& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfoV1) >::CPPType* pMetaInfos);
        static qBool GetSpecificMetaV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreGetSpecificMetaParamV1& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfoV1) >::CPPType* pMetaInfos);
        qBool CallPostMetaBinary(ProtocolCallContext *pContext, const DataStorePreparePostParam& param, DDLTYPE(uint64)::CPPType* dataId);
        static qBool PostMetaBinary_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePreparePostParam& param, DDLTYPE(uint64)::CPPType* dataId);
        qBool CallTouchObject(ProtocolCallContext *pContext, const DataStoreTouchObjectParam& param);
        static qBool TouchObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreTouchObjectParam& param);
        qBool CallGetRatingWithLog(ProtocolCallContext *pContext, const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, DataStoreRatingLog* pRatingLog, const DDLTYPE(uint64)::CPPType& accessPassword);
        static qBool GetRatingWithLog_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, DataStoreRatingLog* pRatingLog, const DDLTYPE(uint64)::CPPType& accessPassword);
        qBool CallPreparePostObject(ProtocolCallContext *pContext, const DataStorePreparePostParam& param, DataStoreReqPostInfo* pReqPostInfo);
        static qBool PreparePostObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePreparePostParam& param, DataStoreReqPostInfo* pReqPostInfo);
        qBool CallPrepareGetObject(ProtocolCallContext *pContext, const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo);
        static qBool PrepareGetObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo);
        qBool CallCompletePostObject(ProtocolCallContext *pContext, const DataStoreCompletePostParam& param);
        static qBool CompletePostObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreCompletePostParam& param);
        qBool CallGetNewArrivedNotifications(ProtocolCallContext *pContext, const DataStoreGetNewArrivedNotificationsParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotification) >::CPPType* pResult, DDLTYPE(bool)::CPPType* pHasNext);
        static qBool GetNewArrivedNotifications_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreGetNewArrivedNotificationsParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotification) >::CPPType* pResult, DDLTYPE(bool)::CPPType* pHasNext);
        qBool CallGetSpecificMeta(ProtocolCallContext *pContext, const DataStoreGetSpecificMetaParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfo) >::CPPType* pMetaInfos);
        static qBool GetSpecificMeta_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreGetSpecificMetaParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfo) >::CPPType* pMetaInfos);
        qBool CallGetPersistenceInfo(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& ownerId, const DDLTYPE(uint16)::CPPType& persistenceSlotId, DataStorePersistenceInfo* pPersistenceInfo);
        static qBool GetPersistenceInfo_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& ownerId, const DDLTYPE(uint16)::CPPType& persistenceSlotId, DataStorePersistenceInfo* pPersistenceInfo);
        qBool CallGetPersistenceInfos(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& ownerId, const DDLTYPE(qvector)< DDLTYPE(uint16) >::CPPType& persistenceSlotIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStorePersistenceInfo) >::CPPType* pPersistenceInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool GetPersistenceInfos_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& ownerId, const DDLTYPE(qvector)< DDLTYPE(uint16) >::CPPType& persistenceSlotIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStorePersistenceInfo) >::CPPType* pPersistenceInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallPerpetuateObject(ProtocolCallContext *pContext, const DDLTYPE(uint16)::CPPType& persistenceSlotId, const DDLTYPE(uint64)::CPPType& dataId, const DDLTYPE(bool)::CPPType& deleteLastObject);
        static qBool PerpetuateObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint16)::CPPType& persistenceSlotId, const DDLTYPE(uint64)::CPPType& dataId, const DDLTYPE(bool)::CPPType& deleteLastObject);
        qBool CallUnperpetuateObject(ProtocolCallContext *pContext, const DDLTYPE(uint16)::CPPType& persistenceSlotId, const DDLTYPE(bool)::CPPType& deleteLastObject);
        static qBool UnperpetuateObject_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint16)::CPPType& persistenceSlotId, const DDLTYPE(bool)::CPPType& deleteLastObject);
        qBool CallPrepareGetObjectOrMetaBinary(ProtocolCallContext *pContext, const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo, DataStoreReqGetAdditionalMeta* pReqGetAdditionalMeta);
        static qBool PrepareGetObjectOrMetaBinary_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo, DataStoreReqGetAdditionalMeta* pReqGetAdditionalMeta);
        qBool CallGetPasswordInfo(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& dataId, DataStorePasswordInfo* pPasswordInfo);
        static qBool GetPasswordInfo_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& dataId, DataStorePasswordInfo* pPasswordInfo);
        qBool CallGetPasswordInfos(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStorePasswordInfo) >::CPPType* pPasswordInfos, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool GetPasswordInfos_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStorePasswordInfo) >::CPPType* pPasswordInfos, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallGetMetasMultipleParam(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreGetMetaParam) >::CPPType& params, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType* pMetaInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool GetMetasMultipleParam_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreGetMetaParam) >::CPPType& params, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType* pMetaInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallCompletePostObjects(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds);
        static qBool CompletePostObjects_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds);
        qBool CallChangeMeta(ProtocolCallContext *pContext, const DataStoreChangeMetaParam& param);
        static qBool ChangeMeta_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreChangeMetaParam& param);
        qBool CallChangeMetas(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool ChangeMetas_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallRateObjects(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType& targets, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, const DDLTYPE(bool)::CPPType& fetchRatings, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool RateObjects_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType& targets, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, const DDLTYPE(bool)::CPPType& fetchRatings, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallPostMetaBinaryWithDataId(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& dataId, const DataStorePreparePostParam& param);
        static qBool PostMetaBinaryWithDataId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& dataId, const DataStorePreparePostParam& param);
        qBool CallPostMetaBinariesWithDataId(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool PostMetaBinariesWithDataId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallRateObjectWithPosting(ProtocolCallContext *pContext, const DataStoreRatingTarget& target, const DataStoreRateObjectParam& rateParam, const DataStorePreparePostParam& postParam, const DDLTYPE(bool)::CPPType& fetchRatings, DataStoreRatingInfo* pRating);
        static qBool RateObjectWithPosting_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreRatingTarget& target, const DataStoreRateObjectParam& rateParam, const DataStorePreparePostParam& postParam, const DDLTYPE(bool)::CPPType& fetchRatings, DataStoreRatingInfo* pRating);
        qBool CallRateObjectsWithPosting(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType& targets, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType& rateParams, const DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType& postParams, const DDLTYPE(bool)::CPPType& transactional, const DDLTYPE(bool)::CPPType& fetchRatings, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool RateObjectsWithPosting_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType& targets, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType& rateParams, const DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType& postParams, const DDLTYPE(bool)::CPPType& transactional, const DDLTYPE(bool)::CPPType& fetchRatings, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallGetObjectInfos(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreReqGetInfo) >::CPPType* pInfos, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        static qBool GetObjectInfos_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreReqGetInfo) >::CPPType* pInfos, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults);
        qBool CallSearchObjectLight(ProtocolCallContext *pContext, const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult);
        static qBool SearchObjectLight_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(DataStoreProtocol) + 1];
};

class DDLPROTOCOL(DataStoreProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(DataStoreProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_PrepareGetObjectV1ProfilingUnit(NEX_T("DataStoreProtocol::PrepareGetObjectV1"))
            , m_PreparePostObjectV1ProfilingUnit(NEX_T("DataStoreProtocol::PreparePostObjectV1"))
            , m_CompletePostObjectV1ProfilingUnit(NEX_T("DataStoreProtocol::CompletePostObjectV1"))
            , m_DeleteObjectProfilingUnit(NEX_T("DataStoreProtocol::DeleteObject"))
            , m_DeleteObjectsProfilingUnit(NEX_T("DataStoreProtocol::DeleteObjects"))
            , m_ChangeMetaV1ProfilingUnit(NEX_T("DataStoreProtocol::ChangeMetaV1"))
            , m_ChangeMetasV1ProfilingUnit(NEX_T("DataStoreProtocol::ChangeMetasV1"))
            , m_GetMetaProfilingUnit(NEX_T("DataStoreProtocol::GetMeta"))
            , m_GetMetasProfilingUnit(NEX_T("DataStoreProtocol::GetMetas"))
            , m_PrepareUpdateObjectProfilingUnit(NEX_T("DataStoreProtocol::PrepareUpdateObject"))
            , m_CompleteUpdateObjectProfilingUnit(NEX_T("DataStoreProtocol::CompleteUpdateObject"))
            , m_SearchObjectProfilingUnit(NEX_T("DataStoreProtocol::SearchObject"))
            , m_GetNotificationUrlProfilingUnit(NEX_T("DataStoreProtocol::GetNotificationUrl"))
            , m_GetNewArrivedNotificationsV1ProfilingUnit(NEX_T("DataStoreProtocol::GetNewArrivedNotificationsV1"))
            , m_RateObjectProfilingUnit(NEX_T("DataStoreProtocol::RateObject"))
            , m_GetRatingProfilingUnit(NEX_T("DataStoreProtocol::GetRating"))
            , m_GetRatingsProfilingUnit(NEX_T("DataStoreProtocol::GetRatings"))
            , m_ResetRatingProfilingUnit(NEX_T("DataStoreProtocol::ResetRating"))
            , m_ResetRatingsProfilingUnit(NEX_T("DataStoreProtocol::ResetRatings"))
            , m_GetSpecificMetaV1ProfilingUnit(NEX_T("DataStoreProtocol::GetSpecificMetaV1"))
            , m_PostMetaBinaryProfilingUnit(NEX_T("DataStoreProtocol::PostMetaBinary"))
            , m_TouchObjectProfilingUnit(NEX_T("DataStoreProtocol::TouchObject"))
            , m_GetRatingWithLogProfilingUnit(NEX_T("DataStoreProtocol::GetRatingWithLog"))
            , m_PreparePostObjectProfilingUnit(NEX_T("DataStoreProtocol::PreparePostObject"))
            , m_PrepareGetObjectProfilingUnit(NEX_T("DataStoreProtocol::PrepareGetObject"))
            , m_CompletePostObjectProfilingUnit(NEX_T("DataStoreProtocol::CompletePostObject"))
            , m_GetNewArrivedNotificationsProfilingUnit(NEX_T("DataStoreProtocol::GetNewArrivedNotifications"))
            , m_GetSpecificMetaProfilingUnit(NEX_T("DataStoreProtocol::GetSpecificMeta"))
            , m_GetPersistenceInfoProfilingUnit(NEX_T("DataStoreProtocol::GetPersistenceInfo"))
            , m_GetPersistenceInfosProfilingUnit(NEX_T("DataStoreProtocol::GetPersistenceInfos"))
            , m_PerpetuateObjectProfilingUnit(NEX_T("DataStoreProtocol::PerpetuateObject"))
            , m_UnperpetuateObjectProfilingUnit(NEX_T("DataStoreProtocol::UnperpetuateObject"))
            , m_PrepareGetObjectOrMetaBinaryProfilingUnit(NEX_T("DataStoreProtocol::PrepareGetObjectOrMetaBinary"))
            , m_GetPasswordInfoProfilingUnit(NEX_T("DataStoreProtocol::GetPasswordInfo"))
            , m_GetPasswordInfosProfilingUnit(NEX_T("DataStoreProtocol::GetPasswordInfos"))
            , m_GetMetasMultipleParamProfilingUnit(NEX_T("DataStoreProtocol::GetMetasMultipleParam"))
            , m_CompletePostObjectsProfilingUnit(NEX_T("DataStoreProtocol::CompletePostObjects"))
            , m_ChangeMetaProfilingUnit(NEX_T("DataStoreProtocol::ChangeMeta"))
            , m_ChangeMetasProfilingUnit(NEX_T("DataStoreProtocol::ChangeMetas"))
            , m_RateObjectsProfilingUnit(NEX_T("DataStoreProtocol::RateObjects"))
            , m_PostMetaBinaryWithDataIdProfilingUnit(NEX_T("DataStoreProtocol::PostMetaBinaryWithDataId"))
            , m_PostMetaBinariesWithDataIdProfilingUnit(NEX_T("DataStoreProtocol::PostMetaBinariesWithDataId"))
            , m_RateObjectWithPostingProfilingUnit(NEX_T("DataStoreProtocol::RateObjectWithPosting"))
            , m_RateObjectsWithPostingProfilingUnit(NEX_T("DataStoreProtocol::RateObjectsWithPosting"))
            , m_GetObjectInfosProfilingUnit(NEX_T("DataStoreProtocol::GetObjectInfos"))
            , m_SearchObjectLightProfilingUnit(NEX_T("DataStoreProtocol::SearchObjectLight"))
#endif // LIVE_VERSION
            {}
        
        typedef CLASSMETATYPE(DataStorePrepareGetParamV1) TPrepareGetObjectV1_param;
        typedef CLASSMETATYPE(DataStoreReqGetInfoV1) TPrepareGetObjectV1_pReqGetInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PrepareGetObjectV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePrepareGetParamV1 param;
            _MSG_EXTRACT_VARIABLE(TPrepareGetObjectV1_param, param);
            DataStoreReqGetInfoV1 pReqGetInfo;
            pProtocol->PrepareGetObjectV1( param, &pReqGetInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PrepareGetObjectV1);
            _MSG_ADD_VARIABLE(TPrepareGetObjectV1_pReqGetInfo, pReqGetInfo);
        }
        
        typedef CLASSMETATYPE(DataStorePreparePostParamV1) TPreparePostObjectV1_param;
        typedef CLASSMETATYPE(DataStoreReqPostInfoV1) TPreparePostObjectV1_pReqPostInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PreparePostObjectV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePreparePostParamV1 param;
            _MSG_EXTRACT_VARIABLE(TPreparePostObjectV1_param, param);
            DataStoreReqPostInfoV1 pReqPostInfo;
            pProtocol->PreparePostObjectV1( param, &pReqPostInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PreparePostObjectV1);
            _MSG_ADD_VARIABLE(TPreparePostObjectV1_pReqPostInfo, pReqPostInfo);
        }
        
        typedef CLASSMETATYPE(DataStoreCompletePostParamV1) TCompletePostObjectV1_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, CompletePostObjectV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreCompletePostParamV1 param;
            _MSG_EXTRACT_VARIABLE(TCompletePostObjectV1_param, param);
            pProtocol->CompletePostObjectV1( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,CompletePostObjectV1);
        }
        
        typedef CLASSMETATYPE(DataStoreDeleteParam) TDeleteObject_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, DeleteObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreDeleteParam param;
            _MSG_EXTRACT_VARIABLE(TDeleteObject_param, param);
            pProtocol->DeleteObject( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,DeleteObject);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreDeleteParam) > TDeleteObjects_params;
        typedef DDLTYPE(bool) TDeleteObjects_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TDeleteObjects_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, DeleteObjects)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreDeleteParam) >::CPPType params;
            _MSG_EXTRACT_VARIABLE(TDeleteObjects_params, params);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TDeleteObjects_transactional, transactional);
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->DeleteObjects( params, transactional, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,DeleteObjects);
            _MSG_ADD_VARIABLE(TDeleteObjects_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStoreChangeMetaParamV1) TChangeMetaV1_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, ChangeMetaV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreChangeMetaParamV1 param;
            _MSG_EXTRACT_VARIABLE(TChangeMetaV1_param, param);
            pProtocol->ChangeMetaV1( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,ChangeMetaV1);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TChangeMetasV1_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParamV1) > TChangeMetasV1_params;
        typedef DDLTYPE(bool) TChangeMetasV1_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TChangeMetasV1_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, ChangeMetasV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TChangeMetasV1_dataIds, dataIds);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParamV1) >::CPPType params;
            _MSG_EXTRACT_VARIABLE(TChangeMetasV1_params, params);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TChangeMetasV1_transactional, transactional);
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->ChangeMetasV1( dataIds, params, transactional, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,ChangeMetasV1);
            _MSG_ADD_VARIABLE(TChangeMetasV1_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStoreGetMetaParam) TGetMeta_param;
        typedef CLASSMETATYPE(DataStoreMetaInfo) TGetMeta_pMetaInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetMeta)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreGetMetaParam param;
            _MSG_EXTRACT_VARIABLE(TGetMeta_param, param);
            DataStoreMetaInfo pMetaInfo;
            pProtocol->GetMeta( param, &pMetaInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetMeta);
            _MSG_ADD_VARIABLE(TGetMeta_pMetaInfo, pMetaInfo);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetMetas_dataIds;
        typedef CLASSMETATYPE(DataStoreGetMetaParam) TGetMetas_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) > TGetMetas_pMetaInfo;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetMetas_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetMetas)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TGetMetas_dataIds, dataIds);
            DataStoreGetMetaParam param;
            _MSG_EXTRACT_VARIABLE(TGetMetas_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType pMetaInfo;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->GetMetas( dataIds, param, &pMetaInfo, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetMetas);
            _MSG_ADD_VARIABLE(TGetMetas_pMetaInfo, pMetaInfo);
            _MSG_ADD_VARIABLE(TGetMetas_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStorePrepareUpdateParam) TPrepareUpdateObject_param;
        typedef CLASSMETATYPE(DataStoreReqUpdateInfo) TPrepareUpdateObject_pReqUpdateInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PrepareUpdateObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePrepareUpdateParam param;
            _MSG_EXTRACT_VARIABLE(TPrepareUpdateObject_param, param);
            DataStoreReqUpdateInfo pReqUpdateInfo;
            pProtocol->PrepareUpdateObject( param, &pReqUpdateInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PrepareUpdateObject);
            _MSG_ADD_VARIABLE(TPrepareUpdateObject_pReqUpdateInfo, pReqUpdateInfo);
        }
        
        typedef CLASSMETATYPE(DataStoreCompleteUpdateParam) TCompleteUpdateObject_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, CompleteUpdateObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreCompleteUpdateParam param;
            _MSG_EXTRACT_VARIABLE(TCompleteUpdateObject_param, param);
            pProtocol->CompleteUpdateObject( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,CompleteUpdateObject);
        }
        
        typedef CLASSMETATYPE(DataStoreSearchParam) TSearchObject_param;
        typedef CLASSMETATYPE(DataStoreSearchResult) TSearchObject_pSearchResult;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, SearchObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreSearchParam param;
            _MSG_EXTRACT_VARIABLE(TSearchObject_param, param);
            DataStoreSearchResult pSearchResult;
            pProtocol->SearchObject( param, &pSearchResult );
            PROTO_PREPARE_RETURN(DataStoreProtocol,SearchObject);
            _MSG_ADD_VARIABLE(TSearchObject_pSearchResult, pSearchResult);
        }
        
        typedef CLASSMETATYPE(DataStoreGetNotificationUrlParam) TGetNotificationUrl_param;
        typedef CLASSMETATYPE(DataStoreReqGetNotificationUrlInfo) TGetNotificationUrl_info;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetNotificationUrl)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreGetNotificationUrlParam param;
            _MSG_EXTRACT_VARIABLE(TGetNotificationUrl_param, param);
            DataStoreReqGetNotificationUrlInfo info;
            pProtocol->GetNotificationUrl( param, &info );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetNotificationUrl);
            _MSG_ADD_VARIABLE(TGetNotificationUrl_info, info);
        }
        
        typedef CLASSMETATYPE(DataStoreGetNewArrivedNotificationsParam) TGetNewArrivedNotificationsV1_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotificationV1) > TGetNewArrivedNotificationsV1_pResult;
        typedef DDLTYPE(bool) TGetNewArrivedNotificationsV1_pHasNext;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetNewArrivedNotificationsV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreGetNewArrivedNotificationsParam param;
            _MSG_EXTRACT_VARIABLE(TGetNewArrivedNotificationsV1_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotificationV1) >::CPPType pResult;
            DDLTYPE(bool)::CPPType pHasNext;
            pProtocol->GetNewArrivedNotificationsV1( param, &pResult, &pHasNext );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetNewArrivedNotificationsV1);
            _MSG_ADD_VARIABLE(TGetNewArrivedNotificationsV1_pResult, pResult);
            _MSG_ADD_VARIABLE(TGetNewArrivedNotificationsV1_pHasNext, pHasNext);
        }
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TRateObject_target;
        typedef CLASSMETATYPE(DataStoreRateObjectParam) TRateObject_param;
        typedef DDLTYPE(bool) TRateObject_fetchRatings;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TRateObject_pRating;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, RateObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreRatingTarget target;
            _MSG_EXTRACT_VARIABLE(TRateObject_target, target);
            DataStoreRateObjectParam param;
            _MSG_EXTRACT_VARIABLE(TRateObject_param, param);
            DDLTYPE(bool)::CPPType fetchRatings;
            _MSG_EXTRACT_VARIABLE(TRateObject_fetchRatings, fetchRatings);
            DataStoreRatingInfo pRating;
            pProtocol->RateObject( target, param, fetchRatings, &pRating );
            PROTO_PREPARE_RETURN(DataStoreProtocol,RateObject);
            _MSG_ADD_VARIABLE(TRateObject_pRating, pRating);
        }
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TGetRating_target;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TGetRating_pRating;
        typedef DDLTYPE(uint64) TGetRating_accessPassword;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetRating)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreRatingTarget target;
            _MSG_EXTRACT_VARIABLE(TGetRating_target, target);
            DataStoreRatingInfo pRating;
            DDLTYPE(uint64)::CPPType accessPassword;
            _MSG_EXTRACT_VARIABLE(TGetRating_accessPassword, accessPassword);
            pProtocol->GetRating( target, &pRating, accessPassword );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetRating);
            _MSG_ADD_VARIABLE(TGetRating_pRating, pRating);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetRatings_dataIds;
        typedef DDLTYPE(qvector)< DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) > > TGetRatings_pRatings;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetRatings_pResults;
        typedef DDLTYPE(uint64) TGetRatings_accessPassword;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetRatings)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TGetRatings_dataIds, dataIds);
            DDLTYPE(qvector)< DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) > >::CPPType pRatings;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            DDLTYPE(uint64)::CPPType accessPassword;
            _MSG_EXTRACT_VARIABLE(TGetRatings_accessPassword, accessPassword);
            pProtocol->GetRatings( dataIds, &pRatings, &pResults, accessPassword );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetRatings);
            _MSG_ADD_VARIABLE(TGetRatings_pRatings, pRatings);
            _MSG_ADD_VARIABLE(TGetRatings_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TResetRating_target;
        typedef DDLTYPE(uint64) TResetRating_updatePassword;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, ResetRating)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreRatingTarget target;
            _MSG_EXTRACT_VARIABLE(TResetRating_target, target);
            DDLTYPE(uint64)::CPPType updatePassword;
            _MSG_EXTRACT_VARIABLE(TResetRating_updatePassword, updatePassword);
            pProtocol->ResetRating( target, updatePassword );
            PROTO_PREPARE_RETURN(DataStoreProtocol,ResetRating);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TResetRatings_dataIds;
        typedef DDLTYPE(bool) TResetRatings_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TResetRatings_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, ResetRatings)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TResetRatings_dataIds, dataIds);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TResetRatings_transactional, transactional);
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->ResetRatings( dataIds, transactional, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,ResetRatings);
            _MSG_ADD_VARIABLE(TResetRatings_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStoreGetSpecificMetaParamV1) TGetSpecificMetaV1_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfoV1) > TGetSpecificMetaV1_pMetaInfos;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetSpecificMetaV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreGetSpecificMetaParamV1 param;
            _MSG_EXTRACT_VARIABLE(TGetSpecificMetaV1_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfoV1) >::CPPType pMetaInfos;
            pProtocol->GetSpecificMetaV1( param, &pMetaInfos );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetSpecificMetaV1);
            _MSG_ADD_VARIABLE(TGetSpecificMetaV1_pMetaInfos, pMetaInfos);
        }
        
        typedef CLASSMETATYPE(DataStorePreparePostParam) TPostMetaBinary_param;
        typedef DDLTYPE(uint64) TPostMetaBinary_dataId;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PostMetaBinary)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePreparePostParam param;
            _MSG_EXTRACT_VARIABLE(TPostMetaBinary_param, param);
            DDLTYPE(uint64)::CPPType dataId;
            pProtocol->PostMetaBinary( param, &dataId );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PostMetaBinary);
            _MSG_ADD_VARIABLE(TPostMetaBinary_dataId, dataId);
        }
        
        typedef CLASSMETATYPE(DataStoreTouchObjectParam) TTouchObject_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, TouchObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreTouchObjectParam param;
            _MSG_EXTRACT_VARIABLE(TTouchObject_param, param);
            pProtocol->TouchObject( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,TouchObject);
        }
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TGetRatingWithLog_target;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TGetRatingWithLog_pRating;
        typedef CLASSMETATYPE(DataStoreRatingLog) TGetRatingWithLog_pRatingLog;
        typedef DDLTYPE(uint64) TGetRatingWithLog_accessPassword;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetRatingWithLog)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreRatingTarget target;
            _MSG_EXTRACT_VARIABLE(TGetRatingWithLog_target, target);
            DataStoreRatingInfo pRating;
            DataStoreRatingLog pRatingLog;
            DDLTYPE(uint64)::CPPType accessPassword;
            _MSG_EXTRACT_VARIABLE(TGetRatingWithLog_accessPassword, accessPassword);
            pProtocol->GetRatingWithLog( target, &pRating, &pRatingLog, accessPassword );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetRatingWithLog);
            _MSG_ADD_VARIABLE(TGetRatingWithLog_pRating, pRating);
            _MSG_ADD_VARIABLE(TGetRatingWithLog_pRatingLog, pRatingLog);
        }
        
        typedef CLASSMETATYPE(DataStorePreparePostParam) TPreparePostObject_param;
        typedef CLASSMETATYPE(DataStoreReqPostInfo) TPreparePostObject_pReqPostInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PreparePostObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePreparePostParam param;
            _MSG_EXTRACT_VARIABLE(TPreparePostObject_param, param);
            DataStoreReqPostInfo pReqPostInfo;
            pProtocol->PreparePostObject( param, &pReqPostInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PreparePostObject);
            _MSG_ADD_VARIABLE(TPreparePostObject_pReqPostInfo, pReqPostInfo);
        }
        
        typedef CLASSMETATYPE(DataStorePrepareGetParam) TPrepareGetObject_param;
        typedef CLASSMETATYPE(DataStoreReqGetInfo) TPrepareGetObject_pReqGetInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PrepareGetObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePrepareGetParam param;
            _MSG_EXTRACT_VARIABLE(TPrepareGetObject_param, param);
            DataStoreReqGetInfo pReqGetInfo;
            pProtocol->PrepareGetObject( param, &pReqGetInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PrepareGetObject);
            _MSG_ADD_VARIABLE(TPrepareGetObject_pReqGetInfo, pReqGetInfo);
        }
        
        typedef CLASSMETATYPE(DataStoreCompletePostParam) TCompletePostObject_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, CompletePostObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreCompletePostParam param;
            _MSG_EXTRACT_VARIABLE(TCompletePostObject_param, param);
            pProtocol->CompletePostObject( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,CompletePostObject);
        }
        
        typedef CLASSMETATYPE(DataStoreGetNewArrivedNotificationsParam) TGetNewArrivedNotifications_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotification) > TGetNewArrivedNotifications_pResult;
        typedef DDLTYPE(bool) TGetNewArrivedNotifications_pHasNext;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetNewArrivedNotifications)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreGetNewArrivedNotificationsParam param;
            _MSG_EXTRACT_VARIABLE(TGetNewArrivedNotifications_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotification) >::CPPType pResult;
            DDLTYPE(bool)::CPPType pHasNext;
            pProtocol->GetNewArrivedNotifications( param, &pResult, &pHasNext );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetNewArrivedNotifications);
            _MSG_ADD_VARIABLE(TGetNewArrivedNotifications_pResult, pResult);
            _MSG_ADD_VARIABLE(TGetNewArrivedNotifications_pHasNext, pHasNext);
        }
        
        typedef CLASSMETATYPE(DataStoreGetSpecificMetaParam) TGetSpecificMeta_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfo) > TGetSpecificMeta_pMetaInfos;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetSpecificMeta)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreGetSpecificMetaParam param;
            _MSG_EXTRACT_VARIABLE(TGetSpecificMeta_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfo) >::CPPType pMetaInfos;
            pProtocol->GetSpecificMeta( param, &pMetaInfos );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetSpecificMeta);
            _MSG_ADD_VARIABLE(TGetSpecificMeta_pMetaInfos, pMetaInfos);
        }
        
        typedef DDLTYPE(uint32) TGetPersistenceInfo_ownerId;
        typedef DDLTYPE(uint16) TGetPersistenceInfo_persistenceSlotId;
        typedef CLASSMETATYPE(DataStorePersistenceInfo) TGetPersistenceInfo_pPersistenceInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetPersistenceInfo)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType ownerId;
            _MSG_EXTRACT_VARIABLE(TGetPersistenceInfo_ownerId, ownerId);
            DDLTYPE(uint16)::CPPType persistenceSlotId;
            _MSG_EXTRACT_VARIABLE(TGetPersistenceInfo_persistenceSlotId, persistenceSlotId);
            DataStorePersistenceInfo pPersistenceInfo;
            pProtocol->GetPersistenceInfo( ownerId, persistenceSlotId, &pPersistenceInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetPersistenceInfo);
            _MSG_ADD_VARIABLE(TGetPersistenceInfo_pPersistenceInfo, pPersistenceInfo);
        }
        
        typedef DDLTYPE(uint32) TGetPersistenceInfos_ownerId;
        typedef DDLTYPE(qvector)< DDLTYPE(uint16) > TGetPersistenceInfos_persistenceSlotIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePersistenceInfo) > TGetPersistenceInfos_pPersistenceInfo;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetPersistenceInfos_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetPersistenceInfos)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType ownerId;
            _MSG_EXTRACT_VARIABLE(TGetPersistenceInfos_ownerId, ownerId);
            DDLTYPE(qvector)< DDLTYPE(uint16) >::CPPType persistenceSlotIds;
            _MSG_EXTRACT_VARIABLE(TGetPersistenceInfos_persistenceSlotIds, persistenceSlotIds);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStorePersistenceInfo) >::CPPType pPersistenceInfo;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->GetPersistenceInfos( ownerId, persistenceSlotIds, &pPersistenceInfo, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetPersistenceInfos);
            _MSG_ADD_VARIABLE(TGetPersistenceInfos_pPersistenceInfo, pPersistenceInfo);
            _MSG_ADD_VARIABLE(TGetPersistenceInfos_pResults, pResults);
        }
        
        typedef DDLTYPE(uint16) TPerpetuateObject_persistenceSlotId;
        typedef DDLTYPE(uint64) TPerpetuateObject_dataId;
        typedef DDLTYPE(bool) TPerpetuateObject_deleteLastObject;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PerpetuateObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint16)::CPPType persistenceSlotId;
            _MSG_EXTRACT_VARIABLE(TPerpetuateObject_persistenceSlotId, persistenceSlotId);
            DDLTYPE(uint64)::CPPType dataId;
            _MSG_EXTRACT_VARIABLE(TPerpetuateObject_dataId, dataId);
            DDLTYPE(bool)::CPPType deleteLastObject;
            _MSG_EXTRACT_VARIABLE(TPerpetuateObject_deleteLastObject, deleteLastObject);
            pProtocol->PerpetuateObject( persistenceSlotId, dataId, deleteLastObject );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PerpetuateObject);
        }
        
        typedef DDLTYPE(uint16) TUnperpetuateObject_persistenceSlotId;
        typedef DDLTYPE(bool) TUnperpetuateObject_deleteLastObject;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, UnperpetuateObject)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint16)::CPPType persistenceSlotId;
            _MSG_EXTRACT_VARIABLE(TUnperpetuateObject_persistenceSlotId, persistenceSlotId);
            DDLTYPE(bool)::CPPType deleteLastObject;
            _MSG_EXTRACT_VARIABLE(TUnperpetuateObject_deleteLastObject, deleteLastObject);
            pProtocol->UnperpetuateObject( persistenceSlotId, deleteLastObject );
            PROTO_PREPARE_RETURN(DataStoreProtocol,UnperpetuateObject);
        }
        
        typedef CLASSMETATYPE(DataStorePrepareGetParam) TPrepareGetObjectOrMetaBinary_param;
        typedef CLASSMETATYPE(DataStoreReqGetInfo) TPrepareGetObjectOrMetaBinary_pReqGetInfo;
        typedef CLASSMETATYPE(DataStoreReqGetAdditionalMeta) TPrepareGetObjectOrMetaBinary_pReqGetAdditionalMeta;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PrepareGetObjectOrMetaBinary)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStorePrepareGetParam param;
            _MSG_EXTRACT_VARIABLE(TPrepareGetObjectOrMetaBinary_param, param);
            DataStoreReqGetInfo pReqGetInfo;
            DataStoreReqGetAdditionalMeta pReqGetAdditionalMeta;
            pProtocol->PrepareGetObjectOrMetaBinary( param, &pReqGetInfo, &pReqGetAdditionalMeta );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PrepareGetObjectOrMetaBinary);
            _MSG_ADD_VARIABLE(TPrepareGetObjectOrMetaBinary_pReqGetInfo, pReqGetInfo);
            _MSG_ADD_VARIABLE(TPrepareGetObjectOrMetaBinary_pReqGetAdditionalMeta, pReqGetAdditionalMeta);
        }
        
        typedef DDLTYPE(uint64) TGetPasswordInfo_dataId;
        typedef CLASSMETATYPE(DataStorePasswordInfo) TGetPasswordInfo_pPasswordInfo;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetPasswordInfo)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType dataId;
            _MSG_EXTRACT_VARIABLE(TGetPasswordInfo_dataId, dataId);
            DataStorePasswordInfo pPasswordInfo;
            pProtocol->GetPasswordInfo( dataId, &pPasswordInfo );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetPasswordInfo);
            _MSG_ADD_VARIABLE(TGetPasswordInfo_pPasswordInfo, pPasswordInfo);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetPasswordInfos_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePasswordInfo) > TGetPasswordInfos_pPasswordInfos;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetPasswordInfos_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetPasswordInfos)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TGetPasswordInfos_dataIds, dataIds);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStorePasswordInfo) >::CPPType pPasswordInfos;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->GetPasswordInfos( dataIds, &pPasswordInfos, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetPasswordInfos);
            _MSG_ADD_VARIABLE(TGetPasswordInfos_pPasswordInfos, pPasswordInfos);
            _MSG_ADD_VARIABLE(TGetPasswordInfos_pResults, pResults);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreGetMetaParam) > TGetMetasMultipleParam_params;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) > TGetMetasMultipleParam_pMetaInfo;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetMetasMultipleParam_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetMetasMultipleParam)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreGetMetaParam) >::CPPType params;
            _MSG_EXTRACT_VARIABLE(TGetMetasMultipleParam_params, params);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType pMetaInfo;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->GetMetasMultipleParam( params, &pMetaInfo, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetMetasMultipleParam);
            _MSG_ADD_VARIABLE(TGetMetasMultipleParam_pMetaInfo, pMetaInfo);
            _MSG_ADD_VARIABLE(TGetMetasMultipleParam_pResults, pResults);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TCompletePostObjects_dataIds;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, CompletePostObjects)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TCompletePostObjects_dataIds, dataIds);
            pProtocol->CompletePostObjects( dataIds );
            PROTO_PREPARE_RETURN(DataStoreProtocol,CompletePostObjects);
        }
        
        typedef CLASSMETATYPE(DataStoreChangeMetaParam) TChangeMeta_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, ChangeMeta)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreChangeMetaParam param;
            _MSG_EXTRACT_VARIABLE(TChangeMeta_param, param);
            pProtocol->ChangeMeta( param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,ChangeMeta);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TChangeMetas_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParam) > TChangeMetas_params;
        typedef DDLTYPE(bool) TChangeMetas_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TChangeMetas_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, ChangeMetas)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TChangeMetas_dataIds, dataIds);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParam) >::CPPType params;
            _MSG_EXTRACT_VARIABLE(TChangeMetas_params, params);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TChangeMetas_transactional, transactional);
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->ChangeMetas( dataIds, params, transactional, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,ChangeMetas);
            _MSG_ADD_VARIABLE(TChangeMetas_pResults, pResults);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) > TRateObjects_targets;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) > TRateObjects_params;
        typedef DDLTYPE(bool) TRateObjects_transactional;
        typedef DDLTYPE(bool) TRateObjects_fetchRatings;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) > TRateObjects_pRatings;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TRateObjects_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, RateObjects)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType targets;
            _MSG_EXTRACT_VARIABLE(TRateObjects_targets, targets);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType params;
            _MSG_EXTRACT_VARIABLE(TRateObjects_params, params);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TRateObjects_transactional, transactional);
            DDLTYPE(bool)::CPPType fetchRatings;
            _MSG_EXTRACT_VARIABLE(TRateObjects_fetchRatings, fetchRatings);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType pRatings;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->RateObjects( targets, params, transactional, fetchRatings, &pRatings, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,RateObjects);
            _MSG_ADD_VARIABLE(TRateObjects_pRatings, pRatings);
            _MSG_ADD_VARIABLE(TRateObjects_pResults, pResults);
        }
        
        typedef DDLTYPE(uint64) TPostMetaBinaryWithDataId_dataId;
        typedef CLASSMETATYPE(DataStorePreparePostParam) TPostMetaBinaryWithDataId_param;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PostMetaBinaryWithDataId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType dataId;
            _MSG_EXTRACT_VARIABLE(TPostMetaBinaryWithDataId_dataId, dataId);
            DataStorePreparePostParam param;
            _MSG_EXTRACT_VARIABLE(TPostMetaBinaryWithDataId_param, param);
            pProtocol->PostMetaBinaryWithDataId( dataId, param );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PostMetaBinaryWithDataId);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TPostMetaBinariesWithDataId_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) > TPostMetaBinariesWithDataId_params;
        typedef DDLTYPE(bool) TPostMetaBinariesWithDataId_transactional;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TPostMetaBinariesWithDataId_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, PostMetaBinariesWithDataId)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TPostMetaBinariesWithDataId_dataIds, dataIds);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType params;
            _MSG_EXTRACT_VARIABLE(TPostMetaBinariesWithDataId_params, params);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TPostMetaBinariesWithDataId_transactional, transactional);
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->PostMetaBinariesWithDataId( dataIds, params, transactional, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,PostMetaBinariesWithDataId);
            _MSG_ADD_VARIABLE(TPostMetaBinariesWithDataId_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStoreRatingTarget) TRateObjectWithPosting_target;
        typedef CLASSMETATYPE(DataStoreRateObjectParam) TRateObjectWithPosting_rateParam;
        typedef CLASSMETATYPE(DataStorePreparePostParam) TRateObjectWithPosting_postParam;
        typedef DDLTYPE(bool) TRateObjectWithPosting_fetchRatings;
        typedef CLASSMETATYPE(DataStoreRatingInfo) TRateObjectWithPosting_pRating;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, RateObjectWithPosting)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreRatingTarget target;
            _MSG_EXTRACT_VARIABLE(TRateObjectWithPosting_target, target);
            DataStoreRateObjectParam rateParam;
            _MSG_EXTRACT_VARIABLE(TRateObjectWithPosting_rateParam, rateParam);
            DataStorePreparePostParam postParam;
            _MSG_EXTRACT_VARIABLE(TRateObjectWithPosting_postParam, postParam);
            DDLTYPE(bool)::CPPType fetchRatings;
            _MSG_EXTRACT_VARIABLE(TRateObjectWithPosting_fetchRatings, fetchRatings);
            DataStoreRatingInfo pRating;
            pProtocol->RateObjectWithPosting( target, rateParam, postParam, fetchRatings, &pRating );
            PROTO_PREPARE_RETURN(DataStoreProtocol,RateObjectWithPosting);
            _MSG_ADD_VARIABLE(TRateObjectWithPosting_pRating, pRating);
        }
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) > TRateObjectsWithPosting_targets;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) > TRateObjectsWithPosting_rateParams;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) > TRateObjectsWithPosting_postParams;
        typedef DDLTYPE(bool) TRateObjectsWithPosting_transactional;
        typedef DDLTYPE(bool) TRateObjectsWithPosting_fetchRatings;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) > TRateObjectsWithPosting_pRatings;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TRateObjectsWithPosting_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, RateObjectsWithPosting)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType targets;
            _MSG_EXTRACT_VARIABLE(TRateObjectsWithPosting_targets, targets);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType rateParams;
            _MSG_EXTRACT_VARIABLE(TRateObjectsWithPosting_rateParams, rateParams);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType postParams;
            _MSG_EXTRACT_VARIABLE(TRateObjectsWithPosting_postParams, postParams);
            DDLTYPE(bool)::CPPType transactional;
            _MSG_EXTRACT_VARIABLE(TRateObjectsWithPosting_transactional, transactional);
            DDLTYPE(bool)::CPPType fetchRatings;
            _MSG_EXTRACT_VARIABLE(TRateObjectsWithPosting_fetchRatings, fetchRatings);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType pRatings;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->RateObjectsWithPosting( targets, rateParams, postParams, transactional, fetchRatings, &pRatings, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,RateObjectsWithPosting);
            _MSG_ADD_VARIABLE(TRateObjectsWithPosting_pRatings, pRatings);
            _MSG_ADD_VARIABLE(TRateObjectsWithPosting_pResults, pResults);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(uint64) > TGetObjectInfos_dataIds;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(DataStoreReqGetInfo) > TGetObjectInfos_pInfos;
        typedef DDLTYPE(qvector)< DDLTYPE(qresult) > TGetObjectInfos_pResults;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, GetObjectInfos)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType dataIds;
            _MSG_EXTRACT_VARIABLE(TGetObjectInfos_dataIds, dataIds);
            DDLTYPE(qvector)< CLASSMETATYPE(DataStoreReqGetInfo) >::CPPType pInfos;
            DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType pResults;
            pProtocol->GetObjectInfos( dataIds, &pInfos, &pResults );
            PROTO_PREPARE_RETURN(DataStoreProtocol,GetObjectInfos);
            _MSG_ADD_VARIABLE(TGetObjectInfos_pInfos, pInfos);
            _MSG_ADD_VARIABLE(TGetObjectInfos_pResults, pResults);
        }
        
        typedef CLASSMETATYPE(DataStoreSearchParam) TSearchObjectLight_param;
        typedef CLASSMETATYPE(DataStoreSearchResult) TSearchObjectLight_pSearchResult;
        PROTO_RMCIMPL_STUB(DataStoreProtocol, SearchObjectLight)
        {
            PROTO_PREPARE_EXTRACTION();
            DataStoreSearchParam param;
            _MSG_EXTRACT_VARIABLE(TSearchObjectLight_param, param);
            DataStoreSearchResult pSearchResult;
            pProtocol->SearchObjectLight( param, &pSearchResult );
            PROTO_PREPARE_RETURN(DataStoreProtocol,SearchObjectLight);
            _MSG_ADD_VARIABLE(TSearchObjectLight_pSearchResult, pSearchResult);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void PrepareGetObjectV1(const DataStorePrepareGetParamV1& param, DataStoreReqGetInfoV1* pReqGetInfo) = 0;
        virtual void PreparePostObjectV1(const DataStorePreparePostParamV1& param, DataStoreReqPostInfoV1* pReqPostInfo) = 0;
        virtual void CompletePostObjectV1(const DataStoreCompletePostParamV1& param) = 0;
        virtual void DeleteObject(const DataStoreDeleteParam& param) = 0;
        virtual void DeleteObjects(const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreDeleteParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void ChangeMetaV1(const DataStoreChangeMetaParamV1& param) = 0;
        virtual void ChangeMetasV1(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParamV1) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void GetMeta(const DataStoreGetMetaParam& param, DataStoreMetaInfo* pMetaInfo) = 0;
        virtual void GetMetas(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DataStoreGetMetaParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType* pMetaInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void PrepareUpdateObject(const DataStorePrepareUpdateParam& param, DataStoreReqUpdateInfo* pReqUpdateInfo) = 0;
        virtual void CompleteUpdateObject(const DataStoreCompleteUpdateParam& param) = 0;
        virtual void SearchObject(const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult) = 0;
        virtual void GetNotificationUrl(const DataStoreGetNotificationUrlParam& param, DataStoreReqGetNotificationUrlInfo* info) = 0;
        virtual void GetNewArrivedNotificationsV1(const DataStoreGetNewArrivedNotificationsParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotificationV1) >::CPPType* pResult, DDLTYPE(bool)::CPPType* pHasNext) = 0;
        virtual void RateObject(const DataStoreRatingTarget& target, const DataStoreRateObjectParam& param, const DDLTYPE(bool)::CPPType& fetchRatings, DataStoreRatingInfo* pRating) = 0;
        virtual void GetRating(const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, const DDLTYPE(uint64)::CPPType& accessPassword) = 0;
        virtual void GetRatings(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfoWithSlot) > >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults, const DDLTYPE(uint64)::CPPType& accessPassword) = 0;
        virtual void ResetRating(const DataStoreRatingTarget& target, const DDLTYPE(uint64)::CPPType& updatePassword) = 0;
        virtual void ResetRatings(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void GetSpecificMetaV1(const DataStoreGetSpecificMetaParamV1& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfoV1) >::CPPType* pMetaInfos) = 0;
        virtual void PostMetaBinary(const DataStorePreparePostParam& param, DDLTYPE(uint64)::CPPType* dataId) = 0;
        virtual void TouchObject(const DataStoreTouchObjectParam& param) = 0;
        virtual void GetRatingWithLog(const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, DataStoreRatingLog* pRatingLog, const DDLTYPE(uint64)::CPPType& accessPassword) = 0;
        virtual void PreparePostObject(const DataStorePreparePostParam& param, DataStoreReqPostInfo* pReqPostInfo) = 0;
        virtual void PrepareGetObject(const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo) = 0;
        virtual void CompletePostObject(const DataStoreCompletePostParam& param) = 0;
        virtual void GetNewArrivedNotifications(const DataStoreGetNewArrivedNotificationsParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreNotification) >::CPPType* pResult, DDLTYPE(bool)::CPPType* pHasNext) = 0;
        virtual void GetSpecificMeta(const DataStoreGetSpecificMetaParam& param, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreSpecificMetaInfo) >::CPPType* pMetaInfos) = 0;
        virtual void GetPersistenceInfo(const DDLTYPE(uint32)::CPPType& ownerId, const DDLTYPE(uint16)::CPPType& persistenceSlotId, DataStorePersistenceInfo* pPersistenceInfo) = 0;
        virtual void GetPersistenceInfos(const DDLTYPE(uint32)::CPPType& ownerId, const DDLTYPE(qvector)< DDLTYPE(uint16) >::CPPType& persistenceSlotIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStorePersistenceInfo) >::CPPType* pPersistenceInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void PerpetuateObject(const DDLTYPE(uint16)::CPPType& persistenceSlotId, const DDLTYPE(uint64)::CPPType& dataId, const DDLTYPE(bool)::CPPType& deleteLastObject) = 0;
        virtual void UnperpetuateObject(const DDLTYPE(uint16)::CPPType& persistenceSlotId, const DDLTYPE(bool)::CPPType& deleteLastObject) = 0;
        virtual void PrepareGetObjectOrMetaBinary(const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo, DataStoreReqGetAdditionalMeta* pReqGetAdditionalMeta) = 0;
        virtual void GetPasswordInfo(const DDLTYPE(uint64)::CPPType& dataId, DataStorePasswordInfo* pPasswordInfo) = 0;
        virtual void GetPasswordInfos(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStorePasswordInfo) >::CPPType* pPasswordInfos, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void GetMetasMultipleParam(const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreGetMetaParam) >::CPPType& params, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreMetaInfo) >::CPPType* pMetaInfo, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void CompletePostObjects(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds) = 0;
        virtual void ChangeMeta(const DataStoreChangeMetaParam& param) = 0;
        virtual void ChangeMetas(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreChangeMetaParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void RateObjects(const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType& targets, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, const DDLTYPE(bool)::CPPType& fetchRatings, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void PostMetaBinaryWithDataId(const DDLTYPE(uint64)::CPPType& dataId, const DataStorePreparePostParam& param) = 0;
        virtual void PostMetaBinariesWithDataId(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, const DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType& params, const DDLTYPE(bool)::CPPType& transactional, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void RateObjectWithPosting(const DataStoreRatingTarget& target, const DataStoreRateObjectParam& rateParam, const DataStorePreparePostParam& postParam, const DDLTYPE(bool)::CPPType& fetchRatings, DataStoreRatingInfo* pRating) = 0;
        virtual void RateObjectsWithPosting(const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingTarget) >::CPPType& targets, const DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRateObjectParam) >::CPPType& rateParams, const DDLTYPE(qvector)< CLASSMETATYPE(DataStorePreparePostParam) >::CPPType& postParams, const DDLTYPE(bool)::CPPType& transactional, const DDLTYPE(bool)::CPPType& fetchRatings, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreRatingInfo) >::CPPType* pRatings, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void GetObjectInfos(const DDLTYPE(qvector)< DDLTYPE(uint64) >::CPPType& dataIds, DDLTYPE(qvector)< CLASSMETATYPE(DataStoreReqGetInfo) >::CPPType* pInfos, DDLTYPE(qvector)< DDLTYPE(qresult) >::CPPType* pResults) = 0;
        virtual void SearchObjectLight(const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_PrepareGetObjectV1ProfilingUnit;
        ProfilingUnit m_PreparePostObjectV1ProfilingUnit;
        ProfilingUnit m_CompletePostObjectV1ProfilingUnit;
        ProfilingUnit m_DeleteObjectProfilingUnit;
        ProfilingUnit m_DeleteObjectsProfilingUnit;
        ProfilingUnit m_ChangeMetaV1ProfilingUnit;
        ProfilingUnit m_ChangeMetasV1ProfilingUnit;
        ProfilingUnit m_GetMetaProfilingUnit;
        ProfilingUnit m_GetMetasProfilingUnit;
        ProfilingUnit m_PrepareUpdateObjectProfilingUnit;
        ProfilingUnit m_CompleteUpdateObjectProfilingUnit;
        ProfilingUnit m_SearchObjectProfilingUnit;
        ProfilingUnit m_GetNotificationUrlProfilingUnit;
        ProfilingUnit m_GetNewArrivedNotificationsV1ProfilingUnit;
        ProfilingUnit m_RateObjectProfilingUnit;
        ProfilingUnit m_GetRatingProfilingUnit;
        ProfilingUnit m_GetRatingsProfilingUnit;
        ProfilingUnit m_ResetRatingProfilingUnit;
        ProfilingUnit m_ResetRatingsProfilingUnit;
        ProfilingUnit m_GetSpecificMetaV1ProfilingUnit;
        ProfilingUnit m_PostMetaBinaryProfilingUnit;
        ProfilingUnit m_TouchObjectProfilingUnit;
        ProfilingUnit m_GetRatingWithLogProfilingUnit;
        ProfilingUnit m_PreparePostObjectProfilingUnit;
        ProfilingUnit m_PrepareGetObjectProfilingUnit;
        ProfilingUnit m_CompletePostObjectProfilingUnit;
        ProfilingUnit m_GetNewArrivedNotificationsProfilingUnit;
        ProfilingUnit m_GetSpecificMetaProfilingUnit;
        ProfilingUnit m_GetPersistenceInfoProfilingUnit;
        ProfilingUnit m_GetPersistenceInfosProfilingUnit;
        ProfilingUnit m_PerpetuateObjectProfilingUnit;
        ProfilingUnit m_UnperpetuateObjectProfilingUnit;
        ProfilingUnit m_PrepareGetObjectOrMetaBinaryProfilingUnit;
        ProfilingUnit m_GetPasswordInfoProfilingUnit;
        ProfilingUnit m_GetPasswordInfosProfilingUnit;
        ProfilingUnit m_GetMetasMultipleParamProfilingUnit;
        ProfilingUnit m_CompletePostObjectsProfilingUnit;
        ProfilingUnit m_ChangeMetaProfilingUnit;
        ProfilingUnit m_ChangeMetasProfilingUnit;
        ProfilingUnit m_RateObjectsProfilingUnit;
        ProfilingUnit m_PostMetaBinaryWithDataIdProfilingUnit;
        ProfilingUnit m_PostMetaBinariesWithDataIdProfilingUnit;
        ProfilingUnit m_RateObjectWithPostingProfilingUnit;
        ProfilingUnit m_RateObjectsWithPostingProfilingUnit;
        ProfilingUnit m_GetObjectInfosProfilingUnit;
        ProfilingUnit m_SearchObjectLightProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
