#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "RendezVous/Core/src/Common/ResultRange.h"

BEGIN_NAMESPACE_NEX
class DataStoreSearchParam;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(DataStoreSearchParam): public RootObject {
public:
    DDLCLASS(DataStoreSearchParam)():_mRevision_DataStoreSearchParam(0)
    , ownerIds(0)    , destinationIds(0)    , tags(0)    , dataTypes(0)     {};
    DDLCLASS(DataStoreSearchParam)(const DDLCLASS(DataStoreSearchParam) &oOther):
        RootObject(oOther),
        _mRevision_DataStoreSearchParam(oOther._mRevision_DataStoreSearchParam),
        searchTarget(oOther.searchTarget),
        ownerIds(oOther.ownerIds),
        ownerType(oOther.ownerType),
        destinationIds(oOther.destinationIds),
        dataType(oOther.dataType),
        createdAfter(oOther.createdAfter),
        createdBefore(oOther.createdBefore),
        updatedAfter(oOther.updatedAfter),
        updatedBefore(oOther.updatedBefore),
        referDataId(oOther.referDataId),
        tags(oOther.tags),
        resultOrderColumn(oOther.resultOrderColumn),
        resultOrder(oOther.resultOrder),
        resultRange(oOther.resultRange),
        resultOption(oOther.resultOption),
        minimalRatingFrequency(oOther.minimalRatingFrequency),
        useCache(oOther.useCache),
        totalCountEnabled(oOther.totalCountEnabled),
        dataTypes(oOther.dataTypes)
    {
    }
    virtual ~DDLCLASS(DataStoreSearchParam)() {};
    const DDLCLASS(DataStoreSearchParam) &operator=(const DDLCLASS(DataStoreSearchParam) &oOther);
    qBool operator==(const DDLCLASS(DataStoreSearchParam) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(DataStoreSearchParam) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(DataStoreSearchParam) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(DataStoreSearchParam) *pValue);
    qByte _mRevision_DataStoreSearchParam;
    qByte GetClassRevision_DataStoreSearchParam() const {return _mRevision_DataStoreSearchParam;}
    void SetClassRevision_DataStoreSearchParam(qByte revision) {_mRevision_DataStoreSearchParam=revision;}
    static qByte GetKnownMaxClassRevision_DataStoreSearchParam() {return 0;}
    DDLTYPE(byte)::CPPType searchTarget;
    NEX_CLASS_VALID_REVISION_DEF(searchTarget, 0);
    qBool NEX_CLASS_ISVALID(searchTarget) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType ownerIds;
    NEX_CLASS_VALID_REVISION_DEF(ownerIds, 0);
    qBool NEX_CLASS_ISVALID(ownerIds) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType ownerType;
    NEX_CLASS_VALID_REVISION_DEF(ownerType, 0);
    qBool NEX_CLASS_ISVALID(ownerType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType destinationIds;
    NEX_CLASS_VALID_REVISION_DEF(destinationIds, 0);
    qBool NEX_CLASS_ISVALID(destinationIds) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType dataType;
    NEX_CLASS_VALID_REVISION_DEF(dataType, 0);
    qBool NEX_CLASS_ISVALID(dataType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType createdAfter;
    NEX_CLASS_VALID_REVISION_DEF(createdAfter, 0);
    qBool NEX_CLASS_ISVALID(createdAfter) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType createdBefore;
    NEX_CLASS_VALID_REVISION_DEF(createdBefore, 0);
    qBool NEX_CLASS_ISVALID(createdBefore) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType updatedAfter;
    NEX_CLASS_VALID_REVISION_DEF(updatedAfter, 0);
    qBool NEX_CLASS_ISVALID(updatedAfter) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(datetime)::CPPType updatedBefore;
    NEX_CLASS_VALID_REVISION_DEF(updatedBefore, 0);
    qBool NEX_CLASS_ISVALID(updatedBefore) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType referDataId;
    NEX_CLASS_VALID_REVISION_DEF(referDataId, 0);
    qBool NEX_CLASS_ISVALID(referDataId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(string) >::CPPType tags;
    NEX_CLASS_VALID_REVISION_DEF(tags, 0);
    qBool NEX_CLASS_ISVALID(tags) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType resultOrderColumn;
    NEX_CLASS_VALID_REVISION_DEF(resultOrderColumn, 0);
    qBool NEX_CLASS_ISVALID(resultOrderColumn) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType resultOrder;
    NEX_CLASS_VALID_REVISION_DEF(resultOrder, 0);
    qBool NEX_CLASS_ISVALID(resultOrder) const { return true; /* The revision is 0. Always true */}
    ResultRange resultRange;
    NEX_CLASS_VALID_REVISION_DEF(resultRange, 0);
    qBool NEX_CLASS_ISVALID(resultRange) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType resultOption;
    NEX_CLASS_VALID_REVISION_DEF(resultOption, 0);
    qBool NEX_CLASS_ISVALID(resultOption) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType minimalRatingFrequency;
    NEX_CLASS_VALID_REVISION_DEF(minimalRatingFrequency, 0);
    qBool NEX_CLASS_ISVALID(minimalRatingFrequency) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType useCache;
    NEX_CLASS_VALID_REVISION_DEF(useCache, 0);
    qBool NEX_CLASS_ISVALID(useCache) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType totalCountEnabled;
    NEX_CLASS_VALID_REVISION_DEF(totalCountEnabled, 0);
    qBool NEX_CLASS_ISVALID(totalCountEnabled) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(uint16) >::CPPType dataTypes;
    NEX_CLASS_VALID_REVISION_DEF(dataTypes, 0);
    qBool NEX_CLASS_ISVALID(dataTypes) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(DataStoreSearchParam): public DDLType {
public:
    typedef DataStoreSearchParam CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(DataStoreSearchParam)& oDataStoreSearchParam) {
        DDLCLASS(DataStoreSearchParam)::Add(pMessageToSend,oDataStoreSearchParam);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(DataStoreSearchParam)* pDataStoreSearchParamToRefresh) {
        DDLCLASS(DataStoreSearchParam)::Extract(pReceivedMessage,pDataStoreSearchParamToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
