﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Services/Jugem/Login/src/Client/JobLogin.h>

BEGIN_NAMESPACE_NEX

class JobNNIDLogin : public JobLogin
{
public:
    // コンストラクタです。
    JobNNIDLogin();

    // デストラクタです。
    virtual ~JobNNIDLogin();

    void Initialize(qUnsignedInt32 contextId, qUnsignedInt32 gameId, NgsFacade* pClient, PrincipalID principalID, const void* pNexAuthResultArg, TimeInterval uiTimeout);

private:
    // ゲームサーバーにログインします。
    void StepGameLogin();

    // ゲームサーバーへのログイン処理を待機します。
    void StepWaitingForGameLogin();

private:

    const void* m_pNexAuthResult;
    PrincipalID m_PrincipalID;
};

END_NAMESPACE_NEX

