﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/NonCopyable.h>
#include <OnlineCore/src/Core/StepSequenceJob.h>
#include <OnlineCore/src/Core/qBuffer.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/NotificationEvent.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/AutoMatchmakeParam.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeSession.h>

BEGIN_NAMESPACE_NEX

class MatchmakeExtensionClient;
class NotificationEventFilterInterface;

class JobDoMatchmaking : public StepSequenceJob, public NonCopyable
{
public:

    JobDoMatchmaking();
    virtual ~JobDoMatchmaking();

    virtual qResult Initialize(
        qUnsignedInt32 uiAssociatedCallID,
        MatchmakeExtensionClient* pMatchmakeExtensionClient,
        const AutoMatchmakeParam& autoMatchmakeParam,
        MatchmakeSession* pMatchmakeSession
    );

protected:

    qUnsignedInt32 m_AssociatedCallID;
    MatchmakeExtensionClient* m_pMatchmakeExtensionClient;
    AutoMatchmakeParam m_AutoMatchmakeParam;
    MatchmakeSession* m_pMatchmakeSessionOut;
    ProtocolCallContext m_MatchmakingCallContext;
    ProtocolCallContext m_WaitNotificationCallContext;
    NotificationEventFilterInterface* m_pNotificationEventFilterInterface;
    NotificationEvent m_NotifiedNotificationEvent;
    qUnsignedInt64 m_RequestId;
    GatheringID m_JoinedGid;
    MatchmakeSession m_MatchmakeSession;
    

    void StepRequestMatchmaking();
    void StepWaitingRequestMatchmaking();
    void StepWaitingNotify();
    void StepFindMatchmakeSessionByGatheringIdDetail();
    void StepWaitingFindMatchmakeSessionByGatheringIdDetail();
    void CompleteJob(const qResult& result);
};

END_NAMESPACE_NEX

