﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class MatchmakeFlags
{
public:
#else
/*!
 @brief MatchmakeFlags の 名前空間です。
*/
namespace MatchmakeFlags
{
#endif

/*!
 @brief MatchmakeSession の Option0 のフラグ
*/
enum MatchmakeSessionOption0
{
    /*!
     @brief オプションなし
     */
    MATCHMAKE_SESSION_OPTION0_NONE                    = 0x00000000L,
    /*!
    @brief オートマッチメイク時の強制遅延モードです。(デバック用)
     EDMや失敗率が高いIPアドレスの配下の端末の接続時と同じように、ギャザリング作成を遅延させます。
     デバッグ用のオプションで、 Live 環境では無効となります。
     MATCHMAKE_SESSION_OPTION0_FORCE_AUTOMATCH_NODELAY と併用時は、サーバー間で共有される NAT タイプや NAT トラバーサル失敗率がクリアされ、遅延なしとなります。
     */
    MATCHMAKE_SESSION_OPTION0_FORCE_AUTOMATCH_DELAY   = 0x00000001L,
    /*!
     @brief オートマッチメイク時の強制遅延なしモードです。(デバック用)
     EIMや失敗率の低いIPアドレスの配下の端末の接続時と同じように、ギャザリング作成を遅延させません。
     デバッグ用のオプションで、 Live 環境では無効となります。
     MATCHMAKE_SESSION_OPTION0_FORCE_AUTOMATCH_DELAY と併用時は、サーバー間で共有される NAT タイプや NAT トラバーサル失敗率がクリアされ、遅延なしとなります。
     */
    MATCHMAKE_SESSION_OPTION0_FORCE_AUTOMATCH_NODELAY = 0x00000002L
};

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

