﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Services/Jugem/Matchmake/src/Common/SimpleCommunityDDL.h>

BEGIN_NAMESPACE_NEX

class MatchmakeSession;

/*!
 @brief   コミュニティのギャザリングIDとそのコミュニティに紐づくマッチメイクセッション数を格納するクラスです。

 @ref MatchmakeExtensionClient::GetSimpleCommunity() で使用されます。
 */
#ifdef FOR_DOC_PURPOSE
class SimpleCommunity: public RootObject
#else
class SimpleCommunity: public DDLCLASS(SimpleCommunity)
#endif
{
public:
    /*!
    @brief      コンストラクタです。
    */
    SimpleCommunity() {}

    /*!
    @brief      デストラクタです。
    */
    virtual ~SimpleCommunity() {}

    /*!
     @brief      ギャザリングIDを取得します

     @return   コミュニティのギャザリングID
     */
    PrincipalID GetGatheringID() const
    {
        return m_GatheringID;
    }

    /*!
     @brief      コミュニティに紐づく MatchmakeSession の数を取得します

     @return   @ref MatchmakeSession の数
     */
    qUnsignedInt32 GetMatchmakeSessionCount() const
    {
        return m_MatchmakeSessionCount;
    }

};

END_NAMESPACE_NEX

