﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

/*!
    @brief MatchmakeReferee モジュールのサクセスコードを定義する名前空間です。
*/

#ifdef SWIG
class MatchmakeRefereeErrorCode
{
public:
#else
namespace MatchmakeRefereeErrorCode
{
#endif
    /*!
        @brief    MatchmakeReferee モジュールのエラーコード。
    */
    enum ErrorCode
    {
        START = 1,
        Unknown                   =  1,  //!<   不明なエラーです。
        InvalidArgument           =  2,  //!<   引数が不正です。
        AlreadyExists             =  3,  //!<   すでに存在します。
        NotParticipatedGathering  =  4,  //!<   ギャザリングに参加していません。
        NotParticipatedRound      =  5,  //!<   ラウンドに参加していません。
        StatsNotFound             =  6,  //!<   統計情報が見つかりません。
        RoundNotFound             =  7,  //!<   ラウンドが見つかりません。
        RoundArbitrated           =  8   //!<   ラウンド集計処理が完了しています。
    };
#ifdef SWIG
};
#else
}
#endif


END_NAMESPACE_NEX

