﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingStatsDDL.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingConstants.h>

BEGIN_NAMESPACE_NEX


#ifdef FOR_DOC_PURPOSE
/*!
    @brief      ランキングの統計情報が格納されるクラスです
*/
class RankingStats
#else
class RankingStats: public DDLCLASS(RankingStats)
#endif
{
public:
    /*!
        @brief      コンストラクタです。
    */
    RankingStats()
    {
    }

    /*!
        @brief      デストラクタです。
    */
    virtual ~RankingStats() {};

    /*!
        @brief      統計値を取得します。

        RankingConstants::StatsFlag の値を指定して、統計値を取得します。
        RankingClient::GetStats 関数呼び出し時にフラグを指定していない統計値を取得しようとした場合、0 が返ります。

        @param[in]  flag  取得する統計値のフラグ
    */
    qDouble GetValue(RankingConstants::StatsFlag flag) const;

};

END_NAMESPACE_NEX

