﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class Ranking2Constants
{
public:
#else  // Not SWIG
/*!
    @brief Ranking2 に関する定数が定義された名前空間です。
*/
namespace Ranking2Constants
{
#endif // End of SWIG

/// スコアの同時登録限界数
static const qUnsignedInt32 MAX_PUT_MULTI_SCORES = 20;

/// ランキング指定長の最大値
static const qUnsignedInt32 MAX_RANKING_LENGTH = 100;
/// フレンドランキング指定長の最大値
#if defined(NEX_USE_PRINCIPALID_64BIT)
static const qUnsignedInt32 MAX_FRIEND_RANKING_LENGTH = 301;
#else
static const qUnsignedInt32 MAX_FRIEND_RANKING_LENGTH = 101;
#endif

/// ユーザー名の最大長（文字数）
static const size_t MAX_USERNAME_LENGTH = 16;
/// バイナリデータの最大長（バイト数）
static const size_t MAX_BINARY_DATA_LENGTH = 100;

/// スコアの並び順（昇順）
static const qBool SCORE_ORDER_ASC  = false;
/// スコアの並び順（降順）
static const qBool SCORE_ORDER_DESC = true;

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

