#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "Ranking2ScoreData.h"
#include "Ranking2CommonData.h"
#include "Ranking2GetParam.h"
#include "Ranking2Info.h"
#include "Ranking2GetByListParam.h"
#include "Ranking2CategorySetting.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(Ranking2Protocol, PutScore, 1 );
PROTO_DEFINE_RMCID(Ranking2Protocol, GetCommonData, 2 );
PROTO_DEFINE_RMCID(Ranking2Protocol, PutCommonData, 3 );
PROTO_DEFINE_RMCID(Ranking2Protocol, DeleteCommonData, 4 );
PROTO_DEFINE_RMCID(Ranking2Protocol, GetRanking, 5 );
PROTO_DEFINE_RMCID(Ranking2Protocol, GetRankingByPrincipalId, 6 );
PROTO_DEFINE_RMCID(Ranking2Protocol, GetCategorySetting, 7 );
PROTO_DEFINE_NUM_RMC(Ranking2Protocol, 7);

class Ranking2ProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(qvector)< CLASSMETATYPE(Ranking2ScoreData) > TPutScore_scoreDataList;
        typedef DDLTYPE(uint64) TPutScore_nexUniqueId;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, PutScore)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(Ranking2CommonData) TGetCommonData_commonData;
        typedef DDLTYPE(uint32) TGetCommonData_optionFlags;
        typedef DDLTYPE(uint32) TGetCommonData_principalId;
        typedef DDLTYPE(uint64) TGetCommonData_nexUniqueId;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, GetCommonData)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetCommonData_commonData,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(Ranking2CommonData) TPutCommonData_commonData;
        typedef DDLTYPE(uint64) TPutCommonData_nexUniqueId;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, PutCommonData)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint64) TDeleteCommonData_nexUniqueId;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, DeleteCommonData)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(Ranking2GetParam) TGetRanking_getParam;
        typedef CLASSMETATYPE(Ranking2Info) TGetRanking_rankingInfo;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, GetRanking)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRanking_rankingInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(Ranking2GetByListParam) TGetRankingByPrincipalId_getParam;
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetRankingByPrincipalId_principalIdList;
        typedef CLASSMETATYPE(Ranking2Info) TGetRankingByPrincipalId_rankingInfo;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, GetRankingByPrincipalId)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRankingByPrincipalId_rankingInfo,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetCategorySetting_category;
        typedef CLASSMETATYPE(Ranking2CategorySetting) TGetCategorySetting_categorySetting;
        PROTO_RMCIMPL_RETURN(Ranking2Protocol, GetCategorySetting)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetCategorySetting_categorySetting,1);
            PROTO_RETURNSTUB_END();
        };
        
        Ranking2ProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew Ranking2ProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallPutScore(ProtocolCallContext *pContext, const DDLTYPE(qvector)< CLASSMETATYPE(Ranking2ScoreData) >::CPPType& scoreDataList, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        static qBool PutScore_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< CLASSMETATYPE(Ranking2ScoreData) >::CPPType& scoreDataList, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        qBool CallGetCommonData(ProtocolCallContext *pContext, Ranking2CommonData* commonData, const DDLTYPE(uint32)::CPPType& optionFlags, const DDLTYPE(uint32)::CPPType& principalId, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        static qBool GetCommonData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, Ranking2CommonData* commonData, const DDLTYPE(uint32)::CPPType& optionFlags, const DDLTYPE(uint32)::CPPType& principalId, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        qBool CallPutCommonData(ProtocolCallContext *pContext, const Ranking2CommonData& commonData, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        static qBool PutCommonData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const Ranking2CommonData& commonData, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        qBool CallDeleteCommonData(ProtocolCallContext *pContext, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        static qBool DeleteCommonData_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint64)::CPPType& nexUniqueId);
        qBool CallGetRanking(ProtocolCallContext *pContext, const Ranking2GetParam& getParam, Ranking2Info* rankingInfo);
        static qBool GetRanking_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const Ranking2GetParam& getParam, Ranking2Info* rankingInfo);
        qBool CallGetRankingByPrincipalId(ProtocolCallContext *pContext, const Ranking2GetByListParam& getParam, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& principalIdList, Ranking2Info* rankingInfo);
        static qBool GetRankingByPrincipalId_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const Ranking2GetByListParam& getParam, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& principalIdList, Ranking2Info* rankingInfo);
        qBool CallGetCategorySetting(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& category, Ranking2CategorySetting* categorySetting);
        static qBool GetCategorySetting_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& category, Ranking2CategorySetting* categorySetting);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(Ranking2Protocol) + 1];
};

class DDLPROTOCOL(Ranking2ProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(Ranking2ProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_PutScoreProfilingUnit(NEX_T("Ranking2Protocol::PutScore"))
            , m_GetCommonDataProfilingUnit(NEX_T("Ranking2Protocol::GetCommonData"))
            , m_PutCommonDataProfilingUnit(NEX_T("Ranking2Protocol::PutCommonData"))
            , m_DeleteCommonDataProfilingUnit(NEX_T("Ranking2Protocol::DeleteCommonData"))
            , m_GetRankingProfilingUnit(NEX_T("Ranking2Protocol::GetRanking"))
            , m_GetRankingByPrincipalIdProfilingUnit(NEX_T("Ranking2Protocol::GetRankingByPrincipalId"))
            , m_GetCategorySettingProfilingUnit(NEX_T("Ranking2Protocol::GetCategorySetting"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(qvector)< CLASSMETATYPE(Ranking2ScoreData) > TPutScore_scoreDataList;
        typedef DDLTYPE(uint64) TPutScore_nexUniqueId;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, PutScore)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< CLASSMETATYPE(Ranking2ScoreData) >::CPPType scoreDataList;
            _MSG_EXTRACT_VARIABLE(TPutScore_scoreDataList, scoreDataList);
            DDLTYPE(uint64)::CPPType nexUniqueId;
            _MSG_EXTRACT_VARIABLE(TPutScore_nexUniqueId, nexUniqueId);
            pProtocol->PutScore( scoreDataList, nexUniqueId );
            PROTO_PREPARE_RETURN(Ranking2Protocol,PutScore);
        }
        
        typedef CLASSMETATYPE(Ranking2CommonData) TGetCommonData_commonData;
        typedef DDLTYPE(uint32) TGetCommonData_optionFlags;
        typedef DDLTYPE(uint32) TGetCommonData_principalId;
        typedef DDLTYPE(uint64) TGetCommonData_nexUniqueId;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, GetCommonData)
        {
            PROTO_PREPARE_EXTRACTION();
            Ranking2CommonData commonData;
            DDLTYPE(uint32)::CPPType optionFlags;
            _MSG_EXTRACT_VARIABLE(TGetCommonData_optionFlags, optionFlags);
            DDLTYPE(uint32)::CPPType principalId;
            _MSG_EXTRACT_VARIABLE(TGetCommonData_principalId, principalId);
            DDLTYPE(uint64)::CPPType nexUniqueId;
            _MSG_EXTRACT_VARIABLE(TGetCommonData_nexUniqueId, nexUniqueId);
            pProtocol->GetCommonData( &commonData, optionFlags, principalId, nexUniqueId );
            PROTO_PREPARE_RETURN(Ranking2Protocol,GetCommonData);
            _MSG_ADD_VARIABLE(TGetCommonData_commonData, commonData);
        }
        
        typedef CLASSMETATYPE(Ranking2CommonData) TPutCommonData_commonData;
        typedef DDLTYPE(uint64) TPutCommonData_nexUniqueId;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, PutCommonData)
        {
            PROTO_PREPARE_EXTRACTION();
            Ranking2CommonData commonData;
            _MSG_EXTRACT_VARIABLE(TPutCommonData_commonData, commonData);
            DDLTYPE(uint64)::CPPType nexUniqueId;
            _MSG_EXTRACT_VARIABLE(TPutCommonData_nexUniqueId, nexUniqueId);
            pProtocol->PutCommonData( commonData, nexUniqueId );
            PROTO_PREPARE_RETURN(Ranking2Protocol,PutCommonData);
        }
        
        typedef DDLTYPE(uint64) TDeleteCommonData_nexUniqueId;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, DeleteCommonData)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint64)::CPPType nexUniqueId;
            _MSG_EXTRACT_VARIABLE(TDeleteCommonData_nexUniqueId, nexUniqueId);
            pProtocol->DeleteCommonData( nexUniqueId );
            PROTO_PREPARE_RETURN(Ranking2Protocol,DeleteCommonData);
        }
        
        typedef CLASSMETATYPE(Ranking2GetParam) TGetRanking_getParam;
        typedef CLASSMETATYPE(Ranking2Info) TGetRanking_rankingInfo;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, GetRanking)
        {
            PROTO_PREPARE_EXTRACTION();
            Ranking2GetParam getParam;
            _MSG_EXTRACT_VARIABLE(TGetRanking_getParam, getParam);
            Ranking2Info rankingInfo;
            pProtocol->GetRanking( getParam, &rankingInfo );
            PROTO_PREPARE_RETURN(Ranking2Protocol,GetRanking);
            _MSG_ADD_VARIABLE(TGetRanking_rankingInfo, rankingInfo);
        }
        
        typedef CLASSMETATYPE(Ranking2GetByListParam) TGetRankingByPrincipalId_getParam;
        typedef DDLTYPE(qvector)< DDLTYPE(uint32) > TGetRankingByPrincipalId_principalIdList;
        typedef CLASSMETATYPE(Ranking2Info) TGetRankingByPrincipalId_rankingInfo;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, GetRankingByPrincipalId)
        {
            PROTO_PREPARE_EXTRACTION();
            Ranking2GetByListParam getParam;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPrincipalId_getParam, getParam);
            DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType principalIdList;
            _MSG_EXTRACT_VARIABLE(TGetRankingByPrincipalId_principalIdList, principalIdList);
            Ranking2Info rankingInfo;
            pProtocol->GetRankingByPrincipalId( getParam, principalIdList, &rankingInfo );
            PROTO_PREPARE_RETURN(Ranking2Protocol,GetRankingByPrincipalId);
            _MSG_ADD_VARIABLE(TGetRankingByPrincipalId_rankingInfo, rankingInfo);
        }
        
        typedef DDLTYPE(uint32) TGetCategorySetting_category;
        typedef CLASSMETATYPE(Ranking2CategorySetting) TGetCategorySetting_categorySetting;
        PROTO_RMCIMPL_STUB(Ranking2Protocol, GetCategorySetting)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType category;
            _MSG_EXTRACT_VARIABLE(TGetCategorySetting_category, category);
            Ranking2CategorySetting categorySetting;
            pProtocol->GetCategorySetting( category, &categorySetting );
            PROTO_PREPARE_RETURN(Ranking2Protocol,GetCategorySetting);
            _MSG_ADD_VARIABLE(TGetCategorySetting_categorySetting, categorySetting);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void PutScore(const DDLTYPE(qvector)< CLASSMETATYPE(Ranking2ScoreData) >::CPPType& scoreDataList, const DDLTYPE(uint64)::CPPType& nexUniqueId) = 0;
        virtual void GetCommonData(Ranking2CommonData* commonData, const DDLTYPE(uint32)::CPPType& optionFlags, const DDLTYPE(uint32)::CPPType& principalId, const DDLTYPE(uint64)::CPPType& nexUniqueId) = 0;
        virtual void PutCommonData(const Ranking2CommonData& commonData, const DDLTYPE(uint64)::CPPType& nexUniqueId) = 0;
        virtual void DeleteCommonData(const DDLTYPE(uint64)::CPPType& nexUniqueId) = 0;
        virtual void GetRanking(const Ranking2GetParam& getParam, Ranking2Info* rankingInfo) = 0;
        virtual void GetRankingByPrincipalId(const Ranking2GetByListParam& getParam, const DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType& principalIdList, Ranking2Info* rankingInfo) = 0;
        virtual void GetCategorySetting(const DDLTYPE(uint32)::CPPType& category, Ranking2CategorySetting* categorySetting) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_PutScoreProfilingUnit;
        ProfilingUnit m_GetCommonDataProfilingUnit;
        ProfilingUnit m_PutCommonDataProfilingUnit;
        ProfilingUnit m_DeleteCommonDataProfilingUnit;
        ProfilingUnit m_GetRankingProfilingUnit;
        ProfilingUnit m_GetRankingByPrincipalIdProfilingUnit;
        ProfilingUnit m_GetCategorySettingProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
