﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#ifdef SWIG
class Ranking2ResetMode
{
public:
#else  // Not SWIG
/*!
    @brief Ranking2 の定期リセットモードを定義する名前空間です。
*/
namespace Ranking2ResetMode
{
#endif // End of SWIG
/*!
    @brief ランキングの定期リセットモード。
*/
enum Ranking2ResetMode
{
    NOTHING             = 0, //!< 定期リセットなし
    EVERYDAY            = 1, //!< 毎日○時
    EVERYWEEK           = 2, //!< 毎週○曜日○時
    MULTI_MONTH         = 3, //!< ○（リスト）月○日○時
    MULTI_MONTH_WEEKDAY = 4, //!< ○（リスト）月第１○曜日○時
    MIN                 = NOTHING,
    MAX                 = MULTI_MONTH_WEEKDAY
};

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

