﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/Jugem/ServiceItem/src/Common/ServiceItemDDF.h>

BEGIN_NAMESPACE_NEX

/*!
    @brief サービスアイテム機能を利用するためのインタフェースです。
*/
class ServiceItemClientInterface
{
public:

    /*!
    @brief      コンストラクタです。

    コンストラクタです。
    */
    ServiceItemClientInterface(){};

    /*!
    @brief      デストラクタです。

    デストラクタです。
    */
    virtual ~ServiceItemClientInterface(){};

    qBool virtual PurchaseServiceItem(ProtocolCallContext *pContext, const ServiceItemPurchaseServiceItemParam& request,
                                      ServiceItemPurchaseServiceItemResponse* response) = 0;
    qBool virtual RedeemServiceItem(ProtocolCallContext *pContext, const ServiceItemRedeemServiceItemParam& request,
                                    ServiceItemRedeemServiceItemResponse* response) = 0;
};

END_NAMESPACE_NEX

