﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/*!
    @brief Subscriber に関する定数が定義された名前空間です。
*/
namespace SubscriberConstants
{
/// トピックに保持するコンテンツ数。
static const qUnsignedInt32 MAX_TOPIC_CONTENT_SIZE = 100;

/// タイムラインに保持するコンテンツ数。
static const qUnsignedInt32 MAX_TIMELINE_CONTENT_SIZE = 100;

/// フォロー可能な最大数。
static const qUnsignedInt32 MAX_FOLLOWING_SIZE = 20;

/// 予約済みトピックの個数。
static const qUnsignedInt32 NUM_RESERVED_TOPICS = 128;

/// 無効な予約済みトピック番号。
static const qUnsignedInt32 INVALID_RESERVED_TOPIC_NUM = 0xffffffff;

/// 一度に取得可能なフォロワーの最大数。
static const qUnsignedInt32 MAX_GET_FOLLOWER_SIZE = 1000;

/// コンテンツに含められるメッセージの長さ。
static const qUnsignedInt32 MAX_CONTENT_MESSAGE_LEN = 140;

/// コンテンツに含められるバイナリのサイズ。
static const qUnsignedInt32 MAX_CONTENT_BINARY_SIZE = 256;

/// 一つのコンテンツの投稿先に指定できるトピックの最大数。
static const qUnsignedInt32 MAX_POST_CONTENT_TOPIC_SIZE = 10;

/// SubscriberClient::GetContent()で一度に指定できるパラメータの数。
static const size_t MAX_GET_CONTENT_PARAMS_SIZE = 3;
}

END_NAMESPACE_NEX

