﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2017 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#pragma once

BEGIN_NAMESPACE_NEX

/*!
    @brief Subscriber モジュールのサクセスコードを定義する名前空間です。
*/

#ifdef SWIG
class SubscriberErrorCode
{
public:
#else
namespace SubscriberErrorCode
{
#endif
    /*!
        @brief    Subscriber モジュールのエラーコード。
    */
    enum ErrorCode
    {
        START = 1,
        Unknown                   =  1,  //!<   不明なエラーです。
        InvalidArgument           =  2,  //!<   引数が不正です。
        OverLimit                 =  3,  //!<   限界数を超えた。
        PermissionDenied          =  4   //!<   権限がない。
    };
#ifdef SWIG
};
#else
}
#endif


END_NAMESPACE_NEX

