﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

#ifdef NEX_SIGLO_FAMILY
#include <RendezVous/Services/Jugem/Utility/src/Client/ErrorDefine.h>
#include <OnlineCore/src/Platform/Core/ErrorCodeFacility.h>

#include <nn/nn_Result.h>
#include <nn/result/result_ErrorResult.h>

BEGIN_NAMESPACE_NEX

#define NEX_NNRESULT_MODULE_CODE 306
#define NEX_NNRESULT_SPECIAL_DESCRIPTION_NUMBER_START 8000 // 特別なデスクリプション番号のスタート

#define NEX_ERROR_RESULT_DEFINE(FACILITY, CODE)  \
    NN_DEFINE_ERROR_RANGE_RESULT( Result##FACILITY##CODE, NEX_NNRESULT_MODULE_CODE, \
        100 * ( NAMESPACE_NEX ErrorCodeFacility:: FACILITY ) + ( NAMESPACE_NEX FACILITY##ErrorCode::CODE ) \
            - ( NAMESPACE_NEX FACILITY##ErrorCode::START ) \
            + ( NAMESPACE_NEX ErrorCodeFacilityOffset:: FACILITY), \
        100 * ( NAMESPACE_NEX ErrorCodeFacility:: FACILITY ) + ( NAMESPACE_NEX FACILITY##ErrorCode::CODE ) \
            - ( NAMESPACE_NEX FACILITY##ErrorCode::START ) \
            + ( NAMESPACE_NEX ErrorCodeFacilityOffset:: FACILITY) + 1)
#define NEX_ERROR_RESULT_DEFINE_WITHINDEX(FACILITY, CODE, INDEX)  \
    NN_DEFINE_ERROR_RANGE_RESULT( Result##FACILITY##CODE, NEX_NNRESULT_MODULE_CODE, \
        100 * ( NAMESPACE_NEX ErrorCodeFacility:: FACILITY ) + INDEX \
            + ( NAMESPACE_NEX ErrorCodeFacilityOffset:: FACILITY), \
        100 * ( NAMESPACE_NEX ErrorCodeFacility:: FACILITY ) + INDEX \
            + ( NAMESPACE_NEX ErrorCodeFacilityOffset:: FACILITY) + 1)

#include<OnlineCore/src/Platform/Core/ResultDefine.h>
#undef NEX_ERROR_RESULT_DEFINE
#undef NEX_ERROR_RESULT_DEFINE_WITHINDEX

#ifdef FOR_DOC_PURPOSE
#define NN_DEFINE_ERROR_RANGE_RESULT(name, module, descriptionBegin, descriptionEnd) class name {}
#endif // FOR_DOC_PURPOSE


/*! @addtogroup nnResult
 *  @{
 **/
NN_DEFINE_ERROR_RANGE_RESULT(ResultUnexpectError, NEX_NNRESULT_MODULE_CODE, 0, 1);  //!<    内部変換失敗、もしくは、初期値のまま
/** @} */ // end of nnResult

/*! @addtogroup nnResultCoreFacility
 *  @{
 **/

/*!
 *   処理が進行中。成功でもエラーでもない状態です。 QSUCCESS(Core,SuccressPending) は、本来成功値ですが、 nn::Result にはエラーとして変換します。
 */
NN_DEFINE_ERROR_RANGE_RESULT(ResultCoreSuccessPending, NEX_NNRESULT_MODULE_CODE, NEX_NNRESULT_SPECIAL_DESCRIPTION_NUMBER_START + 0, NEX_NNRESULT_SPECIAL_DESCRIPTION_NUMBER_START + 1);
/*! @} */ // end of nnResult


END_NAMESPACE_NEX

#endif
