﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

/*!
    @brief        サーバーが発行するユニークな ID です。
*/
typedef qUnsignedInt64 UniqueId;

/*!
    @brief        ユニーク ID の所有者である事を判別するためのパスワードです。
*/
typedef qUnsignedInt64 UniqueIdPassword;


/*!
    @brief        無効なユニーク ID です。
*/
static const UniqueId INVALID_UNIQUEID = 0;

/*!
    @brief        パスワードの無効値です。この値がパスワードに設定されることはありません。
*/
static const qUnsignedInt64 INVALID_UNIQUEID_PASSWORD = 0;


END_NAMESPACE_NEX

