#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "Gathering.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "OnlineCore/src/DDLTypes/STLExtTypes.h"
#include "InvitationDDL.h"
#include "ParticipantDetailsDDL.h"
#include "RendezVous/Core/src/Common/ResultRange.h"
#include "GatheringStatsDDL.h"
#include "DeletionEntryDDL.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MatchMakingProtocol, RegisterGathering, 1 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UnregisterGathering, 2 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UnregisterGatherings, 3 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UpdateGathering, 4 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, Invite, 5 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, AcceptInvitation, 6 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, DeclineInvitation, 7 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, CancelInvitation, 8 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetInvitationsSent, 9 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetInvitationsReceived, 10 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, Participate, 11 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, CancelParticipation, 12 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetParticipants, 13 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, AddParticipants, 14 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetDetailedParticipants, 15 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetParticipantsURLs, 16 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByType, 17 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByDescription, 18 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByDescriptionRegex, 19 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByID, 20 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindBySingleID, 21 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByOwner, 22 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByParticipants, 23 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindInvitations, 24 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindBySQLQuery, 25 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, LaunchSession, 26 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UpdateSessionURL, 27 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetSessionURL, 28 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetState, 29 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, SetState, 30 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, ReportStats, 31 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetStats, 32 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, DeleteGathering, 33 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetPendingDeletions, 34 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, DeleteFromDeletions, 35 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, MigrateGatheringOwnershipV1, 36 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, FindByDescriptionLike, 37 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, RegisterLocalURL, 38 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, RegisterLocalURLs, 39 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UpdateSessionHostV1, 40 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, GetSessionURLs, 41 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UpdateSessionHost, 42 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, UpdateGatheringOwnership, 43 );
PROTO_DEFINE_RMCID(MatchMakingProtocol, MigrateGatheringOwnership, 44 );
PROTO_DEFINE_NUM_RMC(MatchMakingProtocol, 44);

class MatchMakingProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(uint32) TRegisterGathering_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TRegisterGathering_anyGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, RegisterGathering)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TRegisterGathering_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TUnregisterGathering_result;
        typedef DDLTYPE(uint32) TUnregisterGathering_idGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UnregisterGathering)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUnregisterGathering_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TUnregisterGatherings_result;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TUnregisterGatherings_lstGatherings;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UnregisterGatherings)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUnregisterGatherings_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TUpdateGathering_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TUpdateGathering_anyGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UpdateGathering)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUpdateGathering_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TInvite_result;
        typedef DDLTYPE(uint32) TInvite_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TInvite_lstPrincipals;
        typedef DDLTYPE(string) TInvite_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, Invite)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TInvite_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TAcceptInvitation_result;
        typedef DDLTYPE(uint32) TAcceptInvitation_idGathering;
        typedef DDLTYPE(string) TAcceptInvitation_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, AcceptInvitation)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAcceptInvitation_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TDeclineInvitation_result;
        typedef DDLTYPE(uint32) TDeclineInvitation_idGathering;
        typedef DDLTYPE(string) TDeclineInvitation_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, DeclineInvitation)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDeclineInvitation_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TCancelInvitation_result;
        typedef DDLTYPE(uint32) TCancelInvitation_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TCancelInvitation_lstPrincipals;
        typedef DDLTYPE(string) TCancelInvitation_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, CancelInvitation)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCancelInvitation_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetInvitationsSent_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(Invitation) > TGetInvitationsSent_lstInvitations;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetInvitationsSent)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetInvitationsSent_lstInvitations,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< CLASSMETATYPE(Invitation) > TGetInvitationsReceived_lstInvitations;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetInvitationsReceived)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetInvitationsReceived_lstInvitations,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TParticipate_result;
        typedef DDLTYPE(uint32) TParticipate_idGathering;
        typedef DDLTYPE(string) TParticipate_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, Participate)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TParticipate_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TCancelParticipation_result;
        typedef DDLTYPE(uint32) TCancelParticipation_idGathering;
        typedef DDLTYPE(string) TCancelParticipation_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, CancelParticipation)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TCancelParticipation_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetParticipants_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetParticipants_lstParticipants;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetParticipants_lstParticipants,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TAddParticipants_result;
        typedef DDLTYPE(uint32) TAddParticipants_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TAddParticipants_lstParticipants;
        typedef DDLTYPE(string) TAddParticipants_strMessage;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, AddParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TAddParticipants_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetDetailedParticipants_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) > TGetDetailedParticipants_lstParticipants;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetDetailedParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetDetailedParticipants_lstParticipants,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetParticipantsURLs_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TGetParticipantsURLs_lstStationURL;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetParticipantsURLs)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetParticipantsURLs_lstStationURL,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TFindByType_strType;
        typedef CLASSMETATYPE(ResultRange) TFindByType_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByType_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByType)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByType_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TFindByDescription_strDescription;
        typedef CLASSMETATYPE(ResultRange) TFindByDescription_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByDescription_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByDescription)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByDescription_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TFindByDescriptionRegex_strDescriptionRegex;
        typedef CLASSMETATYPE(ResultRange) TFindByDescriptionRegex_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByDescriptionRegex_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByDescriptionRegex)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByDescriptionRegex_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TFindByID_lstID;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByID_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByID)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByID_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindBySingleID_id;
        typedef DDLTYPE(bool) TFindBySingleID_bResult;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TFindBySingleID_pGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindBySingleID)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindBySingleID_bResult,1);
            _DO_RMC_ExtractReturnValue(TFindBySingleID_pGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TFindByOwner_id;
        typedef CLASSMETATYPE(ResultRange) TFindByOwner_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByOwner_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByOwner)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByOwner_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TFindByParticipants_pid;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByParticipants_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByParticipants)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByParticipants_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(ResultRange) TFindInvitations_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindInvitations_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindInvitations)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindInvitations_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TFindBySQLQuery_strQuery;
        typedef CLASSMETATYPE(ResultRange) TFindBySQLQuery_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindBySQLQuery_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindBySQLQuery)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindBySQLQuery_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TLaunchSession_result;
        typedef DDLTYPE(uint32) TLaunchSession_idGathering;
        typedef DDLTYPE(string) TLaunchSession_strURL;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, LaunchSession)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TLaunchSession_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TUpdateSessionURL_result;
        typedef DDLTYPE(uint32) TUpdateSessionURL_idGathering;
        typedef DDLTYPE(string) TUpdateSessionURL_strURL;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UpdateSessionURL)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TUpdateSessionURL_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetSessionURL_result;
        typedef DDLTYPE(uint32) TGetSessionURL_idGathering;
        typedef DDLTYPE(string) TGetSessionURL_strURL;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetSessionURL)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSessionURL_result,1);
            _DO_RMC_ExtractReturnValue(TGetSessionURL_strURL,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetState_result;
        typedef DDLTYPE(uint32) TGetState_idGathering;
        typedef DDLTYPE(uint32) TGetState_uiState;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetState)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetState_result,1);
            _DO_RMC_ExtractReturnValue(TGetState_uiState,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TSetState_result;
        typedef DDLTYPE(uint32) TSetState_idGathering;
        typedef DDLTYPE(uint32) TSetState_uiNewState;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, SetState)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TSetState_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TReportStats_result;
        typedef DDLTYPE(uint32) TReportStats_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) > TReportStats_lstStats;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, ReportStats)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TReportStats_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetStats_result;
        typedef DDLTYPE(uint32) TGetStats_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetStats_lstParticipants;
        typedef DDLTYPE(std_list)< DDLTYPE(byte) > TGetStats_lstColumns;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) > TGetStats_plstStats;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetStats)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetStats_result,1);
            _DO_RMC_ExtractReturnValue(TGetStats_plstStats,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TDeleteGathering_result;
        typedef DDLTYPE(uint32) TDeleteGathering_gid;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, DeleteGathering)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDeleteGathering_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TGetPendingDeletions_result;
        typedef DDLTYPE(uint32) TGetPendingDeletions_uiReason;
        typedef CLASSMETATYPE(ResultRange) TGetPendingDeletions_resultRange;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(DeletionEntry) > TGetPendingDeletions_lstDeletions;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetPendingDeletions)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetPendingDeletions_result,1);
            _DO_RMC_ExtractReturnValue(TGetPendingDeletions_lstDeletions,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TDeleteFromDeletions_result;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeleteFromDeletions_lstDeletions;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, DeleteFromDeletions)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TDeleteFromDeletions_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(bool) TMigrateGatheringOwnershipV1_result;
        typedef DDLTYPE(uint32) TMigrateGatheringOwnershipV1_gid;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TMigrateGatheringOwnershipV1_lstPotentialNewOwnersID;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, MigrateGatheringOwnershipV1)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TMigrateGatheringOwnershipV1_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TFindByDescriptionLike_strDescriptionLike;
        typedef CLASSMETATYPE(ResultRange) TFindByDescriptionLike_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByDescriptionLike_lstGathering;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, FindByDescriptionLike)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TFindByDescriptionLike_lstGathering,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TRegisterLocalURL_gid;
        typedef DDLTYPE(string) TRegisterLocalURL_url;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, RegisterLocalURL)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TRegisterLocalURLs_gid;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRegisterLocalURLs_lstUrls;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, RegisterLocalURLs)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateSessionHostV1_gid;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UpdateSessionHostV1)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetSessionURLs_gid;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TGetSessionURLs_lstURLs;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, GetSessionURLs)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetSessionURLs_lstURLs,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateSessionHost_gid;
        typedef DDLTYPE(bool) TUpdateSessionHost_isMigrateOwner;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UpdateSessionHost)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TUpdateGatheringOwnership_gid;
        typedef DDLTYPE(bool) TUpdateGatheringOwnership_participantsOnly;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, UpdateGatheringOwnership)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TMigrateGatheringOwnership_gid;
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TMigrateGatheringOwnership_lstPotentialNewOwnersID;
        typedef DDLTYPE(bool) TMigrateGatheringOwnership_participantsOnly;
        PROTO_RMCIMPL_RETURN(MatchMakingProtocol, MigrateGatheringOwnership)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        MatchMakingProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew MatchMakingProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallRegisterGathering(ProtocolCallContext *pContext, DDLTYPE(uint32)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering);
        static qBool RegisterGathering_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(uint32)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering);
        qBool CallUnregisterGathering(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering);
        static qBool UnregisterGathering_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering);
        qBool CallUnregisterGatherings(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstGatherings);
        static qBool UnregisterGatherings_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstGatherings);
        qBool CallUpdateGathering(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering);
        static qBool UpdateGathering_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering);
        qBool CallInvite(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, const DDLTYPE(string)::CPPType& strMessage);
        static qBool Invite_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallAcceptInvitation(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool AcceptInvitation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallDeclineInvitation(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool DeclineInvitation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallCancelInvitation(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, const DDLTYPE(string)::CPPType& strMessage);
        static qBool CancelInvitation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallGetInvitationsSent(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType* lstInvitations);
        static qBool GetInvitationsSent_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType* lstInvitations);
        qBool CallGetInvitationsReceived(ProtocolCallContext *pContext, DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType* lstInvitations);
        static qBool GetInvitationsReceived_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType* lstInvitations);
        qBool CallParticipate(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool Participate_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallCancelParticipation(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        static qBool CancelParticipation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallGetParticipants(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants);
        static qBool GetParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants);
        qBool CallAddParticipants(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstParticipants, const DDLTYPE(string)::CPPType& strMessage);
        static qBool AddParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstParticipants, const DDLTYPE(string)::CPPType& strMessage);
        qBool CallGetDetailedParticipants(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType* lstParticipants);
        static qBool GetDetailedParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType* lstParticipants);
        qBool CallGetParticipantsURLs(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* lstStationURL);
        static qBool GetParticipantsURLs_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* lstStationURL);
        qBool CallFindByType(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strType, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByType_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strType, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindByDescription(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strDescription, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByDescription_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strDescription, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindByDescriptionRegex(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strDescriptionRegex, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByDescriptionRegex_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strDescriptionRegex, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindByID(ProtocolCallContext *pContext, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstID, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByID_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstID, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindBySingleID(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& id, DDLTYPE(bool)::CPPType* bResult, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* pGathering);
        static qBool FindBySingleID_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& id, DDLTYPE(bool)::CPPType* bResult, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* pGathering);
        qBool CallFindByOwner(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByOwner_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindByParticipants(ProtocolCallContext *pContext, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& pid, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByParticipants_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& pid, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindInvitations(ProtocolCallContext *pContext, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindInvitations_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallFindBySQLQuery(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strQuery, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindBySQLQuery_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strQuery, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallLaunchSession(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strURL);
        static qBool LaunchSession_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strURL);
        qBool CallUpdateSessionURL(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strURL);
        static qBool UpdateSessionURL_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strURL);
        qBool CallGetSessionURL(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(string)::CPPType* strURL);
        static qBool GetSessionURL_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(string)::CPPType* strURL);
        qBool CallGetState(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(uint32)::CPPType* uiState);
        static qBool GetState_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(uint32)::CPPType* uiState);
        qBool CallSetState(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(uint32)::CPPType& uiNewState);
        static qBool SetState_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(uint32)::CPPType& uiNewState);
        qBool CallReportStats(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType& lstStats);
        static qBool ReportStats_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType& lstStats);
        qBool CallGetStats(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstParticipants, const DDLTYPE(std_list)< DDLTYPE(byte) >::CPPType& lstColumns, DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType* plstStats);
        static qBool GetStats_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstParticipants, const DDLTYPE(std_list)< DDLTYPE(byte) >::CPPType& lstColumns, DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType* plstStats);
        qBool CallDeleteGathering(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& gid);
        static qBool DeleteGathering_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& gid);
        qBool CallGetPendingDeletions(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& uiReason, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(DeletionEntry) >::CPPType* lstDeletions);
        static qBool GetPendingDeletions_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& uiReason, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(DeletionEntry) >::CPPType* lstDeletions);
        qBool CallDeleteFromDeletions(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstDeletions);
        static qBool DeleteFromDeletions_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstDeletions);
        qBool CallMigrateGatheringOwnershipV1(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPotentialNewOwnersID);
        static qBool MigrateGatheringOwnershipV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPotentialNewOwnersID);
        qBool CallFindByDescriptionLike(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& strDescriptionLike, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        static qBool FindByDescriptionLike_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& strDescriptionLike, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering);
        qBool CallRegisterLocalURL(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& url);
        static qBool RegisterLocalURL_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& url);
        qBool CallRegisterLocalURLs(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& lstUrls);
        static qBool RegisterLocalURLs_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& lstUrls);
        qBool CallUpdateSessionHostV1(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid);
        static qBool UpdateSessionHostV1_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid);
        qBool CallGetSessionURLs(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* lstURLs);
        static qBool GetSessionURLs_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* lstURLs);
        qBool CallUpdateSessionHost(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(bool)::CPPType& isMigrateOwner);
        static qBool UpdateSessionHost_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(bool)::CPPType& isMigrateOwner);
        qBool CallUpdateGatheringOwnership(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(bool)::CPPType& participantsOnly);
        static qBool UpdateGatheringOwnership_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(bool)::CPPType& participantsOnly);
        qBool CallMigrateGatheringOwnership(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPotentialNewOwnersID, const DDLTYPE(bool)::CPPType& participantsOnly);
        static qBool MigrateGatheringOwnership_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPotentialNewOwnersID, const DDLTYPE(bool)::CPPType& participantsOnly);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MatchMakingProtocol) + 1];
};

class DDLPROTOCOL(MatchMakingProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(MatchMakingProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_RegisterGatheringProfilingUnit(NEX_T("MatchMakingProtocol::RegisterGathering"))
            , m_UnregisterGatheringProfilingUnit(NEX_T("MatchMakingProtocol::UnregisterGathering"))
            , m_UnregisterGatheringsProfilingUnit(NEX_T("MatchMakingProtocol::UnregisterGatherings"))
            , m_UpdateGatheringProfilingUnit(NEX_T("MatchMakingProtocol::UpdateGathering"))
            , m_InviteProfilingUnit(NEX_T("MatchMakingProtocol::Invite"))
            , m_AcceptInvitationProfilingUnit(NEX_T("MatchMakingProtocol::AcceptInvitation"))
            , m_DeclineInvitationProfilingUnit(NEX_T("MatchMakingProtocol::DeclineInvitation"))
            , m_CancelInvitationProfilingUnit(NEX_T("MatchMakingProtocol::CancelInvitation"))
            , m_GetInvitationsSentProfilingUnit(NEX_T("MatchMakingProtocol::GetInvitationsSent"))
            , m_GetInvitationsReceivedProfilingUnit(NEX_T("MatchMakingProtocol::GetInvitationsReceived"))
            , m_ParticipateProfilingUnit(NEX_T("MatchMakingProtocol::Participate"))
            , m_CancelParticipationProfilingUnit(NEX_T("MatchMakingProtocol::CancelParticipation"))
            , m_GetParticipantsProfilingUnit(NEX_T("MatchMakingProtocol::GetParticipants"))
            , m_AddParticipantsProfilingUnit(NEX_T("MatchMakingProtocol::AddParticipants"))
            , m_GetDetailedParticipantsProfilingUnit(NEX_T("MatchMakingProtocol::GetDetailedParticipants"))
            , m_GetParticipantsURLsProfilingUnit(NEX_T("MatchMakingProtocol::GetParticipantsURLs"))
            , m_FindByTypeProfilingUnit(NEX_T("MatchMakingProtocol::FindByType"))
            , m_FindByDescriptionProfilingUnit(NEX_T("MatchMakingProtocol::FindByDescription"))
            , m_FindByDescriptionRegexProfilingUnit(NEX_T("MatchMakingProtocol::FindByDescriptionRegex"))
            , m_FindByIDProfilingUnit(NEX_T("MatchMakingProtocol::FindByID"))
            , m_FindBySingleIDProfilingUnit(NEX_T("MatchMakingProtocol::FindBySingleID"))
            , m_FindByOwnerProfilingUnit(NEX_T("MatchMakingProtocol::FindByOwner"))
            , m_FindByParticipantsProfilingUnit(NEX_T("MatchMakingProtocol::FindByParticipants"))
            , m_FindInvitationsProfilingUnit(NEX_T("MatchMakingProtocol::FindInvitations"))
            , m_FindBySQLQueryProfilingUnit(NEX_T("MatchMakingProtocol::FindBySQLQuery"))
            , m_LaunchSessionProfilingUnit(NEX_T("MatchMakingProtocol::LaunchSession"))
            , m_UpdateSessionURLProfilingUnit(NEX_T("MatchMakingProtocol::UpdateSessionURL"))
            , m_GetSessionURLProfilingUnit(NEX_T("MatchMakingProtocol::GetSessionURL"))
            , m_GetStateProfilingUnit(NEX_T("MatchMakingProtocol::GetState"))
            , m_SetStateProfilingUnit(NEX_T("MatchMakingProtocol::SetState"))
            , m_ReportStatsProfilingUnit(NEX_T("MatchMakingProtocol::ReportStats"))
            , m_GetStatsProfilingUnit(NEX_T("MatchMakingProtocol::GetStats"))
            , m_DeleteGatheringProfilingUnit(NEX_T("MatchMakingProtocol::DeleteGathering"))
            , m_GetPendingDeletionsProfilingUnit(NEX_T("MatchMakingProtocol::GetPendingDeletions"))
            , m_DeleteFromDeletionsProfilingUnit(NEX_T("MatchMakingProtocol::DeleteFromDeletions"))
            , m_MigrateGatheringOwnershipV1ProfilingUnit(NEX_T("MatchMakingProtocol::MigrateGatheringOwnershipV1"))
            , m_FindByDescriptionLikeProfilingUnit(NEX_T("MatchMakingProtocol::FindByDescriptionLike"))
            , m_RegisterLocalURLProfilingUnit(NEX_T("MatchMakingProtocol::RegisterLocalURL"))
            , m_RegisterLocalURLsProfilingUnit(NEX_T("MatchMakingProtocol::RegisterLocalURLs"))
            , m_UpdateSessionHostV1ProfilingUnit(NEX_T("MatchMakingProtocol::UpdateSessionHostV1"))
            , m_GetSessionURLsProfilingUnit(NEX_T("MatchMakingProtocol::GetSessionURLs"))
            , m_UpdateSessionHostProfilingUnit(NEX_T("MatchMakingProtocol::UpdateSessionHost"))
            , m_UpdateGatheringOwnershipProfilingUnit(NEX_T("MatchMakingProtocol::UpdateGatheringOwnership"))
            , m_MigrateGatheringOwnershipProfilingUnit(NEX_T("MatchMakingProtocol::MigrateGatheringOwnership"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(uint32) TRegisterGathering_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TRegisterGathering_anyGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, RegisterGathering)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TRegisterGathering_anyGathering, anyGathering);
            DDLTYPE(uint32)::CPPType __result=pProtocol->RegisterGathering( anyGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,RegisterGathering);
            _MSG_ADD_VARIABLE(TRegisterGathering_result,__result);
        }
        
        typedef DDLTYPE(bool) TUnregisterGathering_result;
        typedef DDLTYPE(uint32) TUnregisterGathering_idGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UnregisterGathering)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TUnregisterGathering_idGathering, idGathering);
            DDLTYPE(bool)::CPPType __result=pProtocol->UnregisterGathering( idGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UnregisterGathering);
            _MSG_ADD_VARIABLE(TUnregisterGathering_result,__result);
        }
        
        typedef DDLTYPE(bool) TUnregisterGatherings_result;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TUnregisterGatherings_lstGatherings;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UnregisterGatherings)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstGatherings;
            _MSG_EXTRACT_VARIABLE(TUnregisterGatherings_lstGatherings, lstGatherings);
            DDLTYPE(bool)::CPPType __result=pProtocol->UnregisterGatherings( lstGatherings );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UnregisterGatherings);
            _MSG_ADD_VARIABLE(TUnregisterGatherings_result,__result);
        }
        
        typedef DDLTYPE(bool) TUpdateGathering_result;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TUpdateGathering_anyGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UpdateGathering)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType anyGathering;
            _MSG_EXTRACT_VARIABLE(TUpdateGathering_anyGathering, anyGathering);
            DDLTYPE(bool)::CPPType __result=pProtocol->UpdateGathering( anyGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UpdateGathering);
            _MSG_ADD_VARIABLE(TUpdateGathering_result,__result);
        }
        
        typedef DDLTYPE(bool) TInvite_result;
        typedef DDLTYPE(uint32) TInvite_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TInvite_lstPrincipals;
        typedef DDLTYPE(string) TInvite_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, Invite)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TInvite_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstPrincipals;
            _MSG_EXTRACT_VARIABLE(TInvite_lstPrincipals, lstPrincipals);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TInvite_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->Invite( idGathering, lstPrincipals, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,Invite);
            _MSG_ADD_VARIABLE(TInvite_result,__result);
        }
        
        typedef DDLTYPE(bool) TAcceptInvitation_result;
        typedef DDLTYPE(uint32) TAcceptInvitation_idGathering;
        typedef DDLTYPE(string) TAcceptInvitation_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, AcceptInvitation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TAcceptInvitation_idGathering, idGathering);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TAcceptInvitation_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->AcceptInvitation( idGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,AcceptInvitation);
            _MSG_ADD_VARIABLE(TAcceptInvitation_result,__result);
        }
        
        typedef DDLTYPE(bool) TDeclineInvitation_result;
        typedef DDLTYPE(uint32) TDeclineInvitation_idGathering;
        typedef DDLTYPE(string) TDeclineInvitation_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, DeclineInvitation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TDeclineInvitation_idGathering, idGathering);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TDeclineInvitation_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->DeclineInvitation( idGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,DeclineInvitation);
            _MSG_ADD_VARIABLE(TDeclineInvitation_result,__result);
        }
        
        typedef DDLTYPE(bool) TCancelInvitation_result;
        typedef DDLTYPE(uint32) TCancelInvitation_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TCancelInvitation_lstPrincipals;
        typedef DDLTYPE(string) TCancelInvitation_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, CancelInvitation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TCancelInvitation_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstPrincipals;
            _MSG_EXTRACT_VARIABLE(TCancelInvitation_lstPrincipals, lstPrincipals);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TCancelInvitation_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->CancelInvitation( idGathering, lstPrincipals, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,CancelInvitation);
            _MSG_ADD_VARIABLE(TCancelInvitation_result,__result);
        }
        
        typedef DDLTYPE(uint32) TGetInvitationsSent_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(Invitation) > TGetInvitationsSent_lstInvitations;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetInvitationsSent)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetInvitationsSent_idGathering, idGathering);
            DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType lstInvitations;
            pProtocol->GetInvitationsSent( idGathering, &lstInvitations );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetInvitationsSent);
            _MSG_ADD_VARIABLE(TGetInvitationsSent_lstInvitations, lstInvitations);
        }
        
        typedef DDLTYPE(std_list)< CLASSMETATYPE(Invitation) > TGetInvitationsReceived_lstInvitations;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetInvitationsReceived)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType lstInvitations;
            pProtocol->GetInvitationsReceived( &lstInvitations );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetInvitationsReceived);
            _MSG_ADD_VARIABLE(TGetInvitationsReceived_lstInvitations, lstInvitations);
        }
        
        typedef DDLTYPE(bool) TParticipate_result;
        typedef DDLTYPE(uint32) TParticipate_idGathering;
        typedef DDLTYPE(string) TParticipate_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, Participate)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TParticipate_idGathering, idGathering);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TParticipate_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->Participate( idGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,Participate);
            _MSG_ADD_VARIABLE(TParticipate_result,__result);
        }
        
        typedef DDLTYPE(bool) TCancelParticipation_result;
        typedef DDLTYPE(uint32) TCancelParticipation_idGathering;
        typedef DDLTYPE(string) TCancelParticipation_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, CancelParticipation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TCancelParticipation_idGathering, idGathering);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TCancelParticipation_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->CancelParticipation( idGathering, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,CancelParticipation);
            _MSG_ADD_VARIABLE(TCancelParticipation_result,__result);
        }
        
        typedef DDLTYPE(uint32) TGetParticipants_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetParticipants_lstParticipants;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetParticipants_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstParticipants;
            pProtocol->GetParticipants( idGathering, &lstParticipants );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetParticipants);
            _MSG_ADD_VARIABLE(TGetParticipants_lstParticipants, lstParticipants);
        }
        
        typedef DDLTYPE(bool) TAddParticipants_result;
        typedef DDLTYPE(uint32) TAddParticipants_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TAddParticipants_lstParticipants;
        typedef DDLTYPE(string) TAddParticipants_strMessage;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, AddParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TAddParticipants_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstParticipants;
            _MSG_EXTRACT_VARIABLE(TAddParticipants_lstParticipants, lstParticipants);
            DDLTYPE(string)::CPPType strMessage;
            _MSG_EXTRACT_VARIABLE(TAddParticipants_strMessage, strMessage);
            DDLTYPE(bool)::CPPType __result=pProtocol->AddParticipants( idGathering, lstParticipants, strMessage );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,AddParticipants);
            _MSG_ADD_VARIABLE(TAddParticipants_result,__result);
        }
        
        typedef DDLTYPE(uint32) TGetDetailedParticipants_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) > TGetDetailedParticipants_lstParticipants;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetDetailedParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetDetailedParticipants_idGathering, idGathering);
            DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType lstParticipants;
            pProtocol->GetDetailedParticipants( idGathering, &lstParticipants );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetDetailedParticipants);
            _MSG_ADD_VARIABLE(TGetDetailedParticipants_lstParticipants, lstParticipants);
        }
        
        typedef DDLTYPE(uint32) TGetParticipantsURLs_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TGetParticipantsURLs_lstStationURL;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetParticipantsURLs)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetParticipantsURLs_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType lstStationURL;
            pProtocol->GetParticipantsURLs( idGathering, &lstStationURL );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetParticipantsURLs);
            _MSG_ADD_VARIABLE(TGetParticipantsURLs_lstStationURL, lstStationURL);
        }
        
        typedef DDLTYPE(string) TFindByType_strType;
        typedef CLASSMETATYPE(ResultRange) TFindByType_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByType_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByType)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strType;
            _MSG_EXTRACT_VARIABLE(TFindByType_strType, strType);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByType_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByType( strType, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByType);
            _MSG_ADD_VARIABLE(TFindByType_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(string) TFindByDescription_strDescription;
        typedef CLASSMETATYPE(ResultRange) TFindByDescription_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByDescription_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByDescription)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strDescription;
            _MSG_EXTRACT_VARIABLE(TFindByDescription_strDescription, strDescription);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByDescription_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByDescription( strDescription, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByDescription);
            _MSG_ADD_VARIABLE(TFindByDescription_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(string) TFindByDescriptionRegex_strDescriptionRegex;
        typedef CLASSMETATYPE(ResultRange) TFindByDescriptionRegex_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByDescriptionRegex_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByDescriptionRegex)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strDescriptionRegex;
            _MSG_EXTRACT_VARIABLE(TFindByDescriptionRegex_strDescriptionRegex, strDescriptionRegex);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByDescriptionRegex_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByDescriptionRegex( strDescriptionRegex, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByDescriptionRegex);
            _MSG_ADD_VARIABLE(TFindByDescriptionRegex_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TFindByID_lstID;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByID_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByID)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstID;
            _MSG_EXTRACT_VARIABLE(TFindByID_lstID, lstID);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByID( lstID, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByID);
            _MSG_ADD_VARIABLE(TFindByID_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(uint32) TFindBySingleID_id;
        typedef DDLTYPE(bool) TFindBySingleID_bResult;
        typedef DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > TFindBySingleID_pGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindBySingleID)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TFindBySingleID_id, id);
            DDLTYPE(bool)::CPPType bResult;
            DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType pGathering;
            pProtocol->FindBySingleID( id, &bResult, &pGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindBySingleID);
            _MSG_ADD_VARIABLE(TFindBySingleID_bResult, bResult);
            _MSG_ADD_VARIABLE(TFindBySingleID_pGathering, pGathering);
        }
        
        typedef DDLTYPE(uint32) TFindByOwner_id;
        typedef CLASSMETATYPE(ResultRange) TFindByOwner_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByOwner_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByOwner)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType id;
            _MSG_EXTRACT_VARIABLE(TFindByOwner_id, id);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByOwner_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByOwner( id, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByOwner);
            _MSG_ADD_VARIABLE(TFindByOwner_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TFindByParticipants_pid;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByParticipants_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByParticipants)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType pid;
            _MSG_EXTRACT_VARIABLE(TFindByParticipants_pid, pid);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByParticipants( pid, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByParticipants);
            _MSG_ADD_VARIABLE(TFindByParticipants_lstGathering, lstGathering);
        }
        
        typedef CLASSMETATYPE(ResultRange) TFindInvitations_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindInvitations_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindInvitations)
        {
            PROTO_PREPARE_EXTRACTION();
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindInvitations_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindInvitations( resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindInvitations);
            _MSG_ADD_VARIABLE(TFindInvitations_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(string) TFindBySQLQuery_strQuery;
        typedef CLASSMETATYPE(ResultRange) TFindBySQLQuery_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindBySQLQuery_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindBySQLQuery)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strQuery;
            _MSG_EXTRACT_VARIABLE(TFindBySQLQuery_strQuery, strQuery);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindBySQLQuery_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindBySQLQuery( strQuery, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindBySQLQuery);
            _MSG_ADD_VARIABLE(TFindBySQLQuery_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(bool) TLaunchSession_result;
        typedef DDLTYPE(uint32) TLaunchSession_idGathering;
        typedef DDLTYPE(string) TLaunchSession_strURL;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, LaunchSession)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TLaunchSession_idGathering, idGathering);
            DDLTYPE(string)::CPPType strURL;
            _MSG_EXTRACT_VARIABLE(TLaunchSession_strURL, strURL);
            DDLTYPE(bool)::CPPType __result=pProtocol->LaunchSession( idGathering, strURL );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,LaunchSession);
            _MSG_ADD_VARIABLE(TLaunchSession_result,__result);
        }
        
        typedef DDLTYPE(bool) TUpdateSessionURL_result;
        typedef DDLTYPE(uint32) TUpdateSessionURL_idGathering;
        typedef DDLTYPE(string) TUpdateSessionURL_strURL;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UpdateSessionURL)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TUpdateSessionURL_idGathering, idGathering);
            DDLTYPE(string)::CPPType strURL;
            _MSG_EXTRACT_VARIABLE(TUpdateSessionURL_strURL, strURL);
            DDLTYPE(bool)::CPPType __result=pProtocol->UpdateSessionURL( idGathering, strURL );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UpdateSessionURL);
            _MSG_ADD_VARIABLE(TUpdateSessionURL_result,__result);
        }
        
        typedef DDLTYPE(bool) TGetSessionURL_result;
        typedef DDLTYPE(uint32) TGetSessionURL_idGathering;
        typedef DDLTYPE(string) TGetSessionURL_strURL;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetSessionURL)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetSessionURL_idGathering, idGathering);
            DDLTYPE(string)::CPPType strURL;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetSessionURL( idGathering, &strURL );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetSessionURL);
            _MSG_ADD_VARIABLE(TGetSessionURL_result,__result);
            _MSG_ADD_VARIABLE(TGetSessionURL_strURL, strURL);
        }
        
        typedef DDLTYPE(bool) TGetState_result;
        typedef DDLTYPE(uint32) TGetState_idGathering;
        typedef DDLTYPE(uint32) TGetState_uiState;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetState)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetState_idGathering, idGathering);
            DDLTYPE(uint32)::CPPType uiState;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetState( idGathering, &uiState );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetState);
            _MSG_ADD_VARIABLE(TGetState_result,__result);
            _MSG_ADD_VARIABLE(TGetState_uiState, uiState);
        }
        
        typedef DDLTYPE(bool) TSetState_result;
        typedef DDLTYPE(uint32) TSetState_idGathering;
        typedef DDLTYPE(uint32) TSetState_uiNewState;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, SetState)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TSetState_idGathering, idGathering);
            DDLTYPE(uint32)::CPPType uiNewState;
            _MSG_EXTRACT_VARIABLE(TSetState_uiNewState, uiNewState);
            DDLTYPE(bool)::CPPType __result=pProtocol->SetState( idGathering, uiNewState );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,SetState);
            _MSG_ADD_VARIABLE(TSetState_result,__result);
        }
        
        typedef DDLTYPE(bool) TReportStats_result;
        typedef DDLTYPE(uint32) TReportStats_idGathering;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) > TReportStats_lstStats;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, ReportStats)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TReportStats_idGathering, idGathering);
            DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType lstStats;
            _MSG_EXTRACT_VARIABLE(TReportStats_lstStats, lstStats);
            DDLTYPE(bool)::CPPType __result=pProtocol->ReportStats( idGathering, lstStats );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,ReportStats);
            _MSG_ADD_VARIABLE(TReportStats_result,__result);
        }
        
        typedef DDLTYPE(bool) TGetStats_result;
        typedef DDLTYPE(uint32) TGetStats_idGathering;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TGetStats_lstParticipants;
        typedef DDLTYPE(std_list)< DDLTYPE(byte) > TGetStats_lstColumns;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) > TGetStats_plstStats;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetStats)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType idGathering;
            _MSG_EXTRACT_VARIABLE(TGetStats_idGathering, idGathering);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstParticipants;
            _MSG_EXTRACT_VARIABLE(TGetStats_lstParticipants, lstParticipants);
            DDLTYPE(std_list)< DDLTYPE(byte) >::CPPType lstColumns;
            _MSG_EXTRACT_VARIABLE(TGetStats_lstColumns, lstColumns);
            DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType plstStats;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetStats( idGathering, lstParticipants, lstColumns, &plstStats );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetStats);
            _MSG_ADD_VARIABLE(TGetStats_result,__result);
            _MSG_ADD_VARIABLE(TGetStats_plstStats, plstStats);
        }
        
        typedef DDLTYPE(bool) TDeleteGathering_result;
        typedef DDLTYPE(uint32) TDeleteGathering_gid;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, DeleteGathering)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TDeleteGathering_gid, gid);
            DDLTYPE(bool)::CPPType __result=pProtocol->DeleteGathering( gid );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,DeleteGathering);
            _MSG_ADD_VARIABLE(TDeleteGathering_result,__result);
        }
        
        typedef DDLTYPE(bool) TGetPendingDeletions_result;
        typedef DDLTYPE(uint32) TGetPendingDeletions_uiReason;
        typedef CLASSMETATYPE(ResultRange) TGetPendingDeletions_resultRange;
        typedef DDLTYPE(std_list)< CLASSMETATYPE(DeletionEntry) > TGetPendingDeletions_lstDeletions;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetPendingDeletions)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType uiReason;
            _MSG_EXTRACT_VARIABLE(TGetPendingDeletions_uiReason, uiReason);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TGetPendingDeletions_resultRange, resultRange);
            DDLTYPE(std_list)< CLASSMETATYPE(DeletionEntry) >::CPPType lstDeletions;
            DDLTYPE(bool)::CPPType __result=pProtocol->GetPendingDeletions( uiReason, resultRange, &lstDeletions );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetPendingDeletions);
            _MSG_ADD_VARIABLE(TGetPendingDeletions_result,__result);
            _MSG_ADD_VARIABLE(TGetPendingDeletions_lstDeletions, lstDeletions);
        }
        
        typedef DDLTYPE(bool) TDeleteFromDeletions_result;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TDeleteFromDeletions_lstDeletions;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, DeleteFromDeletions)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstDeletions;
            _MSG_EXTRACT_VARIABLE(TDeleteFromDeletions_lstDeletions, lstDeletions);
            DDLTYPE(bool)::CPPType __result=pProtocol->DeleteFromDeletions( lstDeletions );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,DeleteFromDeletions);
            _MSG_ADD_VARIABLE(TDeleteFromDeletions_result,__result);
        }
        
        typedef DDLTYPE(bool) TMigrateGatheringOwnershipV1_result;
        typedef DDLTYPE(uint32) TMigrateGatheringOwnershipV1_gid;
        typedef DDLTYPE(std_list)< DDLTYPE(uint32) > TMigrateGatheringOwnershipV1_lstPotentialNewOwnersID;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, MigrateGatheringOwnershipV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TMigrateGatheringOwnershipV1_gid, gid);
            DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType lstPotentialNewOwnersID;
            _MSG_EXTRACT_VARIABLE(TMigrateGatheringOwnershipV1_lstPotentialNewOwnersID, lstPotentialNewOwnersID);
            DDLTYPE(bool)::CPPType __result=pProtocol->MigrateGatheringOwnershipV1( gid, lstPotentialNewOwnersID );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,MigrateGatheringOwnershipV1);
            _MSG_ADD_VARIABLE(TMigrateGatheringOwnershipV1_result,__result);
        }
        
        typedef DDLTYPE(string) TFindByDescriptionLike_strDescriptionLike;
        typedef CLASSMETATYPE(ResultRange) TFindByDescriptionLike_resultRange;
        typedef DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > > TFindByDescriptionLike_lstGathering;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, FindByDescriptionLike)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType strDescriptionLike;
            _MSG_EXTRACT_VARIABLE(TFindByDescriptionLike_strDescriptionLike, strDescriptionLike);
            ResultRange resultRange;
            _MSG_EXTRACT_VARIABLE(TFindByDescriptionLike_resultRange, resultRange);
            DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType lstGathering;
            pProtocol->FindByDescriptionLike( strDescriptionLike, resultRange, &lstGathering );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,FindByDescriptionLike);
            _MSG_ADD_VARIABLE(TFindByDescriptionLike_lstGathering, lstGathering);
        }
        
        typedef DDLTYPE(uint32) TRegisterLocalURL_gid;
        typedef DDLTYPE(string) TRegisterLocalURL_url;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, RegisterLocalURL)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TRegisterLocalURL_gid, gid);
            DDLTYPE(string)::CPPType url;
            _MSG_EXTRACT_VARIABLE(TRegisterLocalURL_url, url);
            pProtocol->RegisterLocalURL( gid, url );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,RegisterLocalURL);
        }
        
        typedef DDLTYPE(uint32) TRegisterLocalURLs_gid;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TRegisterLocalURLs_lstUrls;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, RegisterLocalURLs)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TRegisterLocalURLs_gid, gid);
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType lstUrls;
            _MSG_EXTRACT_VARIABLE(TRegisterLocalURLs_lstUrls, lstUrls);
            pProtocol->RegisterLocalURLs( gid, lstUrls );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,RegisterLocalURLs);
        }
        
        typedef DDLTYPE(uint32) TUpdateSessionHostV1_gid;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UpdateSessionHostV1)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TUpdateSessionHostV1_gid, gid);
            pProtocol->UpdateSessionHostV1( gid );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UpdateSessionHostV1);
        }
        
        typedef DDLTYPE(uint32) TGetSessionURLs_gid;
        typedef DDLTYPE(std_list)< DDLTYPE(stationurl) > TGetSessionURLs_lstURLs;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, GetSessionURLs)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TGetSessionURLs_gid, gid);
            DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType lstURLs;
            pProtocol->GetSessionURLs( gid, &lstURLs );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,GetSessionURLs);
            _MSG_ADD_VARIABLE(TGetSessionURLs_lstURLs, lstURLs);
        }
        
        typedef DDLTYPE(uint32) TUpdateSessionHost_gid;
        typedef DDLTYPE(bool) TUpdateSessionHost_isMigrateOwner;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UpdateSessionHost)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TUpdateSessionHost_gid, gid);
            DDLTYPE(bool)::CPPType isMigrateOwner;
            _MSG_EXTRACT_VARIABLE(TUpdateSessionHost_isMigrateOwner, isMigrateOwner);
            pProtocol->UpdateSessionHost( gid, isMigrateOwner );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UpdateSessionHost);
        }
        
        typedef DDLTYPE(uint32) TUpdateGatheringOwnership_gid;
        typedef DDLTYPE(bool) TUpdateGatheringOwnership_participantsOnly;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, UpdateGatheringOwnership)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TUpdateGatheringOwnership_gid, gid);
            DDLTYPE(bool)::CPPType participantsOnly;
            _MSG_EXTRACT_VARIABLE(TUpdateGatheringOwnership_participantsOnly, participantsOnly);
            pProtocol->UpdateGatheringOwnership( gid, participantsOnly );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,UpdateGatheringOwnership);
        }
        
        typedef DDLTYPE(uint32) TMigrateGatheringOwnership_gid;
        typedef DDLTYPE(qlist)< DDLTYPE(uint32) > TMigrateGatheringOwnership_lstPotentialNewOwnersID;
        typedef DDLTYPE(bool) TMigrateGatheringOwnership_participantsOnly;
        PROTO_RMCIMPL_STUB(MatchMakingProtocol, MigrateGatheringOwnership)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType gid;
            _MSG_EXTRACT_VARIABLE(TMigrateGatheringOwnership_gid, gid);
            DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType lstPotentialNewOwnersID;
            _MSG_EXTRACT_VARIABLE(TMigrateGatheringOwnership_lstPotentialNewOwnersID, lstPotentialNewOwnersID);
            DDLTYPE(bool)::CPPType participantsOnly;
            _MSG_EXTRACT_VARIABLE(TMigrateGatheringOwnership_participantsOnly, participantsOnly);
            pProtocol->MigrateGatheringOwnership( gid, lstPotentialNewOwnersID, participantsOnly );
            PROTO_PREPARE_RETURN(MatchMakingProtocol,MigrateGatheringOwnership);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(uint32)::CPPType RegisterGathering(const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering) = 0;
        virtual DDLTYPE(bool)::CPPType UnregisterGathering(const DDLTYPE(uint32)::CPPType& idGathering) = 0;
        virtual DDLTYPE(bool)::CPPType UnregisterGatherings(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstGatherings) = 0;
        virtual DDLTYPE(bool)::CPPType UpdateGathering(const DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType& anyGathering) = 0;
        virtual DDLTYPE(bool)::CPPType Invite(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual DDLTYPE(bool)::CPPType AcceptInvitation(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual DDLTYPE(bool)::CPPType DeclineInvitation(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual DDLTYPE(bool)::CPPType CancelInvitation(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPrincipals, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void GetInvitationsSent(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType* lstInvitations) = 0;
        virtual void GetInvitationsReceived(DDLTYPE(std_list)< CLASSMETATYPE(Invitation) >::CPPType* lstInvitations) = 0;
        virtual DDLTYPE(bool)::CPPType Participate(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual DDLTYPE(bool)::CPPType CancelParticipation(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void GetParticipants(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType* lstParticipants) = 0;
        virtual DDLTYPE(bool)::CPPType AddParticipants(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstParticipants, const DDLTYPE(string)::CPPType& strMessage) = 0;
        virtual void GetDetailedParticipants(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< CLASSMETATYPE(ParticipantDetails) >::CPPType* lstParticipants) = 0;
        virtual void GetParticipantsURLs(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* lstStationURL) = 0;
        virtual void FindByType(const DDLTYPE(string)::CPPType& strType, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindByDescription(const DDLTYPE(string)::CPPType& strDescription, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindByDescriptionRegex(const DDLTYPE(string)::CPPType& strDescriptionRegex, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindByID(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstID, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindBySingleID(const DDLTYPE(uint32)::CPPType& id, DDLTYPE(bool)::CPPType* bResult, DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType* pGathering) = 0;
        virtual void FindByOwner(const DDLTYPE(uint32)::CPPType& id, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindByParticipants(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& pid, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindInvitations(const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void FindBySQLQuery(const DDLTYPE(string)::CPPType& strQuery, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual DDLTYPE(bool)::CPPType LaunchSession(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strURL) = 0;
        virtual DDLTYPE(bool)::CPPType UpdateSessionURL(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(string)::CPPType& strURL) = 0;
        virtual DDLTYPE(bool)::CPPType GetSessionURL(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(string)::CPPType* strURL) = 0;
        virtual DDLTYPE(bool)::CPPType GetState(const DDLTYPE(uint32)::CPPType& idGathering, DDLTYPE(uint32)::CPPType* uiState) = 0;
        virtual DDLTYPE(bool)::CPPType SetState(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(uint32)::CPPType& uiNewState) = 0;
        virtual DDLTYPE(bool)::CPPType ReportStats(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType& lstStats) = 0;
        virtual DDLTYPE(bool)::CPPType GetStats(const DDLTYPE(uint32)::CPPType& idGathering, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstParticipants, const DDLTYPE(std_list)< DDLTYPE(byte) >::CPPType& lstColumns, DDLTYPE(std_list)< CLASSMETATYPE(GatheringStats) >::CPPType* plstStats) = 0;
        virtual DDLTYPE(bool)::CPPType DeleteGathering(const DDLTYPE(uint32)::CPPType& gid) = 0;
        virtual DDLTYPE(bool)::CPPType GetPendingDeletions(const DDLTYPE(uint32)::CPPType& uiReason, const ResultRange& resultRange, DDLTYPE(std_list)< CLASSMETATYPE(DeletionEntry) >::CPPType* lstDeletions) = 0;
        virtual DDLTYPE(bool)::CPPType DeleteFromDeletions(const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstDeletions) = 0;
        virtual DDLTYPE(bool)::CPPType MigrateGatheringOwnershipV1(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(std_list)< DDLTYPE(uint32) >::CPPType& lstPotentialNewOwnersID) = 0;
        virtual void FindByDescriptionLike(const DDLTYPE(string)::CPPType& strDescriptionLike, const ResultRange& resultRange, DDLTYPE(std_list)< DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) > >::CPPType* lstGathering) = 0;
        virtual void RegisterLocalURL(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(string)::CPPType& url) = 0;
        virtual void RegisterLocalURLs(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType& lstUrls) = 0;
        virtual void UpdateSessionHostV1(const DDLTYPE(uint32)::CPPType& gid) = 0;
        virtual void GetSessionURLs(const DDLTYPE(uint32)::CPPType& gid, DDLTYPE(std_list)< DDLTYPE(stationurl) >::CPPType* lstURLs) = 0;
        virtual void UpdateSessionHost(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(bool)::CPPType& isMigrateOwner) = 0;
        virtual void UpdateGatheringOwnership(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(bool)::CPPType& participantsOnly) = 0;
        virtual void MigrateGatheringOwnership(const DDLTYPE(uint32)::CPPType& gid, const DDLTYPE(qlist)< DDLTYPE(uint32) >::CPPType& lstPotentialNewOwnersID, const DDLTYPE(bool)::CPPType& participantsOnly) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_RegisterGatheringProfilingUnit;
        ProfilingUnit m_UnregisterGatheringProfilingUnit;
        ProfilingUnit m_UnregisterGatheringsProfilingUnit;
        ProfilingUnit m_UpdateGatheringProfilingUnit;
        ProfilingUnit m_InviteProfilingUnit;
        ProfilingUnit m_AcceptInvitationProfilingUnit;
        ProfilingUnit m_DeclineInvitationProfilingUnit;
        ProfilingUnit m_CancelInvitationProfilingUnit;
        ProfilingUnit m_GetInvitationsSentProfilingUnit;
        ProfilingUnit m_GetInvitationsReceivedProfilingUnit;
        ProfilingUnit m_ParticipateProfilingUnit;
        ProfilingUnit m_CancelParticipationProfilingUnit;
        ProfilingUnit m_GetParticipantsProfilingUnit;
        ProfilingUnit m_AddParticipantsProfilingUnit;
        ProfilingUnit m_GetDetailedParticipantsProfilingUnit;
        ProfilingUnit m_GetParticipantsURLsProfilingUnit;
        ProfilingUnit m_FindByTypeProfilingUnit;
        ProfilingUnit m_FindByDescriptionProfilingUnit;
        ProfilingUnit m_FindByDescriptionRegexProfilingUnit;
        ProfilingUnit m_FindByIDProfilingUnit;
        ProfilingUnit m_FindBySingleIDProfilingUnit;
        ProfilingUnit m_FindByOwnerProfilingUnit;
        ProfilingUnit m_FindByParticipantsProfilingUnit;
        ProfilingUnit m_FindInvitationsProfilingUnit;
        ProfilingUnit m_FindBySQLQueryProfilingUnit;
        ProfilingUnit m_LaunchSessionProfilingUnit;
        ProfilingUnit m_UpdateSessionURLProfilingUnit;
        ProfilingUnit m_GetSessionURLProfilingUnit;
        ProfilingUnit m_GetStateProfilingUnit;
        ProfilingUnit m_SetStateProfilingUnit;
        ProfilingUnit m_ReportStatsProfilingUnit;
        ProfilingUnit m_GetStatsProfilingUnit;
        ProfilingUnit m_DeleteGatheringProfilingUnit;
        ProfilingUnit m_GetPendingDeletionsProfilingUnit;
        ProfilingUnit m_DeleteFromDeletionsProfilingUnit;
        ProfilingUnit m_MigrateGatheringOwnershipV1ProfilingUnit;
        ProfilingUnit m_FindByDescriptionLikeProfilingUnit;
        ProfilingUnit m_RegisterLocalURLProfilingUnit;
        ProfilingUnit m_RegisterLocalURLsProfilingUnit;
        ProfilingUnit m_UpdateSessionHostV1ProfilingUnit;
        ProfilingUnit m_GetSessionURLsProfilingUnit;
        ProfilingUnit m_UpdateSessionHostProfilingUnit;
        ProfilingUnit m_UpdateGatheringOwnershipProfilingUnit;
        ProfilingUnit m_MigrateGatheringOwnershipProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
