﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#define _PR_gathering_methods_pudecl()          \
    virtual Gathering* Clone() const;       \
    virtual String GetGatheringType() const;                    \
    virtual qBool IsA(const String& strClass) const;                    \
    virtual qBool IsAKindOf(const String& strClass) const;                  \
    virtual void StreamIn(Message* pMessageToSend) const;       \
    virtual void StreamOut(Message* pReceivedMessage);

#define _PR_gathering_methods_prdecl()

#define _PR_gathering_methods_impl(CLASS)   \
    Gathering* DDLCLASS(CLASS)::Clone() const {return qNew CLASS;}      \
    String DDLCLASS(CLASS)::GetGatheringType() const {return NEX_T(#CLASS);}           \
    qBool DDLCLASS(CLASS)::IsA(const String& strClass) const {return strClass==NEX_T(#CLASS);} \
    qBool DDLCLASS(CLASS)::IsAKindOf(const String& strClass) const {return strClass==NEX_T(#CLASS);}   \
    void DDLCLASS(CLASS)::StreamIn(Message* pMessageToSend) const {CLASS::Add(pMessageToSend, *this);} \
    void DDLCLASS(CLASS)::StreamOut(Message* pReceivedMessage) {CLASS::Extract(pReceivedMessage, this);}

#define _PR_gathering_methods_derived_impl(CLASS,PARENT)    \
    Gathering* DDLCLASS(CLASS)::Clone() const {return qNew CLASS;}      \
    String DDLCLASS(CLASS)::GetGatheringType() const {return NEX_T(#CLASS);}           \
    qBool DDLCLASS(CLASS)::IsA(const String& strClass) const {return strClass==NEX_T(#CLASS);} \
    qBool DDLCLASS(CLASS)::IsAKindOf(const String& strClass) const {return strClass==NEX_T(#CLASS) || DDLCLASS(PARENT)::IsAKindOf(strClass);}  \
    void DDLCLASS(CLASS)::StreamIn(Message* pMessageToSend) const {CLASS::Add(pMessageToSend, *this);} \
    void DDLCLASS(CLASS)::StreamOut(Message* pReceivedMessage) {CLASS::Extract(pReceivedMessage, this);}


