﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Transport/Interface/ConnectivityTester.h>

BEGIN_NAMESPACE_NEX

/*
    <wiki/NAT Traversal#RVConnectivityTester>
    RVConnectivityTester is used internally by Transport's NATTraversalEngine to gather
    the probe responses from other peers through RendezVous server, once NATTraversalClient is bound.

    An RVConnectivityTester gets created and associated to the ConnectivityManager once
    NATTraversalClient::Bind is invoked.

*/
class RVConnectivityTester: public ConnectivityTester
{
public:
    RVConnectivityTester();
    virtual ~RVConnectivityTester();

    virtual qBool ProbeStations(CallContext *pContext, StationProbeList* preflstStationProbe, qUnsignedInt32 tiTimeout = 5000, qBool bWaitForAllResult = false, Job::JobType jobTypeToUse = Job::RV);
};


END_NAMESPACE_NEX

