﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2017, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2017 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#pragma once

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Transport/Interface/HighLevelStream.h>

BEGIN_NAMESPACE_NEX

class Buffer;
class StationURL;
class PacketOut;

class NATEchoStream: public HighLevelStream
{
public:
    NATEchoStream(RootTransport *pTransport);
    virtual     ~NATEchoStream();

    virtual void DoWork(const Time*);

    static void PrepareMessage(Buffer *pPayloadBuffer, Buffer *pMessage);
    virtual void ReceiveIncomingMsg(const InetAddress &oSourceAddress, Stream::Type oType, Stream::ID idStream, Buffer *pBuffer, Time ioTime, qUnsignedInt16 ui16Port);

};

END_NAMESPACE_NEX

