#pragma once
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( push )
#pragma warning( disable : 4458 )
#endif // defined(_MSC_VER)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(NATTraversalReportInternalProtocol, ReportNATTraversalResult, 1 );
PROTO_DEFINE_RMCID(NATTraversalReportInternalProtocol, ReportNATProperties, 2 );
PROTO_DEFINE_RMCID(NATTraversalReportInternalProtocol, ReportNATTraversalResultDetail, 3 );
PROTO_DEFINE_NUM_RMC(NATTraversalReportInternalProtocol, 3);

class NATTraversalReportInternalProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(uint32) TReportNATTraversalResult_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResult_result;
        typedef DDLTYPE(uint32) TReportNATTraversalResult_rtt;
        PROTO_RMCIMPL_RETURN(NATTraversalReportInternalProtocol, ReportNATTraversalResult)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TReportNATProperties_natmapping;
        typedef DDLTYPE(uint32) TReportNATProperties_natfiltering;
        typedef DDLTYPE(uint32) TReportNATProperties_rtt;
        PROTO_RMCIMPL_RETURN(NATTraversalReportInternalProtocol, ReportNATProperties)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResultDetail_result;
        typedef DDLTYPE(int32) TReportNATTraversalResultDetail_detail;
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_rtt;
        PROTO_RMCIMPL_RETURN(NATTraversalReportInternalProtocol, ReportNATTraversalResultDetail)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        NATTraversalReportInternalProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew NATTraversalReportInternalProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallReportNATTraversalResult(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(uint32)::CPPType& rtt);
        static qBool ReportNATTraversalResult_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(uint32)::CPPType& rtt);
        qBool CallReportNATProperties(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& natmapping, const DDLTYPE(uint32)::CPPType& natfiltering, const DDLTYPE(uint32)::CPPType& rtt);
        static qBool ReportNATProperties_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& natmapping, const DDLTYPE(uint32)::CPPType& natfiltering, const DDLTYPE(uint32)::CPPType& rtt);
        qBool CallReportNATTraversalResultDetail(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(int32)::CPPType& detail, const DDLTYPE(uint32)::CPPType& rtt);
        static qBool ReportNATTraversalResultDetail_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(int32)::CPPType& detail, const DDLTYPE(uint32)::CPPType& rtt);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(NATTraversalReportInternalProtocol) + 1];
};

class DDLPROTOCOL(NATTraversalReportInternalProtocolServer) : public ServerProtocol {
    public:
        DDLPROTOCOL(NATTraversalReportInternalProtocolServer)()
            : ServerProtocol()
#if defined(LIVE_VERSION)
            , m_ReportNATTraversalResultProfilingUnit(NEX_T("NATTraversalReportInternalProtocol::ReportNATTraversalResult"))
            , m_ReportNATPropertiesProfilingUnit(NEX_T("NATTraversalReportInternalProtocol::ReportNATProperties"))
            , m_ReportNATTraversalResultDetailProfilingUnit(NEX_T("NATTraversalReportInternalProtocol::ReportNATTraversalResultDetail"))
#endif // LIVE_VERSION
            {}
        
        typedef DDLTYPE(uint32) TReportNATTraversalResult_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResult_result;
        typedef DDLTYPE(uint32) TReportNATTraversalResult_rtt;
        PROTO_RMCIMPL_STUB(NATTraversalReportInternalProtocol, ReportNATTraversalResult)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType cid;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResult_cid, cid);
            DDLTYPE(bool)::CPPType result;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResult_result, result);
            DDLTYPE(uint32)::CPPType rtt;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResult_rtt, rtt);
            pProtocol->ReportNATTraversalResult( cid, result, rtt );
            PROTO_PREPARE_RETURN(NATTraversalReportInternalProtocol,ReportNATTraversalResult);
        }
        
        typedef DDLTYPE(uint32) TReportNATProperties_natmapping;
        typedef DDLTYPE(uint32) TReportNATProperties_natfiltering;
        typedef DDLTYPE(uint32) TReportNATProperties_rtt;
        PROTO_RMCIMPL_STUB(NATTraversalReportInternalProtocol, ReportNATProperties)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType natmapping;
            _MSG_EXTRACT_VARIABLE(TReportNATProperties_natmapping, natmapping);
            DDLTYPE(uint32)::CPPType natfiltering;
            _MSG_EXTRACT_VARIABLE(TReportNATProperties_natfiltering, natfiltering);
            DDLTYPE(uint32)::CPPType rtt;
            _MSG_EXTRACT_VARIABLE(TReportNATProperties_rtt, rtt);
            pProtocol->ReportNATProperties( natmapping, natfiltering, rtt );
            PROTO_PREPARE_RETURN(NATTraversalReportInternalProtocol,ReportNATProperties);
        }
        
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResultDetail_result;
        typedef DDLTYPE(int32) TReportNATTraversalResultDetail_detail;
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_rtt;
        PROTO_RMCIMPL_STUB(NATTraversalReportInternalProtocol, ReportNATTraversalResultDetail)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType cid;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_cid, cid);
            DDLTYPE(bool)::CPPType result;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_result, result);
            DDLTYPE(int32)::CPPType detail;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_detail, detail);
            DDLTYPE(uint32)::CPPType rtt;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_rtt, rtt);
            pProtocol->ReportNATTraversalResultDetail( cid, result, detail, rtt );
            PROTO_PREPARE_RETURN(NATTraversalReportInternalProtocol,ReportNATTraversalResultDetail);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void ReportNATTraversalResult(const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(uint32)::CPPType& rtt) = 0;
        virtual void ReportNATProperties(const DDLTYPE(uint32)::CPPType& natmapping, const DDLTYPE(uint32)::CPPType& natfiltering, const DDLTYPE(uint32)::CPPType& rtt) = 0;
        virtual void ReportNATTraversalResultDetail(const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(int32)::CPPType& detail, const DDLTYPE(uint32)::CPPType& rtt) = 0;
    
#if defined(LIVE_VERSION)
    private:
        ProfilingUnit m_ReportNATTraversalResultProfilingUnit;
        ProfilingUnit m_ReportNATPropertiesProfilingUnit;
        ProfilingUnit m_ReportNATTraversalResultDetailProfilingUnit;
#endif // LIVE_VERSION
    
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#if defined(_MSC_VER)
#pragma warning( pop )
#endif // defined(_MSC_VER)
